VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form OMRAPI_Sample 
   BorderStyle     =   3  
   Caption         =   "OMRAPI_Sample"
   ClientHeight    =   9645
   ClientLeft      =   2580
   ClientTop       =   1980
   ClientWidth     =   14820
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   9645
   ScaleMode       =   0  
   ScaleWidth      =   26334.82
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton Command_QUIT 
      Caption         =   "Quit"
      Height          =   375
      Left            =   13680
      TabIndex        =   5
      Top             =   8520
      Width           =   975
   End
   Begin VB.CheckBox Check_PRINT 
      Caption         =   "Print"
      Height          =   255
      Left            =   13080
      TabIndex        =   1
      Top             =   4920
      Width           =   1095
   End
   Begin VB.CheckBox Check_READ_BARCODE 
      Caption         =   "Read Barcode"
      Height          =   255
      Left            =   13080
      TabIndex        =   3
      Top             =   4605
      Width           =   1575
   End
   Begin VB.CommandButton Command_MARK_ONLY 
      Caption         =   "     Mark Only         (+ Option)  "
      Height          =   550
      Left            =   13080
      TabIndex        =   2
      Top             =   3960
      Width           =   1575
   End
   Begin RichTextLib.RichTextBox RICH_TEXT_BOX 
      Height          =   9615
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   12855
      _ExtentX        =   22675
      _ExtentY        =   16960
      _Version        =   393217
      Enabled         =   -1  'True
      ReadOnly        =   -1  'True
      ScrollBars      =   3
      RightMargin     =   35000
      TextRTF         =   $"OMRAP_Sample.frx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Frame Read 
      Caption         =   "Read"
      Height          =   1695
      Left            =   12960
      TabIndex        =   4
      Top             =   3600
      Width           =   1815
   End
End
Attribute VB_Name = "OMRAPI_Sample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'=========================================================
'   Sample Program Start
'=========================================================

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const EM_REPLACESEL = &HC2

'//
'// Main [Mark Only(+ Option)]
'//
'//////////////////////////////////////////////////////////////////////////////
Public Sub Command_MARK_ONLY_Click()
    Dim lngStatus                           As OMR_STATUS   '// Return value
    Dim lngDeviceInfo                           As Long     '// Parameter to store the Device information
    Dim lngDevice                               As Long     '// Parameter to store the information OMR Device is open

    Dim nColumns                                As Long     '// Setting value of reading row
    Dim nControlType                            As Long     '// Setting value of reading row
    Dim nMultipleValue                          As Long     '// Setting value of Magnification while set "Control" on the reading method
    Dim nDirective                              As Long     '// Setting value of backside reading
    Dim nThickness                              As Long     '// Setting value of paper thickness
    Dim dwConfigData                            As Long     '// Setting value of warning Error
    Dim nSkewCol                                As Long     '// Setting value of mark skew detection
    Dim nSkewLevel                              As Long     '// Setting value of mark skew detection level
    Dim nPanelEnable                            As Long     '// Setting value of the panel operation
    Dim nVolume                                 As Long     '// Setting value of the buzzer loudness
    Dim nTone                                   As Long     '// Setting value of the buzzer tone
    Dim pID(20)                                 As Byte     '// Setting value of the Device ID
    Dim bytMarks(SR_COL_MAX * SR_ROW_MAX)       As Byte     '// Buffer to store Mark data

    Dim lngResponse                             As Long     '// Return value OMRAPI function
    Dim blnBarcodeCheck                         As Boolean  '// Flag barcode operation
    Dim bytBcType(SR_BARCODE_NUMBER_MAX)        As Byte     '// Pointer to store the Barcode type(1byte)
    Dim bytBcData(64, 256)                      As Byte     '// Pointer to store the Barcode Data
    Dim lngBcDataLen(SR_BARCODE_NUMBER_MAX)     As Long     '// Pointer to store the bytes of barcode data
    Dim lngReadCount                            As Long     '// Pointer to store the number of Barcode set the reading area
    Dim lngSettingCount                         As Long     '// Pointer to store the barcode data
    Dim BarcodeArea(10)                 As OMR_BARCODE_AREA '// Structure condition of Area of Barcode
    Dim intBarcodeIndex                         As Integer  '// Parameter to output Barcode Data
    
    Dim blnPrintCheck                           As Boolean  '// Flag Printer Operation

    Dim strFolderPath                           As String   '// Fullpath executed file
    Dim strTime                                 As String   '// Current time
    Dim strTextBuffer                           As String   '// TXT buffer
    
    Dim MarkInfo                        As OMR_MARK_INFO    '// Structure store Mark Information
    
    '//--------------------------------------------------------
    '//  Get User setting
    '//--------------------------------------------------------

    '// If checked "Print",
    blnPrintCheck = IIf(vbChecked = Me.Check_PRINT.Value, True, False)

    '// If checked "Read Barcode",
    blnBarcodeCheck = IIf(vbChecked = Me.Check_READ_BARCODE.Value, True, False)

    '//--------------------------------------------------------
    '//  Initialization
    '//--------------------------------------------------------

    '// Open Device
    lngStatus = OMR_OpenDeviceUSB()
    If (SR_SUCCESS = lngStatus) Then
        lngDevice = 1
    Else
        Call ErrorMessage("OMR_OpenDeviceUSB", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Initialize Device
    '// Hold OMR setting into library
    lngResponse = OMR_InitialSetting()
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_InitialSetting", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Get the information of OMR unit
    lngDeviceInfo = OMR_GetDeviceInfo()
    If (SR_FUNCTION_FAIL = lngDeviceInfo) Then
        Call ErrorMessage("OMR_GetDeviceInfo", CLng(OMR_GetLastError()))
        GoTo Termination
    End If
    
    '//--------------------------------------------------------
    '//  Set mark reading
    '//--------------------------------------------------------

    '// Get the setting of reading row
    '// (Windows API manual 6.4.2.)
    nColumns = OMR_GetNumberOfColumnsToRead()
    If (0 = nColumns) Then
        Call ErrorMessage("OMR_GetNumberOfColumnsToRead", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Get the setting of Reading method
    '// (Windows API manual 6.4.4.)
    lngResponse = OMR_GetReadingMethod(nControlType, nMultipleValue)
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_GetReadingMethod", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Get the setting of paper thickness
    '// (Windows API manual 6.4.8.)
    nThickness = OMR_GetSheetThickness()
    If (SR_FUNCTION_FAIL = nThickness) Then
        Call ErrorMessage("OMR_GetSheetThickness", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Get the setting of warning Error
    '// (Windows API manual 6.4.10.)
    lngResponse = OMR_GetWarningError(dwConfigData, nSkewCol, nSkewLevel)
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_GetWarningError", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Get the setting of Panel operation
    '// (Windows API manual 6.4.12.)
    nPanelEnable = OMR_GetPanelConfig()
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_GetPanelConfig", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Get the buzzer operation
    '// (Windows API manual 6.4.14.)
    lngResponse = OMR_GetBuzzerConfig(nVolume, nTone)
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_GetBuzzerConfig", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Get the Device ID
    '// (Windows API manual 6.4.16.)
    lngResponse = OMR_GetID(pID())
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_GetID", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Set the reading row
    '// (Windows API manual 6.4.1.)
    lngResponse = OMR_SetNumberOfColumnsToRead(nColumns)
        If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_SetNumberOfColumnsToRead", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Set the reading method
    '// (Windows API manual 6.4.3.)
    lngResponse = OMR_SetReadingMethod(nControlType, nMultipleValue)
        If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_SetReadingMethod", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Set the backside reading
    '// (Windows API manual 6.4.5.)
    nDirective = SR_ENABLE
    lngResponse = OMR_SetBackSensorUnit(nDirective)
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_SetBackSensorUnit", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Set the paper thickness
    '// (Windows API manual 6.4.7.)
    lngResponse = OMR_SetSheetThickness(nThickness)
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_SetSheetThickness", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Set the condition of Warning Error
    '// (Windows API manual 6.4.9.)
    nSkewCol = 1
    nSkewLevel = 1
    lngResponse = OMR_SetWarningError(dwConfigData, nSkewCol, nSkewLevel)
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_SetWarningError", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Set panel operation
    '// (Windows API manual 6.4.11.)
    lngResponse = OMR_SetPanelConfig(nPanelEnable)
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_SetPanelConfig", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Set buzzer operation
    '// (Windows API manual 6.4.13.)
    lngResponse = OMR_SetBuzzerConfig(nVolume, nTone)
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_SetBuzzerConfig", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '// Set the Device ID
    '// (Windows API manual 6.4.15.)
    lngResponse = OMR_SetID(pID())
    If (1 <> lngResponse) Then
        Call ErrorMessage("OMR_SetID", CLng(OMR_GetLastError()))
        GoTo Termination
    End If

    '//--------------------------------------------------------
    '//  Barcode setting
    '//--------------------------------------------------------

    ''// If check [Read Barcode], then execute barcode unit
    If (True = blnBarcodeCheck) Then

        '// Barcode unit would activate in case Barcode unit connected
            If ((SR_DEVICE_UNIT_BARCODE_V <> (lngDeviceInfo And SR_DEVICE_UNIT_BARCODE_MASK)) And _
                (SR_DEVICE_UNIT_BARCODE_H <> (lngDeviceInfo And SR_DEVICE_UNIT_BARCODE_MASK))) Then
            MsgBox "Barcode unit unconnected", vbInformation, "OMRAPI_Sample"
            GoTo Termination
        End If

        '// Barcode operation setting
        '// (Windows API manual 6.8.3.)
        lngResponse = OMR_SetBarcodeReaderUnit(SR_ENABLE)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetBarcodeReaderUnit", CLng(OMR_GetLastError()))
            GoTo Termination
        End If
        
        '// Barcode area setting
        '// (Windows API manual 6.8.5.)
        lngResponse = OMR_SetBarCodeArea(BarcodeArea(0))
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetBarCodeArea", CLng(OMR_GetLastError()))
            GoTo Termination
        End If

        '// Barcode Reading type Setting
        '// (Windows API manual 6.8.7.)
        lngResponse = OMR_SetBarCodeReadType(SR_BARCODE_READ_CODE39 Or SR_BARCODE_READ_ITF Or SR_BARCODE_READ_NW7 Or SR_BARCODE_READ_JAN_EAN_UPC)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetBarCodeReadType", CLng(OMR_GetLastError()))
            GoTo Termination
        End If

        '// Barcode CheckDigit Setting
        '// (Windows API manual 6.8.9.)
        lngResponse = OMR_SetBarCodeCheckDigit(SR_BARCODE_TYPE_CODE39, SR_BARCODE_CD.SR_BARCODE_CD_DISABLE)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetBarCodeCheckDigit", CLng(OMR_GetLastError()))
            GoTo Termination
        End If

        '// Barcode Setting
        '// (Windows API manual 6.8.11.)
        lngResponse = OMR_SetBarCodeOption(SR_BARCODE_TYPE_JAN_EAN_UPC, SR_BARCODE_OPT_UPC_13DIGIT Or SR_BARCODE_OPT_UPC_ADD_CODE)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetBarCodeOption", CLng(OMR_GetLastError()))
            GoTo Termination
        End If
    End If

    '//--------------------------------------------------------
    '//  Printer Setting
    '//--------------------------------------------------------

    '//[CAUTION]
    '//DipSW "SW3-3" is ON while use Printer function SR-1800PR.
    '//(See the user manual)
    '//(Factory default of "SW3-3" is "ON" by SR-1800PR)

    '// If check [Print], then execute Printer unit
    If (True = blnPrintCheck) Then
        '// Printer would active in case connect printer unit or Select stacker
            If ((SR_DEVICE_UNIT_PRINTER <> (lngDeviceInfo And SR_DEVICE_UNIT_PRINTER_MASK)) And _
                (SR_DEVICE_UNIT_STACKER <> (lngDeviceInfo And SR_DEVICE_UNIT_STACKER_MASK))) Then
            MsgBox "Printer unit unconnected", vbInformation, "OMRAPI_Sample"
            GoTo Termination
        End If

        '// Setting Printer Operation
        '// (Windows API manual 6.7.1.)
        lngResponse = OMR_SetPrinterUnit(SR_ENABLE)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrinterUnit", CLng(OMR_GetLastError()))
            GoTo Termination
        End If
        
        '// Setting Print Mode
        '// (Windows API manual 6.7.5.)
        lngResponse = OMR_SetPrintMode(SR_PRINT_MODE_FEED_AND_PRINT)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrintMode", CLng(OMR_GetLastError()))
            GoTo Termination
        End If

        '// Setting Print Position
        '// (Windows API manual 6.7.7.)
        lngResponse = OMR_SetPrintPosition(0)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrintPosition", CLng(OMR_GetLastError()))
            GoTo Termination
        End If

        '// Setting Print Direction
        '// (Windows API manual 6.7.9.)
        lngResponse = OMR_SetPrintAngle(SR_PRINT_ANGLE_0)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrintAngle", CLng(OMR_GetLastError()))
            GoTo Termination
        End If

        '// Setting Print Size
        '// (Windows API manual 6.7.11.)
        lngResponse = OMR_SetPrintFontSize(32)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrintFontSize", CLng(OMR_GetLastError()))
            GoTo Termination
        End If

        '// Setting Print Pitch
        '// (Windows API manual 6.7.13.)
        lngResponse = OMR_SetPrintFontPitch(8)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrintFontPitch", CLng(OMR_GetLastError()))
            GoTo Termination
        End If
        
        '// Setting Printer
        '// (Windows API manual 6.7.15.)
        lngResponse = OMR_SetPrintString(1, "SEKONIC ")
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrintString", CLng(OMR_GetLastError()))
            GoTo Termination
        End If
        
        lngResponse = OMR_SetPrintString(2, "PRINT ")
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrintString", CLng(OMR_GetLastError()))
            GoTo Termination
        End If
        
        lngResponse = OMR_SetPrintString(3, "SAMPLE ")
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrintString", CLng(OMR_GetLastError()))
            GoTo Termination
        End If
        
        '// Setting print order
        '// (Windows API manual 6.7.3.)
        lngResponse = OMR_SetPrintOrder(SR_PRINT.SR_PRINT_BUFFER_1, SR_PRINT.SR_PRINT_BUFFER_2, SR_PRINT.SR_PRINT_BUFFER_3)
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_SetPrintOrder", CLng(OMR_GetLastError()))
            GoTo Termination
        End If
            
    End If

    '// Preprocessing roop
    RICH_TEXT_BOX.Text = ""               '// Clear RichTextBox

    '// Continue rooping till hopper empty or error happen
    Do While True

        strTextBuffer = ""                      '// Clear TXT buffer

        Call GetFilePath(strFolderPath, strTime)     '// Get fullpath of file and time

        strTextBuffer = strTextBuffer & "[Data_" & strTime & ".csv]" & vbCrLf '// Store the output data

        '//--------------------------------------------------------
        '//  Reading
        '//--------------------------------------------------------

        '// Mark reading
        lngResponse = OMR_FeedSheet()
        If (SR_SUCCESS <> CLng(OMR_GetLastError()) And (SR_ERROR_STATUS_Q1 = CLng(OMR_GetLastError()))) Then
            MsgBox "Hopper Empty", vbInformation, "OMRAPI_Sample"
            Exit Do
        ElseIf (SR_SUCCESS <> CLng(OMR_GetLastError())) Then
            Call ErrorMessage("OMR_FeedSheet", CLng(OMR_GetLastError()))
            Exit Do
        End If

        '//--------------------------------------------------------
        '//  Output mark data
        '//--------------------------------------------------------

        MarkInfo.lngColumns = SR_COL_MAX          '// Initialize MarkInfo
        MarkInfo.lngrows = SR_ROW_MAX             '// Initialize MarkInfo

        '// Output mark data(front)
        strTextBuffer = strTextBuffer & "[Front MarkData]" & vbCrLf

        lngStatus = OMR_GetMarks(SR_PAGE_FRONT, MarkInfo, bytMarks(0))
        If (1 <> lngResponse) Then
            Call ErrorMessage("OMR_GetMarks", lngStatus)
            Exit Do
        End If

        strTextBuffer = strTextBuffer & OutputMarkData(MarkInfo, bytMarks)       '// Store mark data to buffer

        '// If "Installed backside read unit" or "valid back side reading",
        '// Output mark data(back)
        If ((SR_DEVICE_UNIT_BACK = (lngDeviceInfo And SR_DEVICE_UNIT_BACK_MASK)) And (SR_ENABLE = nDirective)) Then
            strTextBuffer = strTextBuffer & "[Back MarkData]" & vbCrLf
            lngStatus = OMR_GetMarks(SR_PAGE_BACK, MarkInfo, bytMarks(0))
            If (1 <> lngResponse) Then
                Call ErrorMessage("OMR_GetMarks", lngStatus)
                GoTo Termination
            End If
            strTextBuffer = strTextBuffer & OutputMarkData(MarkInfo, bytMarks)   '// Store mark data to buffer
        End If

        '//--------------------------------------------------------
        '//  Output Barcode data
        '//--------------------------------------------------------

        If (True = blnBarcodeCheck) Then
            '// Get the number of barcode
            lngResponse = OMR_GetBarcodeInfo(lngReadCount, lngSettingCount)
            If (1 <> lngResponse) Then
                Call ErrorMessage("OMR_GetBarcodeInfo", CLng(OMR_GetLastError()))
                Exit Do
            End If

            strTextBuffer = strTextBuffer & "[BarcodeData],ReadingCount," & Format(lngReadCount, "00") & vbCrLf   '// Output the number of barcode read

            If (0 = lngReadCount) Then    '// Not output Barcode data in case no read the barcode
                GoTo BreakOutputBarcodeData
            End If

            '// Output Barcode Data
            For intBarcodeIndex = 0 To lngReadCount - 1
                lngBcDataLen(intBarcodeIndex) = 256       '// Set the number of bytes of Barcode data
                lngResponse = OMR_GetBarcodeData((intBarcodeIndex + 1), bytBcType(intBarcodeIndex), lngBcDataLen(intBarcodeIndex), bytBcData(0, intBarcodeIndex))
                If (1 <> lngResponse) Then
                    Call ErrorMessage("OMR_GetBarcodeData", CLng(OMR_GetLastError()))
                    GoTo Termination
                End If
            Next intBarcodeIndex

            strTextBuffer = strTextBuffer & OutputBarcodeData(lngReadCount, bytBcData(), bytBcType, lngBcDataLen) & vbCrLf  '// Store barcode data to buffer
        End If

BreakOutputBarcodeData:
        '//--------------------------------------------------------
        '//  Printer Operation
        '//--------------------------------------------------------

        If (True = blnPrintCheck) Then
        
            '// Setting Printer
            '// (Windows API manual 6.7.15.)
            lngResponse = OMR_SetPrintString(1, "SEKONIC ")
            If (1 <> lngResponse) Then
                Call ErrorMessage("OMR_SetPrintString", CLng(OMR_GetLastError()))
                Exit Do
            End If

            lngResponse = OMR_SetPrintString(2, "PRINT ")
            If (1 <> lngResponse) Then
                Call ErrorMessage("OMR_SetPrintString", CLng(OMR_GetLastError()))
                Exit Do
            End If

            lngResponse = OMR_SetPrintString(3, "SAMPLE ")
            If (1 <> lngResponse) Then
                Call ErrorMessage("OMR_SetPrintString", CLng(OMR_GetLastError()))
                Exit Do
            End If

            '// Setting print order
            '// (Windows API manual 6.7.3.)
            lngResponse = OMR_SetPrintOrder(SR_PRINT.SR_PRINT_BUFFER_1, SR_PRINT.SR_PRINT_BUFFER_2, SR_PRINT.SR_PRINT_BUFFER_3)
            If (1 <> lngResponse) Then
                Call ErrorMessage("OMR_SetPrintOrder", CLng(OMR_GetLastError()))
                Exit Do
            End If
        End If

        '// Add on the TXT buffer to RichTextBox
        Call SendMessage(RICH_TEXT_BOX.hwnd, EM_REPLACESEL, 0, ByVal strTextBuffer)
        
        '// Save TXT buffer to file
        '// Comment-out the following process if OMR operation is slow.
        Call SaveTextBuffer(strTextBuffer, strTime, strFolderPath)

        RICH_TEXT_BOX.Refresh      '// Upadate RichTextBox
    Loop

    '//--------------------------------------------------------
    '//  Finish
    '//--------------------------------------------------------

Termination:
    '// Close the device if open
    If (1 = lngDevice) Then
        lngStatus = OMR_CloseDevice()
        If (SR_SUCCESS <> lngStatus) Then
            Call ErrorMessage("OMR_CloseDevice", CLng(OMR_GetLastError()))
        End If
    End If
    
End Sub

Private Sub Command_QUIT_Click()
    Dim objRet                              '// Return message box
    
    objRet = MsgBox("Finish Sample program?", vbYesNo Or vbInformation, "OMRAPI_Sample")
    If (vbYes = objRet) Then
        End                                 '// Finish Sample program
    End If
End Sub

'// String(format) display Error information
Public Sub ErrorMessage(ByRef sFuncName As String, ByVal lngStatus As Long)
    Dim strError As String

    strError = sFuncName & " Error " & "(0x" & Format(Hex(lngStatus), "00000000") & ")"
    MsgBox strError, vbExclamation, "OMRAPI_Sample"
End Sub

'// Strings(Function) to output mark data
Friend Function OutputMarkData(ByRef MarkInfo As OMR_MARK_INFO, ByRef pbytMarks() As Byte) As String

    Dim lngMarkLevel      As Long     '// Parameter to store the mark level
    Dim strMarkData       As String   '// mark data
    Dim lngColPosition    As Long     '// Parameter for the roop (The number of row)
    Dim lngRowPosition    As Long     '// Parameter for the roop (The number of column)
    
    '// Strings(function) of output mark data
    If ((Empty <> pbytMarks(0) And 4 < MarkInfo.lngColumns)) Then
        '// Output the header of columns
        strMarkData = ("   ,")
        For lngColPosition = 0 To MarkInfo.lngColumns - 1
            strMarkData = strMarkData & Format(lngColPosition + 1, "00") & ","
        Next lngColPosition

        strMarkData = strMarkData & vbCrLf

        '// Output Mark data and header of the number of Row
        For lngRowPosition = 0 To MarkInfo.lngrows - 1
            strMarkData = strMarkData & Format((lngRowPosition + 1), "000") & ","
            For lngColPosition = 0 To MarkInfo.lngColumns - 1
                lngMarkLevel = pbytMarks((lngRowPosition * MarkInfo.lngColumns) + lngColPosition)
                strMarkData = strMarkData & Format(lngMarkLevel, "00") & ","
            Next lngColPosition
            strMarkData = strMarkData & vbCrLf
        Next lngRowPosition
    End If
    
    strMarkData = strMarkData & vbCrLf
    
    OutputMarkData = strMarkData
    
End Function

'// Strings(function) to make and output barcode
Function OutputBarcodeData(ByRef lngReadCount As Long, ByRef bytBcData() As Byte, ByRef bytBcType() As Byte, ByRef bytBcDataLen() As Long) As String

    Dim strBcBuffer     As String               '// Buffer for imput data
    Dim strBcTypeString As String               '// The string of Barcode type
    Dim strBcData       As String               '// TXT strings to store Barcode Data
    Dim intOutputIndex  As Integer              '// Parameter to output Barcode Data
    Dim intBacodeLength As Integer              '// Parameter Barcode Data
    
    '// Output the barcode data read(MAX :10 barcodes)
    For intOutputIndex = 0 To (lngReadCount - 1)
        strBcData = ""                          '// Initialize strBcData
        
        Select Case Chr(bytBcType(intOutputIndex))

            Case "a"
                strBcTypeString = "CODE-39        "

            Case "b"
                strBcTypeString = "ITF            "

            Case "c"
                strBcTypeString = "NW-7           "

            Case "d"
                strBcTypeString = "JAN/EAN/UPC    "

            Case "e"
                strBcTypeString = "CODE-128       "

            Case "f"
                strBcTypeString = "INDUSTRIAL 2OF5"

            Case "g"
                strBcTypeString = "COOP 2OF5      "

            Case "h"
                strBcTypeString = "CODE-93        "

            Case "@"
            Case Else
                strBcTypeString = "UNKNOWN        "

        End Select

        '// Conversion Barcode data(Byte array) to String array
        For intBacodeLength = 0 To bytBcDataLen(intOutputIndex) - 1
            strBcData = strBcData & Chr(bytBcData(intBacodeLength, intOutputIndex))
        Next intBacodeLength

        strBcBuffer = strBcBuffer & Format(intOutputIndex + 1, "00") & "," & strBcTypeString & ":" & strBcData & vbCrLf
    Next intOutputIndex
    
    OutputBarcodeData = strBcBuffer
    
End Function

'// Strings(function) to get file path and current time
Public Sub GetFilePath(ByRef pstrFolderPath As String, ByRef pstrTime As String)
    pstrTime = Format(CStr(DateTime.Now), "yyyymmddhhmmss")                 '// Output current time to dtTime with designated strings
    pstrFolderPath = App.Path                                               '// Get the folder path of Executed file
End Sub

'// Output txt buffer by CSV file
'// Need cszTime and szFullPath while set the filename
Public Sub SaveTextBuffer(ByVal strTextBuffer As String, ByRef strTime As String, ByRef strFolderPath As String)

    Dim intFileNo       As Integer                  '// a number of file
    Dim strDataFileName As String                   '// File name

    strDataFileName = strFolderPath + "\Data_" + strTime + ".csv"   '// Set the file name

    intFileNo = FreeFile                            '// Get a number of file
    Open strDataFileName For Append As #intFileNo   '// Open file as append mode
    Print #intFileNo, strTextBuffer                 '// Save to file
    Close #intFileNo                                '// Close file

End Sub

'//=========================================================
'// Sample Program End
'//=========================================================
