Option Explicit On
Imports System.Runtime.InteropServices
Imports System.Text.Encoding

Public Class Sk_Dv_Sample

    '=========================================================
    '	Sample Program Start
    '=========================================================

    '//
    '// Main [Mark Only(+ Option)]
    '//
    '//////////////////////////////////////////////////////////////////////////////
    Private Sub B_MARK_ONLY_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_MARK_ONLY.Click
        Dim hSkDevice As UInteger                           '// Handle device
        Dim dwStatus As UInteger                            '// Return Value

        Dim szMarks(SKDV_COL_MAX * SKDV_ROW_MAX) As Byte    '// Buffer to store Mark data
        Dim nBufSize As Integer                             '// The size to store the Mark data

        Dim bResponse As Integer                            '// Return value OMRAPI function
        Dim bBarcodeCheck As Boolean                        '// Flag barcode operation
        Dim sBcType(SR_BARCODE_NUMBER_MAX) As Byte          '// Pointer to store the Barcode type(1byte)
        Dim sBcData(64, 256) As Byte                        '// Pointer to store the Barcode Data
        Dim nBcDataLen(SR_BARCODE_NUMBER_MAX) As Integer    '// Pointer to store the bytes of barcode data
        Dim nReadCount As Integer = 0                       '// Pointer to store the number of Barcode set the reading area
        Dim nSettingCount As Integer = 0                    '// Pointer to store the barcode data
        Dim BarcodeArea(10) As OMR_BARCODE_AREA             '// Structure condition of Area of Barcode

        Dim bPrintCheck As Boolean                          '// Flag Printer Operation

        Dim strFolderPath As String = Nothing               '// Fullpath executed file
        Dim strTime As String = Nothing                     '// Current time
        Dim strTextBuffer As String                         '// TXT buffer

        Dim DeviceInfo As New SK_DV_SR3500_INFO             '// Structure device Information
        Dim DeviceMode As New SK_DV_SR3500_MODE             '// Structure device Mode
        Dim MarkConf As New SK_DV_SR3500MARK_CONF           '// Structure condition of Mark reading
        Dim MarkInfo As New SK_DV_MARK_INFO                 '// Structure store Mark Information
        '//--------------------------------------------------------
        '//  Get User setting
        '//--------------------------------------------------------

        '// If checked "Print", 
        bPrintCheck = IIf(True = Me.CHECK_PRINT.Checked, True, False)

        '// If checked "Read Barcode",
        bBarcodeCheck = IIf(True = Me.CHECK_BARCODE.Checked, True, False)

        '//--------------------------------------------------------
        '//  Initialization
        '//--------------------------------------------------------

        '// Open Device
        dwStatus = SkDv_OpenWithOmrapi(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_OpenWithOmrapi", dwStatus)
            GoTo Termination
        End If

        '// Initialize Device
        '// Hold OMR setting into library
        dwStatus = SkDv_ReqInit(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_ReqInit", dwStatus)
            GoTo Termination
        End If

        '// Get the information of OMR unit
        dwStatus = SkDv_GetInfo(hSkDevice, DeviceInfo)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetInfo", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Set mark reading
        '//--------------------------------------------------------

        '// Get Operation mode
        dwStatus = SkDv_GetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetMode", dwStatus)
            GoTo Termination
        End If

        ''//[NOTICE]
        ''//        Set the condition of Operation mode
        ''//        Cancel the comment and change the contents if want change the setting.
        ''//
        ''//        (Windows API manual 5.3.4.)
        ''//
        ''//        Save the setting in the OMR unit to change the strings belowH

        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_AUTO_REJECT  '// Auto reject when Error(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_HOPPER_EMPTY '// Hopper Empty error detection(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_TM_ERROR     '// Timing Mark error detection(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_DF_ERROR     '// Double Feed error detection(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_LEFT_SKEW    '// Left End Skew error detection (Valid to flag ON)
        'DeviceMode.MarkSkew.iRow = SKDV_MARKSKEW_ROW_MIN                                    '// Mark Skew detection(Valid/Invalid)
        'DeviceMode.MarkSkew.iLevel = SKDV_MARKSKEW_LEVEL_MIN                                '// Mark Skew detection level(1-16)
        'DeviceMode.iPanelOperation = SKDV_ENABLE                                            '// Panel Operation(Valid/Invalid)
        'DeviceMode.Buzzer.iVol = SKDV_BUZZER_MIN                                            '// Buzzer volume(0/1-5))
        'DeviceMode.Buzzer.iTone = SKDV_BUZZER_TONE_A                                        '// Buzzer tone (1/2/3)
        'DeviceMode.PSaving.iSleep = SKDV_SLEEPTIME_MIN                                      '// Sleep timer(0/1-60)
        'DeviceMode.PSaving.iStandby = SKDV_STANDBYTIME_MIN                                  '// Standby timer(0/1-60)


        '// Set Operation mode
        dwStatus = SkDv_SetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_SetMode", dwStatus)
            GoTo Termination
        End If

        '// Get the condition of Mark reading
        dwStatus = SkDv_GetMarkConf(hSkDevice, MarkConf)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetMarkConf", dwStatus)
            GoTo Termination
        End If

        ''//[NOTICE]
        ''//        Set the condition of mark reading
        ''//        Cancel the comment and change the contents if want change the setting.
        ''//
        ''//
        ''//        (Windows API manual 5.3.5.)
        ''//
        ''//        Save the setting in the OMR unit to change the strings below
        ''//
        '//    Check the followings on the process of setting
        '//    MarkConf.lngBackSideReading   : Backside reading(On/Off)
        '//    MarkConf.lngColumns           : The number of columns to be read
        '//    MarkConf.lngReadingMethod     : Reading method
        '//    MarkConf.lngCtrlMultiple      : (If iReading Method is "Control") Front or Back
        '//    MarkConf.lngThicknessType     : Paper thickness to be read

        MarkConf.iBackSideReading = SKDV_ENABLE                     '// Backside reading(Valid/Invalid)
        'MarkConf.iColumns = SKDV_COL_MAX                            '// The number of columns to be read(1-48)
        'MarkConf.iReadingMethod = SKDV_READ_DIRECT                  '// Reading method(Control(Front)/Control(back)/Direct/FACOM/Mark to Mark(Front edge or Front No edge)
        'MarkConf.iCtrlMultiple = SKDV_READ_EDGE_CTRL_MIN1           '// (If iReading Method is "Control" only ) Front or Back space (1-9times)
        'MarkConf.iThicknessType = SKDV_THICKNESS_90_KG              '// Paper thickness to be read(Automatic/55/72/90/110/135)


        '// Set the condition of Mark reading
        dwStatus = SkDv_SetMarkConf(hSkDevice, MarkConf)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_SetMarkConf", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Barcode setting
        '//--------------------------------------------------------

        ''// If check [Read Barcode], then execute barcode unit
        If (True = bBarcodeCheck) Then
            '// Barcode unit would activate in case Barcode unit connected
            If (0 = (SKDV_OPT_UNIT_BCR And (DeviceInfo.Main.dwOption))) Then
                MessageBox.Show("Barcode unit unconnected", "Sk_Dv_Sample", MessageBoxButtons.OK, MessageBoxIcon.Information)
                GoTo Termination
            End If

            '// Barcode operation setting
            '// (Windows API manual 6.8.3.)
            bResponse = OMR_SetBarcodeReaderUnit(SR_ENABLE)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetBarcodeReaderUnit", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If

            '// Barcode area setting
            '// (Windows API manual 6.8.5.)
            bResponse = OMR_SetBarCodeArea(BarcodeArea(0))
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetBarCodeArea", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If

            '// Barcode Reading type Setting
            '// (Windows API manual 6.8.7.)
            bResponse = OMR_SetBarCodeReadType(SR_BARCODE_READ_CODE39 Or SR_BARCODE_READ_ITF Or SR_BARCODE_READ_NW7 Or SR_BARCODE_READ_JAN_EAN_UPC)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetBarCodeReadType", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If

            '// Barcode CheckDigit Setting
            '// (Windows API manual 6.8.9.)
            bResponse = OMR_SetBarCodeCheckDigit(SR_BARCODE_TYPE_CODE39, SR_BARCODE_CD.SR_BARCODE_CD_DISABLE)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetBarCodeCheckDigit", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If

            '// Barcode Setting
            '// (Windows API manual 6.8.11.)
            bResponse = OMR_SetBarCodeOption(SR_BARCODE_TYPE_JAN_EAN_UPC, SR_BARCODE_OPT_UPC_13DIGIT Or SR_BARCODE_OPT_UPC_ADD_CODE)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetBarCodeOption", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If
        End If

        '//--------------------------------------------------------
        '//  Printer Setting
        '//--------------------------------------------------------

        '//[CAUTION]
        '//DipSW "SW3-3" is ON while use Printer function SR-1800PR.
        '//(See the user manual)
        '//(Factory default of "SW3-3" is "ON" by SR-1800PR)

        '// If check [Print], then execute Printer unit
        If (True = bPrintCheck) Then
            '// Printer would active in case connect printer unit or Select stacker
            If ((0 = (SKDV_OPT_UNIT_PRINTER And DeviceInfo.Main.dwOption)) And (0 = (SKDV_OPT_UNIT_STACKER And DeviceInfo.Main.dwOption))) Then
                MessageBox.Show("Printer unit unconnected", "Sk_Dv_Sample", MessageBoxButtons.OK, MessageBoxIcon.Information)
                GoTo Termination
            End If

            '// Setting Printer Operation
            '// (Windows API manual 6.7.5.)
            bResponse = OMR_SetPrinterUnit(SR_ENABLE)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetPrinterUnit", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If

            '// Setting Print Mode
            '// (Windows API manual 6.7.5.)
            bResponse = OMR_SetPrintMode(SR_PRINT_MODE_AFTER_FEED)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetPrintMode", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If

            '// Setting Print Position
            '// (Windows API manual 6.7.7.)
            bResponse = OMR_SetPrintPosition(0)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetPrintPosition", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If

            '// Setting Print Direction
            '// (Windows API manual 6.7.9.)
            bResponse = OMR_SetPrintAngle(SR_PRINT_ANGLE_0)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetPrintAngle", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If

            '// Setting Print Size
            '// (Windows API manual 6.7.11.)
            bResponse = OMR_SetPrintFontSize(32)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetPrintFontSize", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If

            '// Setting Print Pitch
            '// (Windows API manual 6.7.13.)
            bResponse = OMR_SetPrintFontPitch(8)
            If (1 <> bResponse) Then
                ErrorMessage("OMR_SetPrintFontPitch", CUInt(OMR_GetLastError()))
                GoTo Termination
            End If
        End If

        '// Preprocessing roop
        Me.RICH_TEXT_BOX.Text = ""                  '// Clear RichTextBox

        '// Continue rooping till hopper empty or error happen
        Do While True

            strTextBuffer = ""                      '// Clear TXT buffer

            GetFilePath(strFolderPath, strTime)     '// Get fullpath of file and time 

            strTextBuffer += String.Format("[Data_{0}.csv]", strTime) + vbCrLf  '// Store the output data

            '//--------------------------------------------------------
            '//  Reading
            '//--------------------------------------------------------

            '// Mark reading
            dwStatus = SkDv_ReqFeedMarkSheet(hSkDevice)
            If (SKDV_STS_DEVICE_ST_Q1 = (dwStatus And SKDV_STS_DEVICE_STA_MASK)) Then
                MessageBox.Show("Hopper Empty", "Sk_Dv_Sample", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Do
            ElseIf (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                Exit Do
            End If

            '//--------------------------------------------------------
            '//  Output mark data
            '//--------------------------------------------------------

            '// Output mark data(front)
            strTextBuffer += "[Front MarkData]" + vbCrLf

            nBufSize = szMarks.Length              '// Initialize the size of buffer to store mark data
            dwStatus = SkDv_ReqGetMarks(hSkDevice, SKDV_FRONT, MarkInfo, szMarks(0), nBufSize)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                Exit Do
            End If

            strTextBuffer += OutputMarkData(MarkInfo, szMarks)          '// Store mark data to buffer

            '// If "Installed backside read unit" or "valid back side reading",
            '// Output mark data(back)
            If ((SKDV_OPT_UNIT_READER_B And DeviceInfo.Main.dwOption) And (MarkConf.iBackSideReading = SKDV_ENABLE)) Then
                strTextBuffer += "[Back MarkData]" + vbCrLf
                nBufSize = szMarks.Length          '// Initialize the size of buffer to store mark data
                dwStatus = SkDv_ReqGetMarks(hSkDevice, SKDV_BACK, MarkInfo, szMarks(0), nBufSize)
                If (SKDV_STS_SUCCESS <> dwStatus) Then
                    ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                    GoTo Termination
                End If
                strTextBuffer += OutputMarkData(MarkInfo, szMarks)      '// Store mark data to buffer
            End If

            '//--------------------------------------------------------
            '//  Output Barcode data
            '//--------------------------------------------------------

            If (True = bBarcodeCheck) Then
                '// Get the number of barcode
                bResponse = OMR_GetBarcodeInfo(nReadCount, nSettingCount)
                If (1 <> bResponse) Then
                    ErrorMessage("OMR_GetBarcodeInfo", CUInt(OMR_GetLastError()))
                    Exit Do
                End If

                strTextBuffer += String.Format("[BarcodeData],ReadingCount,{0:00}", nReadCount) + vbCrLf   '// Output the number of barcode read

                If (0 = nReadCount) Then    '// Not output Barcode data in case no read the barcode
                    GoTo BreakOutputBarcodeData
                End If

                '// Output Barcode Data
                For i As Integer = 0 To nReadCount - 1
                    nBcDataLen(i) = 256       '// Set the number of bytes of Barcode data
                    bResponse = OMR_GetBarcodeData((i + 1), sBcType(i), nBcDataLen(i), sBcData(i, 0))
                    If (1 <> bResponse) Then
                        ErrorMessage("OMR_GetBarcodeData", CUInt(OMR_GetLastError()))
                        GoTo Termination
                    End If
                Next

                strTextBuffer += OutputBarcodeData(nReadCount, sBcData, sBcType, nBcDataLen) + vbCrLf '// Store barcode data to buffer
            End If

BreakOutputBarcodeData:
            '//--------------------------------------------------------
            '//  Printer Operation
            '//--------------------------------------------------------

            If (True = bPrintCheck) Then
                '// Setting Printer
                '// (Windows API manual 6.7.15.)
                bResponse = OMR_SetPrintString(1, "SEKONIC ")
                If (1 <> bResponse) Then
                    ErrorMessage("OMR_SetPrintString", CUInt(OMR_GetLastError()))
                    Exit Do
                End If

                bResponse = OMR_SetPrintString(2, "PRINT ")
                If (1 <> bResponse) Then
                    ErrorMessage("OMR_SetPrintString", CUInt(OMR_GetLastError()))
                    Exit Do
                End If

                bResponse = OMR_SetPrintString(3, "SANPLE ")
                If (1 <> bResponse) Then
                    ErrorMessage("OMR_SetPrintString", CUInt(OMR_GetLastError()))
                    Exit Do
                End If

                '// Setting print order
                '// (Windows API manual 6.7.3.)
                bResponse = OMR_SetPrintOrder(SR_PRINT.SR_PRINT_BUFFER_1, SR_PRINT.SR_PRINT_BUFFER_2, SR_PRINT.SR_PRINT_BUFFER_3)
                If (1 <> bResponse) Then
                    ErrorMessage("OMR_SetPrintOrder", CUInt(OMR_GetLastError()))
                    Exit Do
                End If
            End If

            '// Output the contents of TXT buffer to RichEditControl
            Me.RICH_TEXT_BOX.AppendText(strTextBuffer)

            '// Save TXT buffer to file
            '// Comment-out the following process if OMR operation is slow. 
            SaveTextBuffer(hSkDevice, strTextBuffer, strTime, strFolderPath)

            Me.Refresh()      '// Update Window
        Loop

        '//--------------------------------------------------------
        '//  Finish
        '//--------------------------------------------------------

Termination:
        '// Close the device if open
        If (0 <> hSkDevice) Then
            dwStatus = SkDv_Close(hSkDevice)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_Close", dwStatus)
            End If
        End If
    End Sub

    '//
    '// Main [Image Only (Single Thread)]
    '//
    '//////////////////////////////////////////////////////////////////////////////
    Private Sub B_IMAGE_ONLY_S_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_IMAGE_ONLY_S.Click
        Dim hSkDevice As UInteger                           '// Handle device
        Dim dwStatus As UInteger                            '// Return Value

        Dim strImageFileNameF As String = Nothing           '// Image file name(front)
        Dim strImageFileNameB As String = Nothing           '// Image file name(back)

        Dim strFolderPath As String = 0                     '// Fullpath executed file
        Dim strTime As String = 0                           '// Current time
        Dim strTextBuffer As String                         '// TXT buffer

        Dim DeviceInfo As New SK_DV_SR3500_INFO             '// Structure device Information
        Dim DeviceMode As New SK_DV_SR3500_MODE             '// Structure device Mode
        Dim MarkConf As New SK_DV_SR3500MARK_CONF           '// Structure condition of Mark reading
        Dim ImageData As New SK_DV_IMAGE_DATA_CONF          '// Structure condition save Image data
        Dim ImageFile As New SK_DV_IMAGE_FILE_CONF          '// Structure type of Image file
        Dim ScanConf As New SK_DV_SR3500IMG_CONF            '// Structure condition Image scanning

        '//--------------------------------------------------------
        '//  Initialization
        '//--------------------------------------------------------

        '// Open Device
        dwStatus = SkDv_OpenSingle(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_OpenSingle", dwStatus)
            GoTo Termination
        End If

        '// Initialize Device
        '// Hold OMR setting into library
        dwStatus = SkDv_ReqInit(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_ReqInit", dwStatus)
            GoTo Termination
        End If

        '// Get the information of OMR unit
        dwStatus = SkDv_GetInfo(hSkDevice, DeviceInfo)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetInfo", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Set mark reading
        '//--------------------------------------------------------

        '// Get Operation mode
        dwStatus = SkDv_GetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetMode", dwStatus)
            GoTo Termination
        End If

        '// All sheet except OMR Mark form can be readable in case reading row is set "0"
        MarkConf.iColumns = 0                            '// The number of columns to be read(0/1-48)

        '// Set Operation mode
        dwStatus = SkDv_SetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_SetMode", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Setting Image reading
        '//--------------------------------------------------------

        '// Set the condition of Image reading if installed Image unit(CIS Sensor)
        If (SKDV_OPT_UNIT_IMAGE_1 And DeviceInfo.Main.dwOption) Then

            '// Get the condition of Image reading
            dwStatus = SkDv_GetImageConf(hSkDevice, ScanConf)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_GetImageConf", dwStatus)
                GoTo Termination
            End If

            ''//[NOTICE]
            ''//    Set the condition of Image reading
            ''//    Cancel the comment and change the contents if want change the setting
            ''//
            ''//    (Windows API manual 5.3.6.)
            ''//
            ''//    Save the setting in the OMR unit to change the strings below
            'ScanConf.iScanningSide = SKDV_SIDE_BOTH             '// Read Setting(no/both side/Front/back)
            'ScanConf.iLightColor(0) = SKDV_LIGHT_GRAYSCALE      '// Read light source(Front)(Color/Grayscale/R/G/B)
            'ScanConf.iLightColor(1) = SKDV_LIGHT_GRAYSCALE      '// Read light source(Back)(Color/Grayscale/R/G/B)
            ScanConf.iResoType = SKDV_RESO_TYPE_100DPI          '// Resolution(600dpi/300dpi/200dpi/150dpi/100dpi)

            '// Set the condition of Image reading
            dwStatus = SkDv_SetImageConf(hSkDevice, ScanConf)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SetImageConf", dwStatus)
                GoTo Termination
            End If
        End If

        '// Preprocessing roop
        Me.RICH_TEXT_BOX.Text = ""                  '// Clear RichTextBox

        '// Continue rooping till hopper empty or error happen
        Do While True

            strTextBuffer = ""                      '// Clear TXT buffer

            GetFilePath(strFolderPath, strTime)     '// Get fullpath of file and time 

            strTextBuffer += String.Format("[Data_{0}.csv]", strTime) + vbCrLf  '// Store the output data

            '//--------------------------------------------------------
            '//  Reading
            '//--------------------------------------------------------

            '// Image Reading
            dwStatus = SkDv_ReqScanForm(hSkDevice)
            If (SKDV_STS_DEVICE_ST_Q1 = (dwStatus And SKDV_STS_DEVICE_STA_MASK)) Then
                MessageBox.Show("Hopper Empty", "Sk_Dv_Sample", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Do
            ElseIf (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                Exit Do
            End If

            '//--------------------------------------------------------
            '//  Save Image (Single thread)
            '//--------------------------------------------------------

            ''//[NOTICE]
            ''//	Set the condition save the Image Data
            ''//
            ''//	(Windows API manual 5.3.6.)
            ''//
            ''//	This setting is not saved to the OMR unit
            ImageData.iFace = SKDV_FRONT                        '// Set the saved image(Front/Back/Both)
            ImageData.rectCutout.left = 0                       '// Area setting to be captured(Left) [:mm]
            ImageData.rectCutout.top = 0                        '// Area setting to be captured(Top) [:mm]
            ImageData.rectCutout.right = 2159                   '// Area setting to be captured(Right) [:mm]
            ImageData.rectCutout.bottom = 3048                  '// Area setting to be captured(Bottom) [:mm]
            ImageData.iColorType = SKIM_IMAGE_GRAY              '// Color Setting(Black&White/Grayscale/Color)
            ImageData.iRotate = SKIM_IMAGE_ROTATE_0             '// Rotation(0/90/180/270)
            ImageData.iResolution = 100                         '// Resolution(300dpi/200dpi/150dpi/100dpi/50dpi)

            '// Set the image file type
            ImageFile.iEncoder = SKIM_ENCODE_BMP                '// Set File type(BMP/GIF/JPEG/PNG/TIFF)
            If (SKIM_ENCODE_JPEG = ImageFile.iEncoder) Then     '// Compressed(JPEG)(0-100)
                ImageFile.iParam = SKIM_ENCODE_JPEG_PRM_MAX
            End If
            If (SKIM_ENCODE_TIFF = ImageFile.iEncoder) Then     '// Compressed or NonCompressed(TIFF)(LZWCompression/NonCompression)
                ImageFile.iParam = SKIM_ENCODE_TIFF_PRM_LZW
            End If

            '// Change the extension of file name if change the file type
            strImageFileNameF = String.Format("{0}\ImageF_{1}.bmp", strFolderPath, strTime)  '// Output saved file name(front)
            dwStatus = SkDv_SaveImageData(hSkDevice, ImageData, ImageFile, strImageFileNameF)    '// Save Image data(front)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SaveImageData", dwStatus)
                Exit Do
            End If

            '// Change the extension of file name if change the file type
            ImageData.iFace = SKDV_BACK
            strImageFileNameB = String.Format("{0}\ImageB_{1}.bmp", strFolderPath, strTime)  '// Output saved file name(back)
            dwStatus = SkDv_SaveImageData(hSkDevice, ImageData, ImageFile, strImageFileNameB)     '// Save Image data(back)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SaveImageData", dwStatus)
                Exit Do
            End If

            '//--------------------------------------------------------
            '//  Output image file name
            '//--------------------------------------------------------

            '// Change the extension of file name if change the file type
            strTextBuffer += "[ImageData]" + vbCrLf
            strTextBuffer += String.Format("ImageF_{0}.bmp", strTime) + vbCrLf
            strTextBuffer += String.Format("ImageB_{0}.bmp", strTime) + vbCrLf + vbCrLf

            '// Output the contents of TXT buffer to RichEditControl
            Me.RICH_TEXT_BOX.AppendText(strTextBuffer)

            '// Save TXT buffer to file
            '// Comment-out the following process if OMR operation is slow. 
            SaveTextBuffer(hSkDevice, strTextBuffer, strTime, strFolderPath)

            Me.Refresh()      '// Update Window
        Loop

        '//--------------------------------------------------------
        '//  Finish
        '//--------------------------------------------------------

Termination:
        '// Close the device if open
        If (0 <> hSkDevice) Then
            dwStatus = SkDv_Close(hSkDevice)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_Close", dwStatus)
            End If
        End If
    End Sub

    '//
    '// Main [Image Only (Multi Thread)]
    '//
    '//////////////////////////////////////////////////////////////////////////////
    Private Sub B_IMAGE_ONLY_M_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_IMAGE_ONLY_M.Click
        Dim hSkDevice As UInteger                           '// Handle device
        Dim dwStatus As UInteger                            '// Return Value

        Dim strImageFileNameF As String = Nothing           '// Image file name(front)
        Dim strImageFileNameB As String = Nothing           '// Image file name(back)
        Dim dwImgError As UInteger                          '// Store the responce of saving image
        Dim bCheckThread As Boolean = 1                     '// Store the responce of SkDv_IsThreadRunning

        Dim strFolderPath As String = 0                     '// Fullpath executed file
        Dim strTime As String = 0                           '// Current time
        Dim strTextBuffer As String                         '// TXT buffer

        Dim DeviceInfo As New SK_DV_SR3500_INFO             '// Structure device Information
        Dim DeviceMode As New SK_DV_SR3500_MODE             '// Structure device Mode
        Dim MarkConf As New SK_DV_SR3500MARK_CONF           '// Structure condition of Mark reading
        Dim MarkInfo As New SK_DV_MARK_INFO                 '// Structure store Mark Information
        Dim ImageData As New SK_DV_IMAGE_DATA_CONF          '// Structure condition save Image data
        Dim ImageFile As New SK_DV_IMAGE_FILE_CONF          '// Structure type of Image file
        Dim ScanConf As New SK_DV_SR3500IMG_CONF            '// Structure condition Image scanning

        Dim CallBack As SaveimageCallbackDelegate = New SaveimageCallbackDelegate(AddressOf SaveimageCallback)  '// Generate DelegateObject to call back

        '//--------------------------------------------------------
        '//  Initialization
        '//--------------------------------------------------------

        '// Open Device
        dwStatus = SkDv_OpenSingle(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_OpenSingle", dwStatus)
            GoTo Termination
        End If

        '// Initialize Device
        '// Hold OMR setting into library
        dwStatus = SkDv_ReqInit(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_ReqInit", dwStatus)
            GoTo Termination
        End If

        '// Get the information of OMR unit
        dwStatus = SkDv_GetInfo(hSkDevice, DeviceInfo)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetInfo", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Set mark reading
        '//--------------------------------------------------------

        '// Get Operation mode
        dwStatus = SkDv_GetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetMode", dwStatus)
            GoTo Termination
        End If

        '// All sheet except OMR Mark form can be readable in case reading row is set "0"
        MarkConf.iColumns = 0                            '// The number of columns to be read(0/1-48)

        '// Set Operation mode
        dwStatus = SkDv_SetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_SetMode", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Setting Image reading
        '//--------------------------------------------------------

        '// Set the condition of Image reading if installed Image unit(CIS Sensor)
        If (SKDV_OPT_UNIT_IMAGE_1 And DeviceInfo.Main.dwOption) Then

            '// Get the condition of Image reading
            dwStatus = SkDv_GetImageConf(hSkDevice, ScanConf)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_GetImageConf", dwStatus)
                GoTo Termination
            End If

            ''//[NOTICE]
            ''//    Set the condition of Image reading
            ''//    Cancel the comment and change the contents if want change the setting
            ''//
            ''//    (Windows API manual 5.3.6.)
            ''//
            ''//    Save the setting in the OMR unit to change the strings below

            'ScanConf.iScanningSide = SKDV_SIDE_BOTH             '// Read Setting(no/both side/Front/back)
            'ScanConf.iLightColor(0) = SKDV_LIGHT_GRAYSCALE      '// Read light source(Front)(Color/Grayscale/R/G/B)
            'ScanConf.iLightColor(1) = SKDV_LIGHT_GRAYSCALE      '// Read light source(Back)(Color/Grayscale/R/G/B)
            ScanConf.iResoType = SKDV_RESO_TYPE_100DPI          '// Resolution(600dpi/300dpi/200dpi/150dpi/100dpi)

            '// Set the condition of Image reading
            dwStatus = SkDv_SetImageConf(hSkDevice, ScanConf)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SetImageConf", dwStatus)
                GoTo Termination
            End If
        End If

        '// Preprocessing roop
        Me.RICH_TEXT_BOX.Text = ""                  '// Clear RichTextBox
        dwImgError = 0                              '// Initialize dwImgError

        '// Continue rooping till hopper empty or error happen
        Do While True

            strTextBuffer = ""                      '// Clear TXT buffer

            GetFilePath(strFolderPath, strTime)     '// Get fullpath of file and time 

            strTextBuffer += String.Format("[Data_{0}.csv]", strTime) + vbCrLf  '// Store the output data

            '//--------------------------------------------------------
            '//  Reading
            '//--------------------------------------------------------

            '// Image Reading
            dwStatus = SkDv_ReqScanForm(hSkDevice)
            If (SKDV_STS_DEVICE_ST_Q1 = (dwStatus And SKDV_STS_DEVICE_STA_MASK)) Then
                MessageBox.Show("Hopper Empty", "Sk_Dv_Sample", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Do
            ElseIf (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                Exit Do
            End If

            '//--------------------------------------------------------
            '//  Save Image(Multi thread)
            '//--------------------------------------------------------

            ''//[NOTICE]
            ''//	Set the condition save the Image Data
            ''//
            ''//	(Windows API manual 5.3.6.)
            ''//
            ''//	This setting is not saved to the OMR unit
            ImageData.iFace = SKDV_FRONT                        '// Set the saved image(Front/Back/Both)
            ImageData.rectCutout.left = 0                       '// Area setting to be captured(Left) [:mm]
            ImageData.rectCutout.top = 0                        '// Area setting to be captured(Top) [:mm]
            ImageData.rectCutout.right = 2159                   '// Area setting to be captured(Right) [:mm]
            ImageData.rectCutout.bottom = 3048                  '// Area setting to be captured(Bottom) [:mm]
            ImageData.iColorType = SKIM_IMAGE_GRAY              '// Color Setting(Black&White/Grayscale/Color)
            ImageData.iRotate = SKIM_IMAGE_ROTATE_0             '// Rotation(0/90/180/270)
            ImageData.iResolution = 100                         '// Resolution(300dpi/200dpi/150dpi/100dpi/50dpi)

            '// Set the image file type
            ImageFile.iEncoder = SKIM_ENCODE_BMP                '// Set File type(BMP/GIF/JPEG/PNG/TIFF)
            If (SKIM_ENCODE_JPEG = ImageFile.iEncoder) Then     '// Compressed(JPEG)(0-100)
                ImageFile.iParam = SKIM_ENCODE_JPEG_PRM_MAX
            End If
            If (SKIM_ENCODE_TIFF = ImageFile.iEncoder) Then     '// Compressed or NonCompressed(TIFF)(LZWCompression/NonCompression)
                ImageFile.iParam = SKIM_ENCODE_TIFF_PRM_LZW
            End If

            '// Change the extension of file name if change the file type
            strImageFileNameF = String.Format("{0}\ImageF_{1}.bmp", strFolderPath, strTime)  '// Output saved file name(front)
            dwStatus = SkDv_SaveImageDataThread(hSkDevice, ImageData, ImageFile, strImageFileNameF, _
                        CallBack.Invoke(ImageData, ImageFile, strImageFileNameF, dwStatus, dwImgError), 0)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SaveImageDataThread(Front)", dwStatus)
                Exit Do
            End If

            '// Change the extension of file name if change the file type
            ImageData.iFace = SKDV_BACK
            strImageFileNameB = String.Format("{0}\ImageB_{1}.bmp", strFolderPath, strTime)  '// Output saved file name(back)
            dwStatus = SkDv_SaveImageDataThread(hSkDevice, ImageData, ImageFile, strImageFileNameB, _
                        CallBack.Invoke(ImageData, ImageFile, strImageFileNameB, dwStatus, dwImgError), 0)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SaveImageDataThread(Back)", dwStatus)
                Exit Do
            End If

            '//--------------------------------------------------------
            '//  Output image file name
            '//--------------------------------------------------------

            '// Change the extension of file name if change the file type
            strTextBuffer += "[ImageData]" + vbCrLf
            strTextBuffer += String.Format("ImageF_{0}.bmp", strTime) + vbCrLf
            strTextBuffer += String.Format("ImageB_{0}.bmp", strTime) + vbCrLf + vbCrLf

            '// Output the contents of TXT buffer to RichEditControl
            Me.RICH_TEXT_BOX.AppendText(strTextBuffer)

            '// Save TXT buffer to file
            '// Comment-out the following process if OMR operation is slow. 
            SaveTextBuffer(hSkDevice, strTextBuffer, strTime, strFolderPath)

            Me.Refresh()      '// Update Window
        Loop

        '//--------------------------------------------------------
        '//  Check the operation other threads
        '//--------------------------------------------------------

        '// Check finish other thread operation.
        '// If return of "SkDv_IsThreadRunning()" is TRUE, Check other thread,
        '// If FALSE, exit the roop
        Do While (1 = bCheckThread)
            bCheckThread = SkDv_IsThreadRunning(hSkDevice)
            System.Threading.Thread.Sleep(100)
        Loop

        '//--------------------------------------------------------
        '//  Output Error buffer
        '//--------------------------------------------------------

        '// Output if error on the process of save image file(multi thread) 
        If (SKDV_STS_SUCCESS <> dwImgError) Then
            ErrorMessage("SkDv_SaveImageDataThread", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Finish
        '//--------------------------------------------------------

Termination:
        '// Close the device if open
        If (0 <> hSkDevice) Then
            dwStatus = SkDv_Close(hSkDevice)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_Close", dwStatus)
            End If
        End If
    End Sub

    '//
    '// Main [Mark + Image (Single Thread)]
    '//
    '//////////////////////////////////////////////////////////////////////////////
    Private Sub B_MARK_AND_IMAGE_S_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_MARK_AND_IMAGE_S.Click
        Dim hSkDevice As UInteger                           '// Handle device
        Dim dwStatus As UInteger                            '// Return Value

        Dim szMarks(SKDV_COL_MAX * SKDV_ROW_MAX) As Byte    '// Buffer to store Mark data
        Dim nBufSize As Integer                             '// The size to store the Mark data

        Dim strImageFileNameF As String = Nothing           '// Image file name(front)
        Dim strImageFileNameB As String = Nothing           '// Image file name(back)

        Dim strFolderPath As String = 0                     '// Fullpath executed file
        Dim strTime As String = 0                           '// Current time
        Dim strTextBuffer As String                         '// TXT buffer

        Dim DeviceInfo As New SK_DV_SR3500_INFO             '// Structure device Information
        Dim DeviceMode As New SK_DV_SR3500_MODE             '// Structure device Mode
        Dim MarkConf As New SK_DV_SR3500MARK_CONF           '// Structure condition of Mark reading
        Dim MarkInfo As New SK_DV_MARK_INFO                 '// Structure store Mark Information
        Dim ImageData As New SK_DV_IMAGE_DATA_CONF          '// Structure condition save Image data
        Dim ImageFile As New SK_DV_IMAGE_FILE_CONF          '// Structure type of Image file
        Dim ScanConf As New SK_DV_SR3500IMG_CONF            '// Structure condition Image scanning

        '//--------------------------------------------------------
        '//  Initialization
        '//--------------------------------------------------------

        '// Open Device
        dwStatus = SkDv_OpenSingle(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_OpenSingle", dwStatus)
            GoTo Termination
        End If

        '// Initialize Device
        '// Hold OMR setting into library
        dwStatus = SkDv_ReqInit(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_ReqInit", dwStatus)
            GoTo Termination
        End If

        '// Get the information of OMR unit
        dwStatus = SkDv_GetInfo(hSkDevice, DeviceInfo)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetInfo", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Set mark reading
        '//--------------------------------------------------------

        '//--------------------------------------------------------
        '//  Set mark reading
        '//--------------------------------------------------------

        '// Get Operation mode
        dwStatus = SkDv_GetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetMode", dwStatus)
            GoTo Termination
        End If

        ''//[NOTICE]
        ''//        Set the condition of Operation mode
        ''//        Cancel the comment and change the contents if want change the setting.
        ''//
        ''//        (Windows API manual 5.3.4.)
        ''//
        ''//        Save the setting in the OMR unit to change the strings below
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_AUTO_REJECT  '// Auto reject when Error(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_HOPPER_EMPTY '// Hopper Empty error detection(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_TM_ERROR     '// Timing Mark error detection(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_DF_ERROR     '// Double Feed error detection(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_LEFT_SKEW    '// Left End Skew error detection (Valid to flag ON)
        'DeviceMode.MarkSkew.iRow = SKDV_MARKSKEW_ROW_MIN                                    '// Mark Skew detection(Valid/Invalid)
        'DeviceMode.MarkSkew.iLevel = SKDV_MARKSKEW_LEVEL_MIN                                '// Mark Skew detection level(1-16)
        'DeviceMode.iPanelOperation = SKDV_ENABLE                                            '// Panel Operation(Valid/Invalid)
        'DeviceMode.Buzzer.iVol = SKDV_BUZZER_MIN                                            '// Buzzer volume(0/1-5))
        'DeviceMode.Buzzer.iTone = SKDV_BUZZER_TONE_A                                        '// Buzzer tone (1/2/3)
        'DeviceMode.PSaving.iSleep = SKDV_SLEEPTIME_MIN                                      '// Sleep timer(0/1-60)
        'DeviceMode.PSaving.iStandby = SKDV_STANDBYTIME_MIN                                  '// Standby timer(0/1-60)


        '// Set Operation mode
        dwStatus = SkDv_SetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_SetMode", dwStatus)
            GoTo Termination
        End If

        '// Get the condition of Mark reading
        dwStatus = SkDv_GetMarkConf(hSkDevice, MarkConf)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetMarkConf", dwStatus)
            GoTo Termination
        End If

        ''//[NOTICE]
        ''//        Set the condition of Operation mode
        ''//        Cancel the comment and change the contents if want change the setting.
        ''//
        ''//        (Windows API manual 5.3.4.)
        ''//
        ''//        Save the setting in the OMR unit to change the strings below
        ''//
        ''//	Check the followings on the process of setting
        ''//	MarkConf.iBackSideReading	: Backside reading(On/Off)
        ''//	MarkConf.iColumns			: The number of columns to be read
        ''//	MarkConf.iReadingMethod		: Reading method
        ''//	MarkConf.iCtrlMultiple		: (If iReading Method is "Control") Front or Back
        ''//	MarkConf.iThicknessType		: Paper thickness to be read

        MarkConf.iBackSideReading = SKDV_ENABLE                     '// Backside reading(Valid/Invalid)
        'MarkConf.iColumns = SKDV_COL_MAX                            '// The number of columns to be read(1-48)
        'MarkConf.iReadingMethod = SKDV_READ_DIRECT                  '// Reading method(Control(Front)/Control(back)/Direct/FACOM/Mark to Mark(Front edge or Front No edge)
        'MarkConf.iCtrlMultiple = SKDV_READ_EDGE_CTRL_MIN1           '// (If iReading Method is "Control" only ) Front or Back space (1-9times)
        'MarkConf.iThicknessType = SKDV_THICKNESS_90_KG              '// Paper thickness to be read(Automatic/55/72/90/110/135)


        '// Set the condition of Mark reading
        dwStatus = SkDv_SetMarkConf(hSkDevice, MarkConf)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_SetMarkConf", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Setting Image reading
        '//--------------------------------------------------------

        '// Set the condition of Image reading if installed Image unit(CIS Sensor)
        If (SKDV_OPT_UNIT_IMAGE_1 And DeviceInfo.Main.dwOption) Then

            '// Get the condition of Image reading
            dwStatus = SkDv_GetImageConf(hSkDevice, ScanConf)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_GetImageConf", dwStatus)
                GoTo Termination
            End If

            ''//[NOTICE]
            ''//    Set the condition of Image reading
            ''//    Cancel the comment and change the contents if want change the setting
            ''//
            ''//    (Windows API manual 5.3.6.)
            ''//
            ''//    Save the setting in the OMR unit to change the strings below
            'ScanConf.iScanningSide = SKDV_SIDE_BOTH             '// Read Setting(no/both side/Front/back)
            'ScanConf.iLightColor(0) = SKDV_LIGHT_GRAYSCALE      '// Read light source(Front)(Color/Grayscale/R/G/B)
            'ScanConf.iLightColor(1) = SKDV_LIGHT_GRAYSCALE      '// Read light source(Back)(Color/Grayscale/R/G/B)
            'ScanConf.iResoType = SKDV_RESO_TYPE_100DPI          '// Resolution(600dpi/300dpi/200dpi/150dpi/100dpi)

            '// Set the condition of Image reading
            dwStatus = SkDv_SetImageConf(hSkDevice, ScanConf)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SetImageConf", dwStatus)
                GoTo Termination
            End If
        End If

        '// Preprocessing roop
        Me.RICH_TEXT_BOX.Text = ""                  '// Clear RichTextBox

        '// Continue rooping till hopper empty or error happen
        Do While True

            strTextBuffer = ""                      '// Clear TXT buffer

            GetFilePath(strFolderPath, strTime)     '// Get fullpath of file and time 

            strTextBuffer += String.Format("[Data_{0}.csv]", strTime) + vbCrLf  '// Store the output data

            '//--------------------------------------------------------
            '//  Reading
            '//--------------------------------------------------------

            '// Mark And Image Reading
            dwStatus = SkDv_ReqScanForm(hSkDevice)
            If (SKDV_STS_DEVICE_ST_Q1 = (dwStatus And SKDV_STS_DEVICE_STA_MASK)) Then
                MessageBox.Show("Hopper Empty", "Sk_Dv_Sample", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Do
            ElseIf (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                Exit Do
            End If

            '//--------------------------------------------------------
            '//  Output mark data
            '//--------------------------------------------------------

            '// Output mark data(front)
            strTextBuffer += "[Front MarkData]" + vbCrLf

            nBufSize = szMarks.Length              '// Initialize the size of buffer to store mark data
            dwStatus = SkDv_ReqGetMarks(hSkDevice, SKDV_FRONT, MarkInfo, szMarks(0), nBufSize)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                Exit Do
            End If

            strTextBuffer += OutputMarkData(MarkInfo, szMarks)          '// Store mark data to buffer

            '// If "Installed backside read unit" or "valid back side reading",
            '// Output mark data(back)
            If ((SKDV_OPT_UNIT_READER_B And DeviceInfo.Main.dwOption) And (MarkConf.iBackSideReading = SKDV_ENABLE)) Then
                strTextBuffer += "[Back MarkData]" + vbCrLf
                nBufSize = szMarks.Length          '// Initialize the size of buffer to store mark data
                dwStatus = SkDv_ReqGetMarks(hSkDevice, SKDV_BACK, MarkInfo, szMarks(0), nBufSize)
                If (SKDV_STS_SUCCESS <> dwStatus) Then
                    ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                    GoTo Termination
                End If
                strTextBuffer += OutputMarkData(MarkInfo, szMarks)      '// Store mark data to buffer
            End If

            '//--------------------------------------------------------
            '//  Save Image (Single thread)
            '//--------------------------------------------------------

            ''//[NOTICE]
            ''//	Set the condition save the Image Data
            ''//
            ''//	(Windows API manual 5.3.6.)
            ''//
            ''//	This setting is not saved to the OMR unit
            ImageData.iFace = SKDV_FRONT                        '// Set the saved image(Front/Back/Both)
            ImageData.rectCutout.left = 0                       '// Area setting to be captured(Left) [:mm]
            ImageData.rectCutout.top = 0                        '// Area setting to be captured(Top) [:mm]
            ImageData.rectCutout.right = 2159                   '// Area setting to be captured(Right) [:mm]
            ImageData.rectCutout.bottom = 3048                  '// Area setting to be captured(Bottom) [:mm]
            ImageData.iColorType = SKIM_IMAGE_GRAY              '// Color Setting(Black&White/Grayscale/Color)
            ImageData.iRotate = SKIM_IMAGE_ROTATE_0             '// Rotation(0/90/180/270)
            ImageData.iResolution = 100                         '// Resolution(300dpi/200dpi/150dpi/100dpi/50dpi)

            '// Set the image file type
            ImageFile.iEncoder = SKIM_ENCODE_BMP                '// Set File type(BMP/GIF/JPEG/PNG/TIFF)
            If (SKIM_ENCODE_JPEG = ImageFile.iEncoder) Then     '// Compressed(JPEG)(0-100)
                ImageFile.iParam = SKIM_ENCODE_JPEG_PRM_MAX
            End If
            If (SKIM_ENCODE_TIFF = ImageFile.iEncoder) Then     '// Compressed or NonCompressed(TIFF)(LZWCompression/NonCompression)
                ImageFile.iParam = SKIM_ENCODE_TIFF_PRM_LZW
            End If

            '// Change the extension of file name if change the file type
            strImageFileNameF = String.Format("{0}\ImageF_{1}.bmp", strFolderPath, strTime)  '// Output saved file name(front)
            dwStatus = SkDv_SaveImageData(hSkDevice, ImageData, ImageFile, strImageFileNameF)          '// Save Image data(front)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SaveImageData", dwStatus)
                Exit Do
            End If

            '// Change the extension of file name if change the file type
            ImageData.iFace = SKDV_BACK
            strImageFileNameB = String.Format("{0}\ImageB_{1}.bmp", strFolderPath, strTime)  '// Output saved file name(back)
            dwStatus = SkDv_SaveImageData(hSkDevice, ImageData, ImageFile, strImageFileNameB)          '// Save Image data(back)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SaveImageData", dwStatus)
                Exit Do
            End If

            '//--------------------------------------------------------
            '//  Output image file name
            '//--------------------------------------------------------

            '// Change the extension of file name if change the file type
            strTextBuffer += "[ImageData]" + vbCrLf
            strTextBuffer += String.Format("ImageF_{0}.bmp", strTime) + vbCrLf
            strTextBuffer += String.Format("ImageB_{0}.bmp", strTime) + vbCrLf + vbCrLf

            '// Output the contents of TXT buffer to RichEditControl
            Me.RICH_TEXT_BOX.AppendText(strTextBuffer)

            '// Save TXT buffer to file
            '// Comment-out the following process if OMR operation is slow. 
            SaveTextBuffer(hSkDevice, strTextBuffer, strTime, strFolderPath)

            Me.Refresh()      '// Update Window
        Loop

        '//--------------------------------------------------------
        '//  Finish
        '//--------------------------------------------------------

Termination:
        '// Close the device if open
        If (0 <> hSkDevice) Then
            dwStatus = SkDv_Close(hSkDevice)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_Close", dwStatus)
            End If
        End If
    End Sub

    '//
    '// Main [Mark + Image (Multi Thread)]
    '//
    '//////////////////////////////////////////////////////////////////////////////
    Private Sub B_MARK_AND_IMAGE_M_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_MARK_AND_IMAGE_M.Click
        Dim hSkDevice As UInteger                           '// Handle device
        Dim dwStatus As UInteger                            '// Return Value

        Dim szMarks(SKDV_COL_MAX * SKDV_ROW_MAX) As Byte    '// Buffer to store Mark data
        Dim nBufSize As Integer                             '// The size to store the Mark data

        Dim strImageFileNameF As String = Nothing           '// Image file name(front)
        Dim strImageFileNameB As String = Nothing           '// Image file name(back)
        Dim dwImgError As UInteger                          '// Store the responce of saving image
        Dim bCheckThread As Boolean = 1                     '// Store the responce of SkDv_IsThreadRunning

        Dim strFolderPath As String = 0                     '// Fullpath executed file
        Dim strTime As String = 0                           '// Current time
        Dim strTextBuffer As String                         '// TXT buffer

        Dim DeviceInfo As New SK_DV_SR3500_INFO             '// Structure device Information
        Dim DeviceMode As New SK_DV_SR3500_MODE             '// Structure device Mode
        Dim MarkInfo As New SK_DV_MARK_INFO                 '// Structure store Mark Information
        Dim MarkConf As New SK_DV_SR3500MARK_CONF           '// Structure condition of Mark reading
        Dim ImageData As New SK_DV_IMAGE_DATA_CONF          '// Structure condition save Image data
        Dim ImageFile As New SK_DV_IMAGE_FILE_CONF          '// Structure type of Image file
        Dim ScanConf As New SK_DV_SR3500IMG_CONF            '// Structure condition Image scanning

        Dim CallBack As SaveimageCallbackDelegate = New SaveimageCallbackDelegate(AddressOf SaveimageCallback)  '// Generate DelegateObject to call back

        '//--------------------------------------------------------
        '//  Initialization
        '//--------------------------------------------------------

        '// Open Device
        dwStatus = SkDv_OpenSingle(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_OpenSingle", dwStatus)
            GoTo Termination
        End If

        '// Initialize Device
        '// Hold OMR setting into library
        dwStatus = SkDv_ReqInit(hSkDevice)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_ReqInit", dwStatus)
            GoTo Termination
        End If

        '// Get the information of OMR unit
        dwStatus = SkDv_GetInfo(hSkDevice, DeviceInfo)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetInfo", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Set mark reading
        '//--------------------------------------------------------

        '// Get Operation mode
        dwStatus = SkDv_GetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetMode", dwStatus)
            GoTo Termination
        End If

        ''//[NOTICE]
        ''//	Set the condition of Operation mode
        ''//	Cancel the comment and change the contents if want change the setting.
        ''//
        ''//	(Windows API manual 5.3.4.)
        ''//
        ''//	Save the setting in the OMR unit to change the strings below

        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_AUTO_REJECT  '// Auto reject when Error(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_HOPPER_EMPTY '// Hopper Empty error detection(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_TM_ERROR     '// Timing Mark error detection(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_DF_ERROR     '// Double Feed error detection(Valid to flag ON)
        'DeviceMode.dwDisableWarning = DeviceMode.dwDisableWarning Or SKDV_WARN_LEFT_SKEW    '// Left End Skew error detection (Valid to flag ON)
        'DeviceMode.MarkSkew.iRow = SKDV_MARKSKEW_ROW_MIN                                    '// Mark Skew detection(Valid/Invalid)
        'DeviceMode.MarkSkew.iLevel = SKDV_MARKSKEW_LEVEL_MIN                                '// Mark Skew detection level(1-16)
        'DeviceMode.iPanelOperation = SKDV_ENABLE                                            '// Panel Operation(Valid/Invalid)
        'DeviceMode.Buzzer.iVol = SKDV_BUZZER_MIN                                            '// Buzzer volume(0/1-5))
        'DeviceMode.Buzzer.iTone = SKDV_BUZZER_TONE_A                                        '// Buzzer tone (1/2/3)
        'DeviceMode.PSaving.iSleep = SKDV_SLEEPTIME_MIN                                      '// Sleep timer(0/1-60)
        'DeviceMode.PSaving.iStandby = SKDV_STANDBYTIME_MIN                                  '// Standby timer(0/1-60)


        '// Set Operation mode
        dwStatus = SkDv_SetMode(hSkDevice, DeviceMode)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_SetMode", dwStatus)
            GoTo Termination
        End If

        '// Get the condition of Mark reading
        dwStatus = SkDv_GetMarkConf(hSkDevice, MarkConf)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_GetMarkConf", dwStatus)
            GoTo Termination
        End If

        ''//[NOTICE]
        ''//    Set the condition of Operation mode
        ''//    Cancel the comment and change the contents if want change the setting.
        ''//
        ''//    (Windows API manual 5.3.4.)
        ''//
        ''//    Save the setting in the OMR unit to change the strings below
        ''//
        ''//
        ''//	Check the followings on the process of setting
        ''//	MarkConf.iBackSideReading	: Backside reading(On/Off)
        ''//	MarkConf.iColumns			: The number of columns to be read
        ''//	MarkConf.iReadingMethod		: Reading method
        ''//	MarkConf.iCtrlMultiple		: (If iReading Method is "Control") Front or Back
        ''//	MarkConf.iThicknessType		: Paper thickness to be read

        MarkConf.iBackSideReading = SKDV_ENABLE                     '// Backside reading(Valid/Invalid)
        'MarkConf.iColumns = SKDV_COL_MAX                            '// The number of columns to be read(1-48)
        'MarkConf.iReadingMethod = SKDV_READ_DIRECT                  '// Reading method(Control(Front)/Control(back)/Direct/FACOM/Mark to Mark(Front edge or Front No edge)
        'MarkConf.iCtrlMultiple = SKDV_READ_EDGE_CTRL_MIN1           '// (If iReading Method is "Control" only ) Front or Back space (1-9times)
        'MarkConf.iThicknessType = SKDV_THICKNESS_90_KG              '// Paper thickness to be read(Automatic/55/72/90/110/135)


        '// Set the condition of Mark reading
        dwStatus = SkDv_SetMarkConf(hSkDevice, MarkConf)
        If (SKDV_STS_SUCCESS <> dwStatus) Then
            ErrorMessage("SkDv_SetMarkConf", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Setting Image reading
        '//--------------------------------------------------------

        '// Set the condition of Image reading if installed Image unit(CIS Sensor)
        If (SKDV_OPT_UNIT_IMAGE_1 And DeviceInfo.Main.dwOption) Then

            '// Get the condition of Image reading
            dwStatus = SkDv_GetImageConf(hSkDevice, ScanConf)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_GetImageConf", dwStatus)
                GoTo Termination
            End If

            ''//[NOTICE]
            ''//    Set the condition of Image reading
            ''//    Cancel the comment and change the contents if want change the setting
            ''//
            ''//    (Windows API manual 5.3.6.)
            ''//
            ''//    Save the setting in the OMR unit to change the strings below

            'ScanConf.iScanningSide = SKDV_SIDE_BOTH             '// Read Setting(no/both side/Front/back)
            'ScanConf.iLightColor(0) = SKDV_LIGHT_GRAYSCALE      '// Read light source(Front)(Color/Grayscale/R/G/B)
            'ScanConf.iLightColor(1) = SKDV_LIGHT_GRAYSCALE      '// Read light source(Back)(Color/Grayscale/R/G/B)
            ScanConf.iResoType = SKDV_RESO_TYPE_100DPI          '// Resolution(600dpi/300dpi/200dpi/150dpi/100dpi)

            '// Set the condition of Image reading
            dwStatus = SkDv_SetImageConf(hSkDevice, ScanConf)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SetImageConf", dwStatus)
                GoTo Termination
            End If
        End If

        '// Preprocessing roop
        Me.RICH_TEXT_BOX.Text = ""                  '// Clear RichTextBox
        dwImgError = 0                              '// Initialize dwImgError

        '// Continue rooping till hopper empty or error happen
        Do While True

            strTextBuffer = ""                      '// Clear TXT buffer

            GetFilePath(strFolderPath, strTime)     '// Get fullpath of file and time 

            strTextBuffer += String.Format("[Data_{0}.csv]", strTime) + vbCrLf  '// Store the output data

            '//--------------------------------------------------------
            '//  Reading
            '//--------------------------------------------------------

            '// Mark And Image Reading
            dwStatus = SkDv_ReqScanForm(hSkDevice)
            If (SKDV_STS_DEVICE_ST_Q1 = (dwStatus And SKDV_STS_DEVICE_STA_MASK)) Then
                MessageBox.Show("Hopper Empty", "Sk_Dv_Sample", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Do
            ElseIf (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                Exit Do
            End If

            '//--------------------------------------------------------
            '//  Output mark data
            '//--------------------------------------------------------

            '// Output mark data(front)
            strTextBuffer += "[Front MarkData]" + vbCrLf

            nBufSize = szMarks.Length              '// Initialize the size of buffer to store mark data
            dwStatus = SkDv_ReqGetMarks(hSkDevice, SKDV_FRONT, MarkInfo, szMarks(0), nBufSize)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                Exit Do
            End If

            strTextBuffer += OutputMarkData(MarkInfo, szMarks)          '// Store mark data to buffer

            '// If "Installed backside read unit" or "valid back side reading",
            '// Output mark data(back)
            If ((SKDV_OPT_UNIT_READER_B And DeviceInfo.Main.dwOption) And (MarkConf.iBackSideReading = SKDV_ENABLE)) Then
                strTextBuffer += "[Back MarkData]" + vbCrLf
                nBufSize = szMarks.Length          '// Initialize the size of buffer to store mark data
                dwStatus = SkDv_ReqGetMarks(hSkDevice, SKDV_BACK, MarkInfo, szMarks(0), nBufSize)
                If (SKDV_STS_SUCCESS <> dwStatus) Then
                    ErrorMessage("SkDv_ReqFeedMarkSheet", dwStatus)
                    GoTo Termination
                End If
                strTextBuffer += OutputMarkData(MarkInfo, szMarks)      '// Store mark data to buffer
            End If

            '//--------------------------------------------------------
            '//  Save Image(Multi thread)
            '//--------------------------------------------------------

            ''//[NOTICE]
            ''//	Set the condition save the Image Data
            ''//
            ''//	(Windows API manual 5.3.6.)
            ''//
            ''//	This setting is not saved to the OMR unit
            ImageData.iFace = SKDV_FRONT                        '// Set the saved image(Front/Back/Both)
            ImageData.rectCutout.left = 0                       '// Area setting to be captured(Left) [:mm]
            ImageData.rectCutout.top = 0                        '// Area setting to be captured(Top) [:mm]
            ImageData.rectCutout.right = 2159                   '// Area setting to be captured(Right) [:mm]
            ImageData.rectCutout.bottom = 3048                  '// Area setting to be captured(Bottom) [:mm]
            ImageData.iColorType = SKIM_IMAGE_GRAY              '// Color Setting(Black&White/Grayscale/Color)
            ImageData.iRotate = SKIM_IMAGE_ROTATE_0             '// Rotation(0/90/180/270)
            ImageData.iResolution = 100                         '// Resolution(300dpi/200dpi/150dpi/100dpi/50dpi)

            '// Set the image file type
            ImageFile.iEncoder = SKIM_ENCODE_BMP                '// Set File type(BMP/GIF/JPEG/PNG/TIFF)
            If (SKIM_ENCODE_JPEG = ImageFile.iEncoder) Then     '// Compressed(JPEG)(0-100)
                ImageFile.iParam = SKIM_ENCODE_JPEG_PRM_MAX
            End If
            If (SKIM_ENCODE_TIFF = ImageFile.iEncoder) Then     '// Compressed or NonCompressed(TIFF)(LZWCompression/NonCompression)
                ImageFile.iParam = SKIM_ENCODE_TIFF_PRM_LZW
            End If

            '// Change the extension of file name if change the file type
            strImageFileNameF = String.Format("{0}\ImageF_{1}.bmp", strFolderPath, strTime)  '// Output saved file name(front)
            dwStatus = SkDv_SaveImageDataThread(hSkDevice, ImageData, ImageFile, strImageFileNameF, _
                        CallBack.Invoke(ImageData, ImageFile, strImageFileNameF, dwStatus, dwImgError), 0)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SaveImageDataThread(Front)", dwStatus)
                Exit Do
            End If

            '// Change the extension of file name if change the file type
            ImageData.iFace = SKDV_BACK
            strImageFileNameB = String.Format("{0}\ImageB_{1}.bmp", strFolderPath, strTime)  '// Output saved file name(back)
            dwStatus = SkDv_SaveImageDataThread(hSkDevice, ImageData, ImageFile, strImageFileNameB, _
                        CallBack.Invoke(ImageData, ImageFile, strImageFileNameB, dwStatus, dwImgError), 0)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_SaveImageDataThread(Back)", dwStatus)
                Exit Do
            End If

            '//--------------------------------------------------------
            '//  Output image file name
            '//--------------------------------------------------------

            '// Change the extension of file name if change the file type
            strTextBuffer += "[ImageData]" + vbCrLf
            strTextBuffer += String.Format("ImageF_{0}.bmp", strTime) + vbCrLf
            strTextBuffer += String.Format("ImageB_{0}.bmp", strTime) + vbCrLf + vbCrLf

            '// Output the contents of TXT buffer to RichEditControl
            Me.RICH_TEXT_BOX.AppendText(strTextBuffer)

            '// Save TXT buffer to file
            '// Comment-out the following process if OMR operation is slow. 
            SaveTextBuffer(hSkDevice, strTextBuffer, strTime, strFolderPath)

            Me.Refresh()      '// Update Window
        Loop

        '//--------------------------------------------------------
        '//  Check the operation other threads
        '//--------------------------------------------------------

        '// Check finish other thread operation.
        '// If return of "SkDv_IsThreadRunning()" is TRUE, Check other thread,
        '// If FALSE, exit the roop
        Do While (1 = bCheckThread)
            bCheckThread = SkDv_IsThreadRunning(hSkDevice)
            System.Threading.Thread.Sleep(100)
        Loop

        '//--------------------------------------------------------
        '//  Output Error buffer
        '//--------------------------------------------------------

        '// Output if error on the process of save image file(multi thread) 
        If (SKDV_STS_SUCCESS <> dwImgError) Then
            ErrorMessage("SkDv_SaveImageDataThread", dwStatus)
            GoTo Termination
        End If

        '//--------------------------------------------------------
        '//  Finish
        '//--------------------------------------------------------

Termination:
        '// Close the device if open
        If (0 <> hSkDevice) Then
            dwStatus = SkDv_Close(hSkDevice)
            If (SKDV_STS_SUCCESS <> dwStatus) Then
                ErrorMessage("SkDv_Close", dwStatus)
            End If
        End If

    End Sub

    Private Sub B_QUIT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles B_QUIT.Click
        Dim iMessageID As Integer = 0       '// Return message box

        iMessageID = MessageBox.Show("Finish Sample program?","Sk_Dv_Sample", MessageBoxButtons.YesNo, MessageBoxIcon.Information)
        If (DialogResult.Yes = iMessageID) Then
            Me.Close()                      '// Finish Sample program
        End If
    End Sub

    '// String(format) display Error information
    Public Sub ErrorMessage(ByRef sFuncName As String, ByVal dwStatus As Integer)
        Dim strError As String

        strError = String.Format("{0} Error (0x{1:00000000})", sFuncName, Hex(dwStatus))
        MessageBox.Show(strError, "Sk_Dv_Sample", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    '// Strings(Function) to output mark data
    Public Function OutputMarkData(ByVal MarkInfo As SK_DV_MARK_INFO, ByRef pszMarks() As Byte) As String

        Dim nMarkLevel As Integer               '// Parameter to store the mark level
        Dim strMarkData As String = Nothing     '// mark data

        '// Strings(function) of output mark data
        If (Nothing <> pszMarks(0) And 4 < MarkInfo.iColumns) Then
            '// Output the header of columns
            strMarkData = ("   ,")
            For nColPosition As Integer = 0 To MarkInfo.iColumns - 1
                strMarkData += String.Format("{0:00},", (nColPosition + 1))
            Next nColPosition

            strMarkData += vbCrLf

            '// Output Mark data and header of the number of Row
            For nRowPosition As Integer = 0 To MarkInfo.iRows - 1
                strMarkData += String.Format("{0:000},", (nRowPosition + 1))
                For nColPosition As Integer = 0 To MarkInfo.iColumns - 1
                    nMarkLevel = pszMarks((nRowPosition * MarkInfo.iColumns) + nColPosition)
                    strMarkData += String.Format("{0:00},", nMarkLevel)
                Next nColPosition
                strMarkData += vbCrLf
            Next nRowPosition
        End If
        strMarkData += vbCrLf
        Return strMarkData
    End Function

    '// Strings(function) to make and output barcode
    Public Function OutputBarcodeData(ByRef nReadCount As Integer, ByRef sBcData(,) As Byte, ByVal sBcType() As Byte, ByVal nBcDataLen() As Integer) As String

        Dim strBcBuffer As String = Nothing         '// Buffer for imput data
        Dim strBcTypeString As String = Nothing     '// The string of Barcode type
        Dim strBcData As String                     '// TXT strings to store Barcode Data

        '// Output the barcode data read(MAX :10 barcodes)
        For i As Integer = 0 To (nReadCount - 1)
            strBcData = Nothing                     '// Initialize strBcData

            Select Case Chr(sBcType(i))

                Case "a"
                    strBcTypeString = "CODE-39"

                Case "b"
                    strBcTypeString = "ITF"

                Case "c"
                    strBcTypeString = "NW-7"

                Case "d"
                    strBcTypeString = "JAN/EAN/UPC"

                Case "e"
                    strBcTypeString = "CODE-128"

                Case "f"
                    strBcTypeString = "INDUSTRIAL 2OF5"

                Case "g"
                    strBcTypeString = "COOP 2OF5"

                Case "h"
                    strBcTypeString = "CODE-93"

                Case "@"
                Case Else
                    strBcTypeString = "UNKNOWN"

            End Select

            '// Conversion Barcode data(Byte array) to String array 
            For Length As Integer = 0 To nBcDataLen(i) - 1
                strBcData += Chr(sBcData(i, Length))
            Next Length

            strBcBuffer += String.Format("{0:00},{1,-15}:{2}", (i + 1), strBcTypeString, strBcData) + vbCrLf
        Next i
        Return strBcBuffer
    End Function

    '// Strings(function) to get file path and current time
    Public Sub GetFilePath(ByRef pstrFolderPath As String, ByRef pstrTime As String)
        Dim dtTime As DateTime = DateTime.Now

        pstrTime = dtTime.ToString("yyyyMMddHHmmssfff")                 '// Output current time to dtTime with designated strings
        pstrFolderPath = My.Application.Info.DirectoryPath.ToString()   '// Get the Folder path of Executed file
    End Sub

    '// Output txt buffer by CSV file
    '// Need cszTime and szFullPath while set the filename
    Public Sub SaveTextBuffer(ByVal hSkDevice As Integer, ByVal strTextBuffer As String, ByRef strTime As String, ByRef strFolderPath As String)
        Dim SWriter As System.IO.StreamWriter = Nothing
        Dim strDataFileName As String      '// File name of Data

        strDataFileName = strFolderPath + "\Data_" + strTime + ".csv"

        Try
            SWriter = New System.IO.StreamWriter(strDataFileName, True)
            SWriter.Write(strTextBuffer)
        Finally
            If Not (SWriter Is Nothing) Then
                SWriter.Close()
            End If
        End Try
    End Sub
End Class

'//=========================================================
'//	Sample Program End
'//=========================================================