Option Explicit On
Public Module SkDvSr3500Err
    '//*************+***************+***************+***************+***************+
    '//
    '//	SEKONIC
    '//	Device control Error code header
    '//
    '//	FileName	: SkDvSr3500Err.h
    '//	CPU			: x86
    '//	Compiler	: Microsoft Visual C++ 6.0 or later
    '//
    '//*************+***************+***************+***************+***************+
    '// 2012.03.15  for New Sample Program
    '//	2012.01.11	Into English
    '//	2011.10.27	for SR-3500 HYBRID
    '//*************+***************+***************+***************+***************+


    '//*************+***************+***************+***************+***************+
    '//	define / typedef
    '//*************+***************+***************+***************+***************+

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Status info  Lib "SkDvSr3500Img.dll" (SkDvStatus)
    Public Const SKDV_STS_MODULE_MASK = &HFFFF0000          '// Bit mask of Module definition sector
    Public Const SKDV_STS_MODULE = &H20310000               '// This module
    Public Const SKDV_STS_MODULE_IO = &H20210000            '// The lower basic communication library
    Public Const SKDV_STS_DEVICE_ERR = &H20020000           '// Error from Device


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    Public Const SKDV_STS_SUCCESS = &H0                     '// Success

    Public Const SKDV_STS_EXECUTE_ERR = &H20310001          '// WindowAPI Execution error
    Public Const SKDV_STS_CREATE_EVENT_ERR = &H20310006     '// Create Event Error
    Public Const SKDV_STS_CREATE_THREAD_ERR = &H20310007    '// Create Thread Error
    Public Const SKDV_STS_WAIT_TIMEOUT = &H2031000F         '// Timeout

    Public Const SKDV_STS_HANDLE_ERR = &H20311001           '// Handle Error
    Public Const SKDV_STS_MEM_ALLOC_ERR = &H20311002        '// Memory Allocation Error
    Public Const SKDV_STS_LOAD_SUBLIB_ERR = &H20311003      '// Load Sub library Error

    Public Const SKDV_STS_PARAM_ERR = &H20311010            '// Parameter Incorrect
    Public Const SKDV_STS_PARAM_ERR1 = &H20311011           '// Parameter 1 Incorrect
    Public Const SKDV_STS_PARAM_ERR2 = &H20311012           '// Parameter 2 Incorrect
    Public Const SKDV_STS_PARAM_ERR3 = &H20311013           '// Parameter 3 Incorrect
    Public Const SKDV_STS_PARAM_ERR4 = &H20311014           '// Parameter 4 Incorrect
    Public Const SKDV_STS_PARAM_ERR5 = &H20311015           '// Parameter 5 Incorrect
    Public Const SKDV_STS_PARAM_ERR6 = &H20311016           '// Parameter 6 Incorrect
    Public Const SKDV_STS_PARAM_ERR7 = &H20311017           '// Parameter 7 Incorrect
    Public Const SKDV_STS_PARAM_ERR8 = &H20311018           '// Parameter 8 Incorrect
    Public Const SKDV_STS_PARAM_ERR9 = &H20311019           '// Parameter 9 Incorrect
    Public Const SKDV_STS_FUNCTION_ERR = &H2031101F         '// API Function Error

    Public Const SKDV_STS_PARAM_ERR_SCANNINGSIDE = &H20311011   '// Parameter Error Back side scanning
    Public Const SKDV_STS_PARAM_ERR_SCAN_CTRL = &H20311012      '// Parameter Error Scanning Control
    '//	Public Const	SKDV_STS_PARAM_ERR_FEED_CTRL    = &H20311013	'//  Lib "SkDvSr3500Img.dll" (Reserved)Parameter Error Feed Control
    '//	Public Const	SKDV_STS_PARAM_ERR_THICKNESS	= &H20311014    '//  Lib "SkDvSr3500Img.dll" (Reserved)Parameter Error Thickness
    Public Const SKDV_STS_PARAM_ERR_FORMLENGTH_MAX = &H20311014 '// Parameter Error MAX Form Length
    Public Const SKDV_STS_PARAM_ERR_FORMLENGTH_MIN = &H20311015 '// Parameter Error MIN Form Length
    Public Const SKDV_STS_PARAM_ERR_CIS_LIGHT = &H20311016      '// CIS Light Incorrect Lib "SkDvSr3500Img.dll" (+iFace)
    Public Const SKDV_STS_PARAM_ERR_CIS_LIGHT_F = &H20311016    '// CIS Light Incorrect  Lib "SkDvSr3500Img.dll" (F)
    Public Const SKDV_STS_PARAM_ERR_CIS_LIGHT_B = &H20311017    '// CIS Light Incorrect Lib "SkDvSr3500Img.dll" (B)
    Public Const SKDV_STS_PARAM_ERR_RESOLUTION = &H20311018     '// Resolution Incorrect
    '//	Public Const	SKDV_STS_PARAM_ERR_RESOLUTION_V = &H20311019    '//  Lib "SkDvSr3500Img.dll" (Reserved)Resolution Incorrect

    '//	Public Const	SKDV_STS_INTERFACE_ERR  = &H20311020	    	'//  Lib "SkDvSr3500Img.dll" (Reserved)Interface error
    Public Const SKDV_STS_CIS_BASE_DATA_ERR = &H20311021    '// CIS Base data Incorrect

    Public Const SKDV_STS_NO_DATA = &H20311100              '// No Data
    '//	Public Const SKDV_STS_ADJ_SHADE_ERR = &H20311101    '//  Lib "SkDvSr3500Img.dll" (Reserved)
    Public Const SKDV_STS_ROTATION_ERR = &H20311102         '// Rotation Error

    Public Const SKDV_STS_IMAGE_PROCESS_ERR = &H203111FF    '// Image Process Error

    Public Const SKDV_STS_FILE_ERR = &H20311200             '// File Error
    Public Const SKDV_STS_FILE_SAVE_ERR = &H20311201        '// File Save Error
    Public Const SKDV_STS_FILE_LOAD_ERR = &H20311211        '// File Load Error
    Public Const SKDV_STS_FILE_FORMAT_ERR = &H20311231      '// File Format Error

    '//	Public Const SKDV_STS_DV_IMAGE_ERR	=   &H2031130X	'// Image data error  Lib "SkDvSr3500Img.dll" (from OMR device)
    Public Const SKDV_STS_DV_IMAGE_ERR = &H20311301         '// Failure image data Transfer  Lib "SkDvSr3500Img.dll" (from OMR device)
    '//	Public Const SKDV_STS_DV_IMAGE_SHORTAGE	    = &H20311301    '//  Lib "SkDvSr3500Img.dll" (Reserved)
    '//	Public Const SKDV_STS_DV_IMAGE_OVER_LEN		= &H20311302    '//  Lib "SkDvSr3500Img.dll" (Reserved)
    '//	Public Const SKDV_STS_DV_IMAGE_ERR_UNKNOWN	= &H2031130F    '//  Lib "SkDvSr3500Img.dll" (Reserved)

    '//	Public Const SKDV_STS_IMAGE_DATA_ERR        = &H2031131X    '// Image Data error
    Public Const SKDV_STS_NO_IMAGE = &H20311311             '// No Image
    Public Const SKDV_STS_OVER_LENGTH_IMAGE = &H20311312    '// Image data Overloaded
    Public Const SKDV_STS_DIFF_IMAGE_WIDTH = &H20311313     '// Image Width Different
    Public Const SKDV_STS_DIFF_IMAGE_HEIGHT = &H20311314    '// Image Height different
    Public Const SKDV_STS_IMAGE_LENGTH_ERR = &H20311315     '// Image Length Error

    '//	Public Const	SKDV_STS_RECVED_NAK	= &H2031210X    '// NAKreceived
    Public Const SKDV_STS_RECVED_NAK_CMD = &H20312101       '// NAKreceived  Lib "SkDvSr3500Img.dll" (Command Error)
    Public Const SKDV_STS_RECVED_NAK_PRM = &H20312102       '// NAKreceived  Lib "SkDvSr3500Img.dll" (Parameter Error)
    Public Const SKDV_STS_RECVED_NAK_NON = &H20312103       '// NAKreceived  Lib "SkDvSr3500Img.dll" (Non Support)
    Public Const SKDV_STS_RECVED_NAK_OPE = &H20312104       '// NAKreceived  Lib "SkDvSr3500Img.dll" (LCD panel operation)
    Public Const SKDV_STS_RECVED_NAK_DOING = &H20312105     '// NAKreceived  Lib "SkDvSr3500Img.dll" (Operating unit)
    Public Const SKDV_STS_RECVED_NAK_UNKNOWN = &H2031210F   '// NAKreceived  Lib "SkDvSr3500Img.dll" (Unknown)

    Public Const SKDV_STS_RECV_ACK_TIMEOUT = &H20312200     '// Timeout  Lib "SkDvSr3500Img.dll" (ACKreceived)
    Public Const SKDV_STS_RECV_RES_TIMEOUT = &H20312201     '// Timeout  Lib "SkDvSr3500Img.dll" (Response received)
    Public Const SKDV_STS_DIFF_ACK_CMD = &H20312210         '// CMD code of ACK is Different
    Public Const SKDV_STS_DIFF_RES_CMD = &H20312211         '// CMD code of response is Different
    Public Const SKDV_STS_SHORT_RESPONSE_ERR = &H20312220   '// The length of response is short
    Public Const SKDV_STS_LONG_RESPONSE_ERR = &H20312221    '// The length of response is long
    Public Const SKDV_STS_RESPONSE_FORMAT_ERR = &H20312222  '// Incorrect response format
    Public Const SKDV_STS_DIFF_PRM = &H20312223             '// Different Parameter

    '//	Public Const	SKDV_STS_CALIB	= &H203130XX		'// Calibration Error
    Public Const SKDV_STS_CALIB = &H20313000                '// Calibration Error
    Public Const SKDV_STS_CALIB_MASK = &HFFFFFF00           '// Bit mask of Calibration Error
    '// Backgraund check
    Public Const SKDV_STS_CALIB_CHK_BG_EVEN_BL_F_ERR = &H20313010       '// Different the data when LED off  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CHK_BG_EVEN_BL_B_ERR = &H20313011       '// Different the data when LED off  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CHK_BG_EVEN_WH_F_ERR = &H20313012       '// Different the data when LED On  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CHK_BG_EVEN_WH_B_ERR = &H20313013       '// Different the data when LED On  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CHK_BG_DIFF_F_ERR = &H20313014          '// Gap is big between LED ON / OFF  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CHK_BG_DIFF_B_ERR = &H20313015          '// Gap is big between LED ON / OFF  Lib "SkDvSr3500Img.dll" (Back)
    '// CIS base level check Lib "SkDvSr3500Img.dll" (scattering)
    Public Const SKDV_STS_CALIB_CIS_BS_BLACK_EVEN_F_ERR = &H20313020    '// Difference Black Level  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_BLACK_EVEN_B_ERR = &H20313021    '// Difference Black Level  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CIS_BS_WHITE_EVEN_F_ERR = &H20313022    '// Difference White Level  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_WHITE_EVEN_B_ERR = &H20313023    '// Difference White Level  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CIS_BS_RED_EVEN_F_ERR = &H20313024      '// Difference Red Level  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_RED_EVEN_B_ERR = &H20313025      '// Difference Red Level  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CIS_BS_GREEN_EVEN_F_ERR = &H20313026    '// Difference Green Level  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_GREEN_EVEN_B_ERR = &H20313027    '// Difference Green Level  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CIS_BS_BLUE_EVEN_F_ERR = &H20313028     '// Difference Blue Level  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_BLUE_EVEN_B_ERR = &H20313029     '// Difference Blue Level  Lib "SkDvSr3500Img.dll" (Back)
    '// CIS base level check Lib "SkDvSr3500Img.dll" (value)
    Public Const SKDV_STS_CALIB_CIS_BS_BLACK_UPPER_F_ERR = &H20313030   '// Black Level Max  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_BLACK_UPPER_B_ERR = &H20313031   '// Black Level Max  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CIS_BS_WHITE_RANGE_F_ERR = &H20313032   '// White Level calibration Range  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_WHITE_RANGE_B_ERR = &H20313033   '// White Level Calibration Range  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CIS_BS_RED_RANGE_F_ERR = &H20313034     '// Red Level calibration Range  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_RED_RANGE_B_ERR = &H20313035     '// Red Level calibration Range  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CIS_BS_GREEN_RANGE_F_ERR = &H20313036   '// Green Level calibration Range  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_GREEN_RANGE_B_ERR = &H20313037   '// Green Level calibration Range  Lib "SkDvSr3500Img.dll" (Back)
    Public Const SKDV_STS_CALIB_CIS_BS_BLUE_RANGE_F_ERR = &H20313038    '// Blue Level calibration Range  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CIS_BS_BLUE_RANGE_B_ERR = &H20313039    '// Blue Level calibration Range  Lib "SkDvSr3500Img.dll" (Back)
    '// Platen check
    Public Const SKDV_STS_CALIB_CHK_PL_UPPER_F_ERR = &H20313040         '// Platen detects too White  Lib "SkDvSr3500Img.dll" (Front)
    Public Const SKDV_STS_CALIB_CHK_PL_UPPER_B_ERR = &H20313041         '// Platen detects too White  Lib "SkDvSr3500Img.dll" (Back)

    '//	Public Const	SKDV_STS_CALIB_LEFTSKEW		= &H203131XX		'// Left Skew Level Calibration Error
    Public Const SKDV_STS_CALIB_LS_UPPER_LEVEL_ERR = &H20313101         '// Left Skew Level High
    Public Const SKDV_STS_CALIB_LS_UNDER_LEVEL_ERR = &H20313102         '// Left Skew Level Low


    '//	Public Const	SKDV_STS_USER				= &H2031fXXX		'// User operation
    Public Const SKDV_STS_USER_CANCEL = &H2031F001                      '// User Cancel


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SR-Series
    '//-----+-------+-------+-------+-------+-------+-------+-------+
    Public Const SKDV_STS_DEVICE_ST_MASK = &HFFFFF800                   '// Bit mask of status code from the device
    Public Const SKDV_STS_DEVICE_STA_MASK = &HFFFFFF80                  '// Bit mask of status code from the device
    Public Const SKDV_STS_DEVICE_FACE_MASK = &H60                       '// Bit mask of information from the device front and back
    Public Const SKDV_STS_DEVICE_DIF_MASK = &H1F                        '// Bit mask for detailed information from the device

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '//								    = &Hffffff80	    '// Bit mask of status code from the device
    '// "A*"Main unit
    Public Const SKDV_STS_DEVICE_ST_A1 = &H20020880         '// "A1"Memory Error 1  Lib "SkDvSr3500Img.dll" (Internal Memory Error)
    Public Const SKDV_STS_DEVICE_ST_A2 = &H20020900         '// "A2"Memory Error 2  Lib "SkDvSr3500Img.dll" (Internal Memory Error)
    Public Const SKDV_STS_DEVICE_ST_A3 = &H20020980         '// "A3"Hopper Drive Error
    Public Const SKDV_STS_DEVICE_ST_A4 = &H20020A00         '// "A4"Download Error  Lib "SkDvSr3500Img.dll" (Main Unit)
    Public Const SKDV_STS_DEVICE_ST_A5 = &H20020A80         '// "A5"Sensor Type Error
    Public Const SKDV_STS_DEVICE_ST_A6 = &H20020B00         '// "A6"Option Error
    Public Const SKDV_STS_DEVICE_ST_A8 = &H20020C00         '// "A8"Power Supply Error
    '// "B*"Reading unit
    Public Const SKDV_STS_DEVICE_ST_B1 = &H20021080         '// "B1"Communication Error
    Public Const SKDV_STS_DEVICE_ST_B2 = &H20021100         '// "B2"Internal COM Error  Lib "SkDvSr3500Img.dll" (No response Read Sensor)
    Public Const SKDV_STS_DEVICE_ST_B3 = &H20021180         '// "B3"Memory Error  Lib "SkDvSr3500Img.dll" (in Read Sensor) 
    Public Const SKDV_STS_DEVICE_ST_B4 = &H20021200         '// "B4"Adjust Value Error  Lib "SkDvSr3500Img.dll" (Read Sensor)
    Public Const SKDV_STS_DEVICE_ST_B5 = &H20021280         '// "B5"Download Error  Lib "SkDvSr3500Img.dll" (Read Sensor)  
    Public Const SKDV_STS_DEVICE_ST_B6 = &H20021300         '// "B6"Internal Error  Lib "SkDvSr3500Img.dll" (Read Sensor)
    Public Const SKDV_STS_DEVICE_ST_B7 = &H20021380         '// "B7"Version Error Lib "SkDvSr3500Img.dll" (Read Sensor) 
    '// "C*"Barcode unit
    Public Const SKDV_STS_DEVICE_ST_C1 = &H20021880         '// "C1"Communication Error  Lib "SkDvSr3500Img.dll" (Barcode Unit)
    Public Const SKDV_STS_DEVICE_ST_C2 = &H20021900         '// "C2"Internal COM Error  Lib "SkDvSr3500Img.dll" (Barcode Unit)
    Public Const SKDV_STS_DEVICE_ST_C3 = &H20021980         '// "C3"Memory Error  Lib "SkDvSr3500Img.dll" (Barcode Unit)
    Public Const SKDV_STS_DEVICE_ST_C4 = &H20021A00         '// "C4"Sensor Error  Lib "SkDvSr3500Img.dll" (Barcode Unit)
    Public Const SKDV_STS_DEVICE_ST_C5 = &H20021A80         '// "C5"Download Error  Lib "SkDvSr3500Img.dll" (Barcode Unit)
    Public Const SKDV_STS_DEVICE_ST_C6 = &H20021B00         '// "C6"Internal Error  Lib "SkDvSr3500Img.dll" (Barcode Unit)
    Public Const SKDV_STS_DEVICE_ST_C7 = &H20021B80         '// "C7"Version Error  Lib "SkDvSr3500Img.dll" (Barcode Unit)
    '// "D*"Printer unit
    Public Const SKDV_STS_DEVICE_ST_D1 = &H20022080         '// "D1"Communication Error Lib "SkDvSr3500Img.dll" (Printer Unit)
    Public Const SKDV_STS_DEVICE_ST_D2 = &H20022100         '// "D2"Internal COM Error  Lib "SkDvSr3500Img.dll" (Printer Unit)
    Public Const SKDV_STS_DEVICE_ST_D3 = &H20022180         '// "D3"Memory Error  Lib "SkDvSr3500Img.dll" (Printer Unit)
    Public Const SKDV_STS_DEVICE_ST_D4 = &H20022200         '// "D4"Download Error  Lib "SkDvSr3500Img.dll" (Printer Unit)
    Public Const SKDV_STS_DEVICE_ST_D5 = &H20022280         '// "D5"Internal Error  Lib "SkDvSr3500Img.dll" (Printer Unit)
    Public Const SKDV_STS_DEVICE_ST_D6 = &H20022300         '// "D6"Version Error  Lib "SkDvSr3500Img.dll" (Printer Unit)
    '// "E*"Stacker unit
    Public Const SKDV_STS_DEVICE_ST_E1 = &H20022880         '// "E1"Communication Error  Lib "SkDvSr3500Img.dll" (Stacker Unit)
    Public Const SKDV_STS_DEVICE_ST_E2 = &H20022900         '// "E2"Internal COM Error  Lib "SkDvSr3500Img.dll" (Stacker Unit)
    Public Const SKDV_STS_DEVICE_ST_E3 = &H20022980         '// "E3"Memory Error  Lib "SkDvSr3500Img.dll" (Stacker Unit)
    Public Const SKDV_STS_DEVICE_ST_E4 = &H20022A00         '// "E4"Download Error  Lib "SkDvSr3500Img.dll" (Stacker Unit)
    Public Const SKDV_STS_DEVICE_ST_E5 = &H20022A80         '// "E5"Internal Error  Lib "SkDvSr3500Img.dll" (Stacker Unit)
    Public Const SKDV_STS_DEVICE_ST_E6 = &H20022B00         '// "E6"Version Error  Lib "SkDvSr3500Img.dll" (Stacker Unit)
    '// "J*"Image reading unit
    Public Const SKDV_STS_DEVICE_ST_J1 = &H20025080         '// "J1"Download Error  Lib "SkDvSr3500Img.dll" (Image Sensor Unit) 
    Public Const SKDV_STS_DEVICE_ST_J2 = &H20025100         '// "J2"Internal COM Error 1  Lib "SkDvSr3500Img.dll" (Image Sensor Unit)
    Public Const SKDV_STS_DEVICE_ST_J3 = &H20025180         '// "J3"Internal COM Error 1  Lib "SkDvSr3500Img.dll" (Image Sensor Unit)
    Public Const SKDV_STS_DEVICE_ST_J4 = &H20025200         '// "J4"Memory Error 1  Lib "SkDvSr3500Img.dll" (Image Sensor Unit / Flash Rom Read Error) 
    Public Const SKDV_STS_DEVICE_ST_J5 = &H20025280         '// "J5"Memory Error 2  Lib "SkDvSr3500Img.dll" (Image Sensor Unit / Flash Rom Load Error)  
    Public Const SKDV_STS_DEVICE_ST_J6 = &H20025300         '// "J6"Memory Error 3  Lib "SkDvSr3500Img.dll" (Image Sensor Unit / E2PROM Read Error)
    Public Const SKDV_STS_DEVICE_ST_J7 = &H20025380         '// "J7"Memory Error 4  Lib "SkDvSr3500Img.dll" (Image Sensor Unit / E2PROM Load Error) 
    Public Const SKDV_STS_DEVICE_ST_J8 = &H20025400         '// "J8"IC Error  Lib "SkDvSr3500Img.dll" (Image Sensor Unit)
    Public Const SKDV_STS_DEVICE_ST_J9 = &H20025480         '// "J9"CIS Error  Lib "SkDvSr3500Img.dll" (Image Sensor Unit)
    Public Const SKDV_STS_DEVICE_ST_K1 = &H20025880         '// "K1"FPGA Error  Lib "SkDvSr3500Img.dll" (Image Sensor Unit) 
    Public Const SKDV_STS_DEVICE_ST_K2 = &H20025900         '// "K2"Power Supply Error  Lib "SkDvSr3500Img.dll" (Image Sensor Unit) 
    Public Const SKDV_STS_DEVICE_ST_K3 = &H20025980         '// "K3"Version Error  Lib "SkDvSr3500Img.dll" (Image Sensor Unit) 
    '// "F*"Communication error
    Public Const SKDV_STS_DEVICE_ST_F5 = &H20023280         '// "F5"Command Error
    Public Const SKDV_STS_DEVICE_ST_F6 = &H20023300         '// "F6"Parameter Error
    Public Const SKDV_STS_DEVICE_ST_F7 = &H20023380         '// "F7"Protocol Error
    '// "G*"Cover open
    Public Const SKDV_STS_DEVICE_ST_G1 = &H20023880         '// "G1"Cover Open 
    Public Const SKDV_STS_DEVICE_ST_G2 = &H20023900         '// "G2"Stacker Unit Cover Open
    '// "H*"Jam
    Public Const SKDV_STS_DEVICE_ST_H1 = &H20024080         '// "H1"No Feed
    Public Const SKDV_STS_DEVICE_ST_H2 = &H20024100         '// "H2"Jam at Paper Feeding Detection Sensor 
    Public Const SKDV_STS_DEVICE_ST_H3 = &H20024180         '// "H3"Jam at Reading Start Detection Sensor 
    Public Const SKDV_STS_DEVICE_ST_H4 = &H20024200         '// "H4"Jam at Main body Paper Discharge Detection Sensor
    '// "I*"Stacker unit Jam
    Public Const SKDV_STS_DEVICE_ST_I1 = &H20024880         '// "I1"Jam at Printing Start Detection Sensor
    Public Const SKDV_STS_DEVICE_ST_I2 = &H20024900         '// "I2"Jam at Main Paper Discharge Sensor
    Public Const SKDV_STS_DEVICE_ST_I3 = &H20024980         '// "I3"Jam at Selected  Lib "SkDvSr3500Img.dll" (Reject) Paper Discharge Sensor
    '// "P*"
    Public Const SKDV_STS_DEVICE_ST_P1 = &H20028080         '// "P1"Back Surface Reading Unit Unconnected
    Public Const SKDV_STS_DEVICE_ST_P2 = &H20028100         '// "P2"Barcode Unit Unconnected
    Public Const SKDV_STS_DEVICE_ST_P3 = &H20028180         '// "P3"Printer Unit Unconnected
    Public Const SKDV_STS_DEVICE_ST_P4 = &H20028200         '// "P4"Select Stacker Unit Unconnected
    Public Const SKDV_STS_DEVICE_ST_P5 = &H20028280         '// "P5"Image Sensor Unit Unconnected
    '// "Q*"
    Public Const SKDV_STS_DEVICE_ST_Q1 = &H20028880         '// "Q1"Sheet Empty
    Public Const SKDV_STS_DEVICE_ST_Q2 = &H20028900         '// "Q2"Double Feed Error
    Public Const SKDV_STS_DEVICE_ST_Q3 = &H20028980         '// "Q3"Left End Skew Error
    Public Const SKDV_STS_DEVICE_ST_Q4 = &H20028A00         '// "Q4"Mark Skew Error
    '// "R*"
    Public Const SKDV_STS_DEVICE_ST_R1 = &H20029080         '// "R1"Hopper Stops
    Public Const SKDV_STS_DEVICE_ST_R2 = &H20029100         '// "R2"Drowing Out Error
    Public Const SKDV_STS_DEVICE_ST_R3 = &H20029180         '// "R3"Timeout
    Public Const SKDV_STS_DEVICE_ST_R4 = &H20029200         '// "R4"Timing Mark Error
    Public Const SKDV_STS_DEVICE_ST_R5 = &H20029280         '// "R5"Setting Error
    Public Const SKDV_STS_DEVICE_ST_R6 = &H20029300         '// "R6"Memory Overflow
    '// "S*"
    Public Const SKDV_STS_DEVICE_ST_S2 = &H20029900         '// "S2"Black Level Error
    Public Const SKDV_STS_DEVICE_ST_S3 = &H20029980         '// "S3"Read Sensor Stain Error
    Public Const SKDV_STS_DEVICE_ST_S4 = &H20029A00         '// "S4"Skew Sensor Stain Error
    '// "T*"
    Public Const SKDV_STS_DEVICE_ST_T1 = &H2002A080         '// "T1"Form Left In Hopper
    Public Const SKDV_STS_DEVICE_ST_T2 = &H2002A100         '// "T2"Form Left in Reading Sensor
    Public Const SKDV_STS_DEVICE_ST_T3 = &H2002A180         '// "T3"Form Left in End of Main Body
    Public Const SKDV_STS_DEVICE_ST_T4 = &H2002A200         '// "T4"Form Left in Printer Printing Detection Sensor
    Public Const SKDV_STS_DEVICE_ST_T5 = &H2002A280         '// "T5"Form Left in Main paper Discharge Sensor
    Public Const SKDV_STS_DEVICE_ST_T6 = &H2002A300         '// "T6"Form Left in Selected  Lib "SkDvSr3500Img.dll" (Reject) Paper Discharge Sensor
    '// "Z*"
    Public Const SKDV_STS_DEVICE_ST_Z1 = &H2002D080         '// "Z1"Density adjust Skew Error
    Public Const SKDV_STS_DEVICE_ST_Z2 = &H2002D100         '// "Z2"Density adjust Sheet Error
    Public Const SKDV_STS_DEVICE_ST_Z3 = &H2002D180         '// "Z3"Dirt Density adjust Sheet
    Public Const SKDV_STS_DEVICE_ST_Z4 = &H2002D200         '// "Z4"Density adjust Error
    Public Const SKDV_STS_DEVICE_ST_Z5 = &H2002D280         '// "Z5"RDPS adjust Error
    Public Const SKDV_STS_DEVICE_ST_Z6 = &H2002D300         '// "Z6"Skew Sensor Adjust Error
    Public Const SKDV_STS_DEVICE_ST_Z7 = &H2002D380         '// "Z7"DF sensor Adjust Error


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '//												= &Hfffff800
    Public Const SKDV_STS_DEVICE_STS1_NONE = &H20020000     '// "0*"
    Public Const SKDV_STS_DEVICE_STS1_A = &H20020800        '// "A*"
    Public Const SKDV_STS_DEVICE_STS1_B = &H20021000        '// "B*"
    Public Const SKDV_STS_DEVICE_STS1_C = &H20021800        '// "C*"
    Public Const SKDV_STS_DEVICE_STS1_D = &H20022000        '// "D*"
    Public Const SKDV_STS_DEVICE_STS1_E = &H20022800        '// "E*"
    Public Const SKDV_STS_DEVICE_STS1_F = &H20023000        '// "F*"
    Public Const SKDV_STS_DEVICE_STS1_G = &H20023800        '// "G*"
    Public Const SKDV_STS_DEVICE_STS1_H = &H20024000        '// "H*"
    Public Const SKDV_STS_DEVICE_STS1_I = &H20024800        '// "I*"
    Public Const SKDV_STS_DEVICE_STS1_J = &H20025000        '// "J*"
    Public Const SKDV_STS_DEVICE_STS1_K = &H20025800        '// "K*"
    Public Const SKDV_STS_DEVICE_STS1_L = &H20026000        '// "L*"
    Public Const SKDV_STS_DEVICE_STS1_M = &H20026800        '// "M*"
    Public Const SKDV_STS_DEVICE_STS1_N = &H20027000        '// "N*"
    Public Const SKDV_STS_DEVICE_STS1_O = &H20027800        '// "O*"
    Public Const SKDV_STS_DEVICE_STS1_P = &H20028000        '// "P*"
    Public Const SKDV_STS_DEVICE_STS1_Q = &H20028800        '// "Q*"
    Public Const SKDV_STS_DEVICE_STS1_R = &H20029000        '// "R*"
    Public Const SKDV_STS_DEVICE_STS1_S = &H20029800        '// "S*"
    Public Const SKDV_STS_DEVICE_STS1_T = &H2002A000        '// "T*"
    Public Const SKDV_STS_DEVICE_STS1_U = &H2002A800        '// "U*"
    Public Const SKDV_STS_DEVICE_STS1_V = &H2002B000        '// "V*"
    Public Const SKDV_STS_DEVICE_STS1_W = &H2002B800        '// "W*"
    Public Const SKDV_STS_DEVICE_STS1_X = &H2002C000        '// "X*"
    Public Const SKDV_STS_DEVICE_STS1_Y = &H2002C800        '// "Y*"
    Public Const SKDV_STS_DEVICE_STS1_Z = &H2002D000        '// "Z*"
    Public Const SKDV_STS_DEVICE_STS1_AT = &H2002F800       '// "@*"

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    Public Const SKDV_STS_DEVICE_STS2_0 = &H0               '// "*0"
    Public Const SKDV_STS_DEVICE_STS2_1 = &H80              '// "*1"
    Public Const SKDV_STS_DEVICE_STS2_2 = &H100             '// "*2"
    Public Const SKDV_STS_DEVICE_STS2_3 = &H180             '// "*3"
    Public Const SKDV_STS_DEVICE_STS2_4 = &H200             '// "*4"
    Public Const SKDV_STS_DEVICE_STS2_5 = &H280             '// "*5"
    Public Const SKDV_STS_DEVICE_STS2_6 = &H300             '// "*6"
    Public Const SKDV_STS_DEVICE_STS2_7 = &H380             '// "*7"
    Public Const SKDV_STS_DEVICE_STS2_8 = &H400             '// "*8"
    Public Const SKDV_STS_DEVICE_STS2_9 = &H480             '// "*9"
    Public Const SKDV_STS_DEVICE_STS2_AT = &H780            '// "*@"

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '//									= &H00000060		'// Information from side of the device
    Public Const SKDV_STS_DEVICE_FACE_BOTH = &H0            '// Both
    Public Const SKDV_STS_DEVICE_FACE_FRONT = &H20          '// Front
    Public Const SKDV_STS_DEVICE_FACE_BACK = &H40           '// Back
    Public Const SKDV_STS_DEVICE_FACE_SAME = &H60           '// Same

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '//									= &H0000001f		'// More information from the device
    Public Const SKDV_STS_DEVICE_DIF_NONE = &H0             '// "0"
    Public Const SKDV_STS_DEVICE_DIF_A = &H1                '// "A"
    Public Const SKDV_STS_DEVICE_DIF_B = &H2                '// "B"
    Public Const SKDV_STS_DEVICE_DIF_C = &H3                '// "C"
    Public Const SKDV_STS_DEVICE_DIF_D = &H4                '// "D"
    Public Const SKDV_STS_DEVICE_DIF_E = &H5                '// "E"
    Public Const SKDV_STS_DEVICE_DIF_F = &H6                '// "F"
    Public Const SKDV_STS_DEVICE_DIF_G = &H7                '// "G"
    Public Const SKDV_STS_DEVICE_DIF_H = &H8                '// "H"
    Public Const SKDV_STS_DEVICE_DIF_I = &H9                '// "I"
    Public Const SKDV_STS_DEVICE_DIF_J = &HA                '// "J"
    Public Const SKDV_STS_DEVICE_DIF_K = &HB                '// "K"
    Public Const SKDV_STS_DEVICE_DIF_L = &HC                '// "L"
    Public Const SKDV_STS_DEVICE_DIF_M = &HD                '// "M"
    Public Const SKDV_STS_DEVICE_DIF_N = &HE                '// "N"
    Public Const SKDV_STS_DEVICE_DIF_O = &HF                '// "O"
    Public Const SKDV_STS_DEVICE_DIF_P = &H10               '// "P"
    Public Const SKDV_STS_DEVICE_DIF_Q = &H11               '// "Q"
    Public Const SKDV_STS_DEVICE_DIF_R = &H12               '// "R"
    Public Const SKDV_STS_DEVICE_DIF_S = &H13               '// "S"
    Public Const SKDV_STS_DEVICE_DIF_T = &H14               '// "T"
    Public Const SKDV_STS_DEVICE_DIF_U = &H15               '// "U"
    Public Const SKDV_STS_DEVICE_DIF_V = &H16               '// "V"
    Public Const SKDV_STS_DEVICE_DIF_W = &H17               '// "W"
    Public Const SKDV_STS_DEVICE_DIF_X = &H18               '// "X"
    Public Const SKDV_STS_DEVICE_DIF_Y = &H19               '// "Y"
    Public Const SKDV_STS_DEVICE_DIF_Z = &H1A               '// "Z"
    Public Const SKDV_STS_DEVICE_DIF_AT = &H1F              '// "@"

End Module
