Option Explicit On
Imports System.Runtime.InteropServices
Public Module SkDvSr3500Prm
    '//*************+***************+***************+***************+***************+
    '//
    '//	SEKONIC
    '//	Device control Parameter header
    '//
    '//	FileName	: SkDvSr3500Prm.h
    '//	CPU			: x86
    '//	Compiler	: Microsoft Visual C++ 6.0 or later
    '//
    '//*************+***************+***************+***************+***************+
    '// 2012.03.15  for New Sample Program
    '//	2012.01.11	Into English
    '//	2011.10.27	for SR-3500 HYBRID
    '//*************+***************+***************+***************+***************+

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// dot,meter
    Public Const DPI600_PPM = 23622 '// Pixels per meter (600dpi)	= 23622.047 = 600/0.0254
    Public Const DPI300_PPM = 11811 '// Pixels per meter (300dpi)	= 11811.024 = 300/0.0254
    Public Const DPI200_PPM = 7874  '// Pixels per meter (200dpi)	=  7874.016 = 200/0.0254
    Public Const DPI150_PPM = 5906  '// Pixels per meter (150dpi)	=  5905.512 = 150/0.0254
    Public Const DPI100_PPM = 3937  '// Pixels per meter (100dpi)	=  3937.007 = 100/0.0254


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Enable/Disable
    Public Const SKDV_DISABLE = 0
    Public Const SKDV_ENABLE = 1


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Face
    Public Const SKDV_FRONT = 0                                 '// Front
    Public Const SKDV_BACK = 1                                  '// Back
    Public Const SKDV_FACE_NUM = 2                              '// Number of items



    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_MODULE_INFO
    Public Const SKDV_INFO_MODEL_LEN = 16                       '// model name string length
    Public Const SKDV_INFO_VER_LEN = 16                         '// version string length


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DEVICE_INFO
    '// length
    Public Const SKDV_GUID_LEN = 36                             '// Length of GUID
    Public Const SKDV_PRODUCT_STR_MAX = 15                      '// Max length of product name
    Public Const SKDV_SERIAL_LEN = 9                            '// The number of bytes in the serial number  (fixed length)
    Public Const SKDV_FIRM_VER_STR_MAX = 4                      '// The maximum length version of the farm
    Public Const SKDV_FIRM_SUM_STR_MAX = 4                      '// The maximum number of farm checksum
    Public Const SKDV_HARD_VER_STR_MAX = 3                      '// The maximum number of hardware version

    '// szProduct
    Public Const SKDV_PRODUCT_SR2300 = "SR-2300"                '// 
    Public Const SKDV_PRODUCT_SR5500 = "SR-5500"                '// 
    Public Const SKDV_PRODUCT_SR3500 = "SR-3500"                '// 
    Public Const SKDV_PRODUCT_SR6000 = "SR-6000"                '// 
    Public Const SKDV_PRODUCT_SR6500 = "SR-6500"                '// 
    Public Const SKDV_PRODUCT_SR1800 = "SR-1800"                '// 
    Public Const SKDV_PRODUCT_SR3500HYBRID = "SR-3500 HYBRID"   '// 

    '// Main.dwOption
    Public Const SKDV_OPT_UNIT_MASK = &HFFFF0000                '// Optional unit bit mask
    Public Const SKDV_OPT_UNIT_READER_F = &H80000000            '// Exist MarkReading unit (front)
    Public Const SKDV_OPT_UNIT_READER_B = &H40000000            '// Exist MarkReading unit (back)
    Public Const SKDV_OPT_UNIT_BCR = &H20000000                 '// Exist BarcodeReader unit
    Public Const SKDV_OPT_UNIT_PRINTER = &H10000000             '// Exist Printer unit
    Public Const SKDV_OPT_UNIT_STACKER = &H8000000              '// Exist Stacker unit
    Public Const SKDV_OPT_UNIT_IMAGE_1 = &H4000000              '// Exist ImageReading unit (CPU)
    Public Const SKDV_OPT_UNIT_IMAGE_2 = &H2000000              '// Exist ImageReading unit (FPGA)

    '// (reserved)
    '//	Public Const	SKDV_OPT_INTERFACE_MASK	= &H0000000f	'// Interface type bit mask
    '//	Public Const	SKDV_OPT_INTERFACE_USB_FULL = &H00000001'// USB full speed interface  (USB1.1)
    '//	Public Const	SKDV_OPT_INTERFACE_USB_HIGH = &H00000002'// USB high-speed interface  (USB2.0)

    '// Reader[].dwOption
    Public Const SKDV_OPT_SENSOR_TYPE_MASK = &HFF00             '// Sensor type bit mask
    Public Const SKDV_OPT_SENSOR_TYPE_BIT = 8                   '// Bit positions of sensor type
    Public Const SKDV_OPT_SENSOR_TYPE_ERR = &HFF00              '// Error Sensor type
    Public Const SKDV_OPT_SENSOR_TYPE_RED_VIS = &H0             '// Visible light
    Public Const SKDV_OPT_SENSOR_TYPE_INFRARED = &H100          '// Near-infrared light

    Public Const SKDV_OPT_SENSOR_PITCH_MASK = &HFF              '// Sensor pitch bit mask
    Public Const SKDV_OPT_SENSOR_PITCH_BIT = 0                  '// Bit position of the sensor pitch
    Public Const SKDV_OPT_SENSOR_PITCH_ERR = &HFF               '// Sensor pitch error
    Public Const SKDV_OPT_SENSOR_PITCH_1P6INCH = &H1            '// 1/6inch
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH = &H2             '// 0.2inch
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH_S = &H3           '// 0.2inch-S
    Public Const SKDV_OPT_SENSOR_PITCH_025INCH = &H4            '// 0.25inch
    Public Const SKDV_OPT_SENSOR_PITCH_03INCH = &H5             '// 0.3inch
    Public Const SKDV_OPT_SENSOR_PITCH_03INCH_F = &H6           '// 0.3inch-F
    Public Const SKDV_OPT_SENSOR_PITCH_6MM = &H7                '// 6mm
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH_K = &H8           '// 0.2inch-K
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH_SP = &H9          '// 0.2inch-Special
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH_C = &HA           '// 0.2inch-C

    '// Bcr.dwOption
    Public Const SKDV_OPT_BARCODE_MASK = &HFF                   '// Bar code reader bit mask
    Public Const SKDV_OPT_BARCODE_BIT = 0                       '// Bit positions of Bar code reader
    Public Const SKDV_OPT_BARCODE_ERR = &HFF                    '// Not connected bar code reader
    Public Const SKDV_OPT_BARCODE_V = &H1                       '// Vertical
    Public Const SKDV_OPT_BARCODE_H = &H2                       '// Horizontal

    '// Printer.dwOption & Stacker.dwOption
    Public Const SKDV_OPT_PRINTER_CARTRIDGE = &H80000000        '// With Cartridge

    '// Image1.dwOption
    Public Const SKDV_OPT_IMAGE_FACE_MASK = &HF0000000          '// Face bit mask
    Public Const SKDV_OPT_IMAGE_FACE_FRONT = &H80000000         '// Front
    Public Const SKDV_OPT_IMAGE_FACE_BACK = &H40000000          '// Back
    Public Const SKDV_OPT_IMAGE_FACE_BOTH = &HC0000000          '// Both


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Other
    Public Const SKDV_ID_LEN = 20                               '// The number of bytes of identification codes


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_SR3500_MODE

    '// (reserved).iFeedMode
    Public Const SKDV_FEED_MODE_AUTO = 0                        '// (reserved)
    Public Const SKDV_FEED_MODE_MANUAL = 1                      '// (reserved)

    '// (reserved).iFeedTime
    Public Const SKDV_FEED_TIME_MIN = 0                         '// (reserved)
    Public Const SKDV_FEED_TIME_MAX = 99                        '// (reserved)

    '// .dwDisableWarning
    Public Const SKDV_WARN_AUTO_REJECT = &H10000                '// Enable automatic waste paper processing
    Public Const SKDV_WARN_HOPPER_EMPTY = &H20000               '// Empty seat detection
    Public Const SKDV_WARN_TM_ERROR = &H40000                   '// Error detection timing mark
    Public Const SKDV_WARN_DF_ERROR = &H80000                   '// Double-feed detection
    Public Const SKDV_WARN_LEFT_SKEW = &H100000                 '// Left edge skew detection

    '// .MarkSkew.iRow
    Public Const SKDV_MARKSKEW_ROW_DISABLE = 0                  '// Disable
    Public Const SKDV_MARKSKEW_ROW_MIN = 1                      '// 
    Public Const SKDV_MARKSKEW_ROW_MAX = 155                    '// Maximum value

    '// .MarkSkew.iLevel
    Public Const SKDV_MARKSKEW_LEVEL_MIN = 1                    '// 
    Public Const SKDV_MARKSKEW_LEVEL_MAX = 16                   '// Maximum value

    '// .iPanelOperation
    '// SKDV_DISABLE/SKDV_ENABLE

    '// .Buzzer.iVol
    Public Const SKDV_BUZZER_DISABLE = 0                        '// Buzzer Off
    Public Const SKDV_BUZZER_MIN = 1                            '// Buzzer Volume Min.
    Public Const SKDV_BUZZER_MAX = 5                            '// Buzzer Volume Max.

    '// .Buzzer.iTone
    Public Const SKDV_BUZZER_TONE_A = 1                         '// 
    Public Const SKDV_BUZZER_TONE_B = 2                         '// 
    Public Const SKDV_BUZZER_TONE_C = 3                         '// 

    '// .PSaving.iSleep
    Public Const SKDV_SLEEPTIME_DISABLE = 0                     '// 
    Public Const SKDV_SLEEPTIME_MIN = 1                         '// Minimum value
    Public Const SKDV_SLEEPTIME_MAX = 60                        '// Maximum value

    '// .PSaving.iStandby
    Public Const SKDV_STANDBYTIME_DISABLE = 0                   '// 
    Public Const SKDV_STANDBYTIME_MIN = 1                       '// Minimum value
    Public Const SKDV_STANDBYTIME_MAX = 60                      '// Maximum value


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_SR3500MARK_CONF

    '// .iBackSideReading
    '// SKDV_DISABLE/SKDV_ENABLE

    '// .iColumns
    Public Const SKDV_COL_MAX = 48
    Public Const SKDV_ROW_MAX = 155

    '// .iReadingMethod
    Public Const SKDV_READ_FRONT_EDGE = 1                       '// Top-end timing control type
    Public Const SKDV_READ_REAR_EDGE = 2                        '// Bottom-end timing control type
    Public Const SKDV_READ_DIRECT = 3                           '// Direct under type
    Public Const SKDV_READ_FACOM = 4                            '// FACOM type
    Public Const SKDV_READ_BETWEEN_MARK_NS = 5                  '// Mark to mark type (without top-end)
    Public Const SKDV_READ_BETWEEN_MARK = 6                     '// Mark to mark type (with top-end)
    Public Const SKDV_READMETHOD_MIN = 1                        '// 
    Public Const SKDV_READMETHOD_MAX = 6                        '// Maximum value
    Public Const SKDV_READMETHOD_CNT = 6                        '// Number of items

    '// .iCtrlMultiple
    Public Const SKDV_READ_EDGE_CTRL_MIN1 = 1                   '// Timing control value of minimum (Top-end)
    Public Const SKDV_READ_EDGE_CTRL_MIN2 = 2                   '// Timing control value of minimum (Bottom-end)
    Public Const SKDV_READ_EDGE_CTRL_MAX = 9                    '// Timing control value of maximum

    '// .iThicknessType
    Public Const SKDV_THICKNESS_AUTO_DETECT = 0                 '// Automatic detection
    Public Const SKDV_THICKNESS_55_KG = 1                       '// 64g/m2   (55kg)
    Public Const SKDV_THICKNESS_72_KG = 2                       '// 84g/m2   (72kg)
    Public Const SKDV_THICKNESS_90_KG = 3                       '// 105g/m2  (90kg)
    Public Const SKDV_THICKNESS_110_KG = 4                      '// 128g/m2  (110kg)
    Public Const SKDV_THICKNESS_135_KG = 5                      '// 157g/m2  (135kg)
    Public Const SKDV_THICKNESS_MIN = 0                         '// Minimum value
    Public Const SKDV_THICKNESS_MAX = 5                         '//
    Public Const SKDV_THICKNESS_CNT = 6                         '// Number of items


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_SR3500IMG_CONF

    '// .iScaningSide
    Public Const SKDV_SIDE_NONE = 0                             '// Images do not scan
    Public Const SKDV_SIDE_BOTH = 1                             '// Both
    Public Const SKDV_SIDE_FRONT = 2                            '// Front
    Public Const SKDV_SIDE_BACK = 3                             '// Back
    Public Const SKDV_SIDE_MAX = 3                              '// Maximum value


    '// (reserved)
    '// .iScanCtrlType
    '//	Public Const SKDV_SCAN_CTRL_ONE	=		0				'// One Scans
    '//	Public Const SKDV_SCAN_CTRL_BATCH =		1				'// Batch scanning  (continuous feed)
    '//	Public Const SKDV_SCAN_CTRL_MAX	=		1				'// Maximum value

    '// (reserved)
    '// .iFormLength
    Public Const SKDV_FORMLENGTH_DISABLE = 0                    '// Disable
    Public Const SKDV_FORMLENGTH_MIN = 1100                     '// 110.0[mm]
    Public Const SKDV_FORMLENGTH_MAX = 3556                     '// 355.6[mm]


    '// .iLightColor[]
    Public Const SKDV_LIGHT_COLOR = 0                           '// Color
    Public Const SKDV_LIGHT_GRAYSCALE = 1                       '// Glayscale
    Public Const SKDV_LIGHT_RED = 2                             '// Red
    Public Const SKDV_LIGHT_GREEN = 3                           '// Green
    Public Const SKDV_LIGHT_BLUE = 4                            '// Blue
    Public Const SKDV_LIGHT_MAX = 4                             '// Maximum value


    '// .iResoType
    Public Const SKDV_RESO_TYPE_600DPI = 0                      '// 600dpi
    Public Const SKDV_RESO_TYPE_300DPI = 1                      '// 300dpi
    Public Const SKDV_RESO_TYPE_200DPI = 2                      '// 200dpi
    Public Const SKDV_RESO_TYPE_150DPI = 3                      '// 150dpi
    Public Const SKDV_RESO_TYPE_100DPI = 4                      '// 100dpi
    Public Const SKDV_RESO_TYPE_MAX = 4                         '// Maximum value


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// iResoMode
    Public Const SKDV_RESO_MODE_600DPI = 0                      '// 600dpi driving
    Public Const SKDV_RESO_MODE_300DPI = 1                      '// 300dpi driving
    Public Const SKDV_RESO_MODE_MAX = 1                         '// Maximum value
    Public Const SKDV_RESO_MODE_NUM = 2                         '// Number of items


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_SR3500_STATUS_CHAR
    Public Const SKDV_ST_LEN = 2                                '// ST1/ST2 length


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_IMAGE_DATA_CONF

    '// .iSide
    '//	SKDV_FRONT/SKDV_BACK

    '// .iColorType
    Public Const SKIM_IMAGE_WB = 0                              '// Monochrome
    Public Const SKIM_IMAGE_GRAY = 1                            '// Grayscale
    Public Const SKIM_IMAGE_COLOR = 2                           '// Color
    Public Const SKIM_COLOR_TYPE_MIN = 0                        '// Minimum value
    Public Const SKIM_COLOR_TYPE_MAX = 2                        '// Maximum value

    '// .iRotate
    Public Const SKIM_IMAGE_ROTATE_0 = 0                        '// No rotation
    Public Const SKIM_IMAGE_ROTATE_90 = 1                       '// Rotated  90 degrees
    Public Const SKIM_IMAGE_ROTATE_180 = 2                      '// Rotated 180 degrees
    Public Const SKIM_IMAGE_ROTATE_270 = 3                      '// Rotated 270 degrees
    Public Const SKIM_IMAGE_ROTATE_MIN = 0                      '// Minimum value
    Public Const SKIM_IMAGE_ROTATE_MAX = 3                      '// Maximum value

    '// .iResolution
    Public Const SKIM_IMAGE_RESOLUTION_MIN = 50                 '// Minimum value
    Public Const SKIM_IMAGE_RESOLUTION_MAX = 600                '// Maximum value


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_IMAGE_FILE_CONF

    '// .iEncoder
    Public Const SKIM_ENCODE_BMP = 0                            '// BMP
    Public Const SKIM_ENCODE_GIF = 1                            '// gif
    Public Const SKIM_ENCODE_JPEG = 2                           '// Jpeg
    Public Const SKIM_ENCODE_PNG = 3                            '// png
    Public Const SKIM_ENCODE_TIFF = 4                           '// Tiff
    Public Const SKIM_ENCODE_MIN = 0                            '// Minimum value
    Public Const SKIM_ENCODE_MAX = 4                            '// Maximum value


    '// .iParam  (Jpeg)
    Public Const SKIM_ENCODE_JPEG_PRM_MIN = 0                   '// Minimum value
    Public Const SKIM_ENCODE_JPEG_PRM_MAX = 100                 '// Maximum value

    '// .iParam  (Tiff)
    Public Const SKIM_ENCODE_TIFF_PRM_LZW = 2                   '// EncoderValueCompressionLZW
    Public Const SKIM_ENCODE_TIFF_PRM_NONE = 6                  '// EncoderValueCompressionNone


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SkDv_ReqGetSensor - pdwSensor
    Public Const SKDV_SENSOR_BIT_OUTPS = &H20                   '// OUTPS
    Public Const SKDV_SENSOR_BIT_RDPS = &H10                    '// RDPS
    Public Const SKDV_SENSOR_BIT_INPS = &H8                     '// INPS
    Public Const SKDV_SENSOR_BIT_PS0 = &H4                      '// PS0
    Public Const SKDV_SENSOR_BIT_UPPS = &H2                     '// UPPS
    Public Const SKDV_SENSOR_BIT_DWPS = &H1                     '// DWPS
    Public Const SKDV_SENSOR_BIT_SKS = &H1000                   '// SKS
    Public Const SKDV_SENSOR_BIT_MAIN_CVR = &H100               '// MAIN-CVR
    Public Const SKDV_SENSOR_BIT_SPS = &H40000                  '// SPS
    Public Const SKDV_SENSOR_BIT_MPS = &H20000                  '// MPS
    Public Const SKDV_SENSOR_BIT_P2PS = &H10000                 '// P2PS
    Public Const SKDV_SENSOR_BIT_STK_CVR1 = &H1000000           '// STK-CVR1



    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SkDv_ReqEjectForm - iDirection
    Public Const SKDV_EJECT_MAIN = 1                            '// Eject sheet to Main Stacker  (Immediate)
    Public Const SKDV_EJECT_SELECT = 2                          '// Eject sheet to Select Stacker  (Immediate)
    Public Const SKDV_EJECT_MAIN_NEXT = 3                       '// Eject sheet to Main Stacker on the next SF command.
    Public Const SKDV_EJECT_SELECT_NEXT = 4                     '// Eject sheet to Select Stacker on the next SF command.


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// fnCalibrationCallBack - iSeqNum
    Public Const SKDV_CALIB_SEQ_START = 0                       '// 
    Public Const SKDV_CALIB_SEQ_GET_INFO = 1                    '// 
    Public Const SKDV_CALIB_SEQ_FIRST_FEED = 2                  '// 
    Public Const SKDV_CALIB_SEQ_CHK_BACKGROUND = 3              '// 
    Public Const SKDV_CALIB_SEQ_START_FEED = 4                  '// 
    Public Const SKDV_CALIB_SEQ_ADJ_LED_ONTIME = 5              '// 
    Public Const SKDV_CALIB_SEQ_SET_LED_ONTIME = 6              '// 
    Public Const SKDV_CALIB_SEQ_CIS_BASE = 7                    '// 
    Public Const SKDV_CALIB_SEQ_CHK_CIS_BASE = 8                '// 
    Public Const SKDV_CALIB_SEQ_SAVE = 9                        '// 
    Public Const SKDV_CALIB_SEQ_END_FEED = 10                   '// 
    Public Const SKDV_CALIB_SEQ_CHK_PLATEN = 11                 '// 
    Public Const SKDV_CALIB_SEQ_END = 12                        '// 


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// fnCalibrationCallBack - iSeqNum
    Public Const SKDV_CALIB_PROG_LOWER = 0                      '// Minimum value
    Public Const SKDV_CALIB_PROG_UPPER = 100                    '// Maximum value


    '//*************+***************+***************+***************+***************+
    '//*************+***************+***************+***************+***************+

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Module Info
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_MODULE_INFO
        <MarshalAs(UnmanagedType.ByValArray)> _
        Public ReszModel() As Byte                              '// model name
        <MarshalAs(UnmanagedType.ByValArray)> _
        Public szVersion() As Byte                              '// version
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device Info Base
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DEVICE_INFO
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_GUID_LEN + 1)> _
        Public szGuid() As Byte                                 '// Unique ID []
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_PRODUCT_STR_MAX + 1)> _
        Public szProduct() As Byte                              '// Product name
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_SERIAL_LEN + 1)> _
        Public szSerialNo() As Byte                             '// Serial number [IE]
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_FIRM_VER_STR_MAX + 1)> _
        Public szFirmVer() As Byte                              '// Firmware version
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_FIRM_SUM_STR_MAX + 1)> _
        Public szFirmSum() As Byte                              '// Firmware check sum
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_HARD_VER_STR_MAX + 1)> _
        Public szHardVer() As Byte                              '// Hardware version

        <MarshalAs(UnmanagedType.I4)> _
        Public dwOption As UInteger                             '// Option infomation
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device Info
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_SR3500_INFO
        <MarshalAs(UnmanagedType.Struct)> _
        Public Main As SK_DEVICE_INFO                           '// Main unit
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Public Reader() As SK_DEVICE_INFO                       '// Mark reading unit
        <MarshalAs(UnmanagedType.Struct)> _
        Public Bcr As SK_DEVICE_INFO                            '// Barcode reader unit (option)
        <MarshalAs(UnmanagedType.Struct)> _
        Public Printer As SK_DEVICE_INFO                        '// Printer unit (option)
        <MarshalAs(UnmanagedType.Struct)> _
        Public Stacker As SK_DEVICE_INFO                        '// Stacker unit (option)
        <MarshalAs(UnmanagedType.Struct)> _
        Public Image1 As SK_DEVICE_INFO                         '// Image reading CPU unit (option)
        <MarshalAs(UnmanagedType.Struct)> _
        Public Image2 As SK_DEVICE_INFO                         '// Image reading FPGA unit (option)
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device mode
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_SR3500_MODE
        Public iFeedMode As Integer                             '// (reserved)
        Public iFeedTime As Integer                             '// (reserved)
        Public dwDisableWarning As UInteger                     '// DisableWarning
        Public MarkSkew As MarkSkew                             '// Mark skew
        Public iPanelOperation As Integer                       '// Panel Operation
        Public Buzzer As Buzzer                                 '// Buzzer
        Public PSaving As PSaving                               '// Power Saving
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure MarkSkew                                   '// Mark skew
        Public iRow As Integer                                      '// Row
        Public iLevel As Integer                                    '// Mark level
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure Buzzer                                     '// Buzzer
        Public iVol As Integer                                      '// Volume
        Public iTone As Integer                                     '// Tone
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure PSaving                                    '// Power Saving
        Public iSleep As Integer                                    '// Sleep time
        Public iStandby As Integer                                  '// Standby time
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device Configuration for MarkSheet
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_SR3500MARK_CONF
        Public iBackSideReading As Integer                      '// Use of Back Sensor Unit
        Public iColumns As Integer                              '// Number of columns
        Public iReadingMethod As Integer                        '// Reading method
        Public iCtrlMultiple As Integer                         '// Control multiple value
        Public iThicknessType As Integer                        '// Sheet paper weight (thickness)
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device Configuration for Image
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_SR3500IMG_CONF
        Public iScanningSide As Integer                         '// Scaning side
        Public iScanCtrlType As Integer                         '// (reserved)
        Public iFormLengthMin As Integer                        '// (reserved)
        Public iFormLengthMax As Integer                        '// (reserved)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)> _
        Public iLightColor() As Integer                         '// LightColor
        Public iResoType As Integer                             '// Resolution
        Public iResoTypeY As Integer                            '// (reserved)
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Status code character
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_SR3500_STATUS_CHAR
        <MarshalAs(UnmanagedType.ByValArray)> _
        Public ST1() As Byte
        <MarshalAs(UnmanagedType.ByValArray)> _
        Public ST2() As Byte
        <MarshalAs(UnmanagedType.ByValArray)> _
        Public DIF1 As Byte
        <MarshalAs(UnmanagedType.ByValArray)> _
        Public DIF2 As Byte
    End Structure


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Mark data infomation
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_MARK_INFO
        Public iType As Integer
        Public iRows As Integer
        Public iColumns As Integer
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Image data Configuration
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_IMAGE_DATA_CONF
        Public iFace As Integer                                 '// Face
        Public rectCutout As RECT
        Public iColorType As Integer
        Public iRotate As Integer
        Public iResolution As Integer                           '// Resolution
        Public dwOption As UInteger                             '// (reserved)
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure RECT
        Public left As Integer
        Public top As Integer
        Public right As Integer
        Public bottom As Integer
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Image file Configuration
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_IMAGE_FILE_CONF
        Public iEncoder As Integer                              '// Encoder
        Public iParam As Integer                                '// Encoder parameter
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SIZE
        Public cx As Integer
        Public cy As Integer
    End Structure

End Module