//*************+***************+***************+***************+***************+
//
//	SEKONIC
//	Device control Parameter header
//
//	FileName	: SkDvSr3500Prm.h
//	CPU			: x86
//	Compiler	: Microsoft Visual C++ 6.0 or later
//
//*************+***************+***************+***************+***************+
//	2012.01.11	Into English
//	2011.10.27	for SR-3500 HYBRID
//*************+***************+***************+***************+***************+
#ifndef	INCLUDE_SKDVSR3500PRM_HEADER			// Multi include of a header is prevented.
#define	INCLUDE_SKDVSR3500PRM_HEADER

#pragma once



//*************+***************+***************+***************+***************+
//	define / typedef
//*************+***************+***************+***************+***************+

//-----+-------+-------+-------+-------+-------+-------+-------+
// Base value type
#ifndef SKDV_HANDLE_TYPE
#define SKDV_HANDLE_TYPE
typedef	void*			SkDvHandle;						// Handle of the control device
#endif
typedef	DWORD			SkDvStatus;						// Status Code


//*************+***************+***************+***************+***************+


//-----+-------+-------+-------+-------+-------+-------+-------+
// dot,meter
#define DPI600_PPM								23622			// Pixels per meter(600dpi)	=23622.047 =600/0.0254
#define DPI300_PPM								11811			// Pixels per meter(300dpi)	=11811.024 =300/0.0254
#define DPI200_PPM								7874			// Pixels per meter(200dpi)	= 7874.016 =200/0.0254
#define DPI150_PPM								5906			// Pixels per meter(150dpi)	= 5905.512 =150/0.0254
#define DPI100_PPM								3937			// Pixels per meter(100dpi)	= 3937.007 =100/0.0254


//-----+-------+-------+-------+-------+-------+-------+-------+
// Enable/Disable
#define	SKDV_DISABLE							0
#define	SKDV_ENABLE								1


//-----+-------+-------+-------+-------+-------+-------+-------+
// Face
#define	SKDV_FRONT								0				// Front
#define	SKDV_BACK								1				// Back
#define	SKDV_FACE_NUM							2				// Number of items



//-----+-------+-------+-------+-------+-------+-------+-------+
// SK_DV_MODULE_INFO
#define	SKDV_INFO_MODEL_LEN						16				// model name string length
#define	SKDV_INFO_VER_LEN						16				// version string length


//-----+-------+-------+-------+-------+-------+-------+-------+
// SK_DEVICE_INFO
// length
#define	SKDV_GUID_LEN							36				// Length of GUID
#define	SKDV_PRODUCT_STR_MAX					15				// Max length of product name
#define	SKDV_SERIAL_LEN							9				// The number of bytes in the serial number (fixed length)
#define	SKDV_FIRM_VER_STR_MAX					4				// The maximum length version of the farm
#define	SKDV_FIRM_SUM_STR_MAX					4				// The maximum number of farm checksum
#define	SKDV_HARD_VER_STR_MAX					3				// The maximum number of hardware version

// szProduct
#define SKDV_PRODUCT_SR2300						"SR-2300"		// 
#define SKDV_PRODUCT_SR5500						"SR-5500"		// 
#define SKDV_PRODUCT_SR3500						"SR-3500"		// 
#define SKDV_PRODUCT_SR6000						"SR-6000"		// 
#define SKDV_PRODUCT_SR6500						"SR-6500"		// 
#define SKDV_PRODUCT_SR1800						"SR-1800"		// 
#define SKDV_PRODUCT_SR3500HYBRID				"SR-3500 HYBRID"// 

// Main.dwOption
#define	SKDV_OPT_UNIT_MASK						0xffff0000		// Optional unit bit mask
#define	SKDV_OPT_UNIT_READER_F					0x80000000		// Exist MarkReading unit(front)
#define	SKDV_OPT_UNIT_READER_B					0x40000000		// Exist MarkReading unit(back)
#define	SKDV_OPT_UNIT_BCR						0x20000000		// Exist BarcodeReader unit
#define	SKDV_OPT_UNIT_PRINTER					0x10000000		// Exist Printer unit
#define	SKDV_OPT_UNIT_STACKER					0x08000000		// Exist Stacker unit
#define	SKDV_OPT_UNIT_IMAGE_1					0x04000000		// Exist ImageReading unit(CPU)
#define	SKDV_OPT_UNIT_IMAGE_2					0x02000000		// Exist ImageReading unit(FPGA)

// (reserved)
//	#define	SKDV_OPT_INTERFACE_MASK					0x0000000f		// Interface type bit mask
//	#define	SKDV_OPT_INTERFACE_USB_FULL				0x00000001		// USB full speed interface (USB1.1)
//	#define	SKDV_OPT_INTERFACE_USB_HIGH				0x00000002		// USB high-speed interface (USB2.0)

// Reader[].dwOption
#define	SKDV_OPT_SENSOR_TYPE_MASK				0x0000ff00		// Sensor type bit mask
#define	SKDV_OPT_SENSOR_TYPE_BIT				8				// Bit positions of sensor type
#define	SKDV_OPT_SENSOR_TYPE_ERR				0x0000ff00		// Error Sensor type
#define	SKDV_OPT_SENSOR_TYPE_RED_VIS			0x00000000		// Visible light
#define	SKDV_OPT_SENSOR_TYPE_INFRARED			0x00000100		// Near-infrared light

#define	SKDV_OPT_SENSOR_PITCH_MASK				0x000000ff		// Sensor pitch bit mask
#define	SKDV_OPT_SENSOR_PITCH_BIT				0				// Bit position of the sensor pitch
#define	SKDV_OPT_SENSOR_PITCH_ERR				0x000000ff		// Sensor pitch error
#define	SKDV_OPT_SENSOR_PITCH_1P6INCH			0x00000001		// 1/6inch
#define	SKDV_OPT_SENSOR_PITCH_02INCH			0x00000002		// 0.2inch
#define	SKDV_OPT_SENSOR_PITCH_02INCH_S			0x00000003		// 0.2inch-S
#define	SKDV_OPT_SENSOR_PITCH_025INCH			0x00000004		// 0.25inch
#define	SKDV_OPT_SENSOR_PITCH_03INCH			0x00000005		// 0.3inch
#define	SKDV_OPT_SENSOR_PITCH_03INCH_F			0x00000006		// 0.3inch-F
#define	SKDV_OPT_SENSOR_PITCH_6MM				0x00000007		// 6mm
#define	SKDV_OPT_SENSOR_PITCH_02INCH_K			0x00000008		// 0.2inch-K
#define	SKDV_OPT_SENSOR_PITCH_02INCH_SP			0x00000009		// 0.2inch-Special
#define	SKDV_OPT_SENSOR_PITCH_02INCH_C			0x0000000a		// 0.2inch-C

// Bcr.dwOption
#define	SKDV_OPT_BARCODE_MASK					0x000000ff		// Bar code reader bit mask
#define	SKDV_OPT_BARCODE_BIT					0				// Bit positions of Bar code reader
#define	SKDV_OPT_BARCODE_ERR					0x000000ff		// Not connected bar code reader
#define	SKDV_OPT_BARCODE_V						0x00000001		// Vertical
#define	SKDV_OPT_BARCODE_H						0x00000002		// Horizontal

// Printer.dwOption & Stacker.dwOption
#define	SKDV_OPT_PRINTER_CARTRIDGE				0x80000000		// With Cartridge

// Image1.dwOption
#define	SKDV_OPT_IMAGE_FACE_MASK				0xf0000000		// Face bit mask
#define	SKDV_OPT_IMAGE_FACE_FRONT				0x80000000		// Front
#define	SKDV_OPT_IMAGE_FACE_BACK				0x40000000		// Back
#define	SKDV_OPT_IMAGE_FACE_BOTH				0xc0000000		// Both


//-----+-------+-------+-------+-------+-------+-------+-------+
// Other
#define	SKDV_ID_LEN								20				// The number of bytes of identification codes


//-----+-------+-------+-------+-------+-------+-------+-------+
// SK_DV_SR3500_MODE

// (reserved).iFeedMode
#define	SKDV_FEED_MODE_AUTO						0				// (reserved)
#define	SKDV_FEED_MODE_MANUAL					1				// (reserved)

// (reserved).iFeedTime
#define	SKDV_FEED_TIME_MIN						0				// (reserved)
#define	SKDV_FEED_TIME_MAX						99				// (reserved)

// .dwDisableWarning
#define SKDV_WARN_AUTO_REJECT					0x00010000		// Enable automatic waste paper processing
#define SKDV_WARN_HOPPER_EMPTY					0x00020000		// Empty seat detection
#define SKDV_WARN_TM_ERROR						0x00040000		// Error detection timing mark
#define SKDV_WARN_DF_ERROR						0x00080000		// Double-feed detection
#define SKDV_WARN_LEFT_SKEW						0x00100000		// Left edge skew detection

// .MarkSkew.iRow
#define	SKDV_MARKSKEW_ROW_DISABLE				0				// Disable
#define	SKDV_MARKSKEW_ROW_MIN					1				// 
#define	SKDV_MARKSKEW_ROW_MAX					155				// Maximum value

// .MarkSkew.iLevel
#define	SKDV_MARKSKEW_LEVEL_MIN					1				// 
#define	SKDV_MARKSKEW_LEVEL_MAX					16				// Maximum value

// .iPanelOperation
// SKDV_DISABLE/SKDV_ENABLE

// .Buzzer.iVol
#define	SKDV_BUZZER_DISABLE						0				// Buzzer Off
#define	SKDV_BUZZER_MIN							1				// Buzzer Volume Min.
#define	SKDV_BUZZER_MAX							5				// Buzzer Volume Max.

// .Buzzer.iTone
#define	SKDV_BUZZER_TONE_A						1				// 
#define	SKDV_BUZZER_TONE_B						2				// 
#define	SKDV_BUZZER_TONE_C						3				// 

// .PSaving.iSleep
#define SKDV_SLEEPTIME_DISABLE					0				// 
#define SKDV_SLEEPTIME_MIN						1				// Minimum value
#define SKDV_SLEEPTIME_MAX						60				// Maximum value

// .PSaving.iStandby
#define SKDV_STANDBYTIME_DISABLE				0				// 
#define SKDV_STANDBYTIME_MIN					1				// Minimum value
#define SKDV_STANDBYTIME_MAX					60				// Maximum value


//-----+-------+-------+-------+-------+-------+-------+-------+
// SK_DV_SR3500MARK_CONF

// .iBackSideReading
// SKDV_DISABLE/SKDV_ENABLE

// .iColumns
#define	SKDV_COL_MAX							48				
#define	SKDV_ROW_MAX							155				

// .iReadingMethod
#define	SKDV_READ_FRONT_EDGE					1				// Top-end timing control type
#define	SKDV_READ_REAR_EDGE						2				// Bottom-end timing control type
#define	SKDV_READ_DIRECT						3				// Direct under type
#define	SKDV_READ_FACOM							4				// FACOM type
#define	SKDV_READ_BETWEEN_MARK_NS				5				// Mark to mark type(without top-end)
#define	SKDV_READ_BETWEEN_MARK					6				// Mark to mark type(with top-end)
#define	SKDV_READMETHOD_MIN						1				// 
#define	SKDV_READMETHOD_MAX						6				// Maximum value
#define	SKDV_READMETHOD_CNT						6				// Number of items

// .iCtrlMultiple
#define	SKDV_READ_EDGE_CTRL_MIN1				1				// Timing control value of minimum(Top-end)
#define	SKDV_READ_EDGE_CTRL_MIN2				2				// Timing control value of minimum(Bottom-end)
#define	SKDV_READ_EDGE_CTRL_MAX					9				// Timing control value of maximum

// .iThicknessType
#define	SKDV_THICKNESS_AUTO_DETECT 				0				// Automatic detection
#define	SKDV_THICKNESS_55_KG 					1				// 64g/m2  (55kg)
#define	SKDV_THICKNESS_72_KG					2				// 84g/m2  (72kg)
#define	SKDV_THICKNESS_90_KG					3				// 105g/m2 (90kg)
#define	SKDV_THICKNESS_110_KG					4				// 128g/m2 (110kg)
#define	SKDV_THICKNESS_135_KG					5				// 157g/m2 (135kg)
#define	SKDV_THICKNESS_MIN						0				// Minimum value
#define	SKDV_THICKNESS_MAX						5				//
#define	SKDV_THICKNESS_CNT						6				// Number of items


//-----+-------+-------+-------+-------+-------+-------+-------+
// SK_DV_SR3500IMG_CONF

// .iScaningSide
#define	SKDV_SIDE_NONE							0				// Images do not scan
#define	SKDV_SIDE_BOTH							1				// Both
#define	SKDV_SIDE_FRONT							2				// Front
#define	SKDV_SIDE_BACK							3				// Back
#define	SKDV_SIDE_MAX							3				// Maximum value


// (reserved)
// .iScanCtrlType
//	#define SKDV_SCAN_CTRL_ONE						0				// One Scans
//	#define SKDV_SCAN_CTRL_BATCH					1				// Batch scanning (continuous feed)
//	#define SKDV_SCAN_CTRL_MAX						1				// Maximum value

// (reserved)
// .iFormLength
#define	SKDV_FORMLENGTH_DISABLE					0				// Disable
#define	SKDV_FORMLENGTH_MIN						1100			// 110.0[mm]
#define	SKDV_FORMLENGTH_MAX						3556			// 355.6[mm]


// .iLightColor[]
#define	SKDV_LIGHT_COLOR						0				// Color
#define	SKDV_LIGHT_GRAYSCALE					1				// Glayscale
#define	SKDV_LIGHT_RED							2				// Red
#define	SKDV_LIGHT_GREEN						3				// Green
#define	SKDV_LIGHT_BLUE							4				// Blue
#define	SKDV_LIGHT_MAX							4				// Maximum value


// .iResoType
#define	SKDV_RESO_TYPE_600DPI					0				// 600dpi
#define	SKDV_RESO_TYPE_300DPI					1				// 300dpi
#define	SKDV_RESO_TYPE_200DPI					2				// 200dpi
#define	SKDV_RESO_TYPE_150DPI					3				// 150dpi
#define	SKDV_RESO_TYPE_100DPI					4				// 100dpi
#define	SKDV_RESO_TYPE_MAX						4				// Maximum value


//-----+-------+-------+-------+-------+-------+-------+-------+
// iResoMode
#define	SKDV_RESO_MODE_600DPI					0				// 600dpi driving
#define	SKDV_RESO_MODE_300DPI					1				// 300dpi driving
#define	SKDV_RESO_MODE_MAX						1				// Maximum value
#define	SKDV_RESO_MODE_NUM						2				// Number of items


//-----+-------+-------+-------+-------+-------+-------+-------+
// SK_DV_SR3500_STATUS_CHAR
#define	SKDV_ST_LEN								2				// ST1/ST2 length


//-----+-------+-------+-------+-------+-------+-------+-------+
// SK_DV_IMAGE_DATA_CONF

// .iSide
//	SKDV_FRONT/SKDV_BACK

// .iColorType
#define	SKIM_IMAGE_WB							0				// Monochrome
#define	SKIM_IMAGE_GRAY							1				// Grayscale
#define	SKIM_IMAGE_COLOR						2				// Color
#define	SKIM_COLOR_TYPE_MIN						0				// Minimum value
#define	SKIM_COLOR_TYPE_MAX						2				// Maximum value

// .iRotate
#define	SKIM_IMAGE_ROTATE_0						0				// No rotation
#define	SKIM_IMAGE_ROTATE_90					1				// Rotated  90 degrees
#define	SKIM_IMAGE_ROTATE_180					2				// Rotated 180 degrees
#define	SKIM_IMAGE_ROTATE_270					3				// Rotated 270 degrees
#define	SKIM_IMAGE_ROTATE_MIN					0				// Minimum value
#define	SKIM_IMAGE_ROTATE_MAX					3				// Maximum value

// .iResolution
#define	SKIM_IMAGE_RESOLUTION_MIN				50				// Minimum value
#define	SKIM_IMAGE_RESOLUTION_MAX				600				// Maximum value


//-----+-------+-------+-------+-------+-------+-------+-------+
// SK_DV_IMAGE_FILE_CONF

// .iEncoder
#define	SKIM_ENCODE_BMP							0				// BMP
#define	SKIM_ENCODE_GIF							1				// gif
#define	SKIM_ENCODE_JPEG						2				// Jpeg
#define	SKIM_ENCODE_PNG							3				// png
#define	SKIM_ENCODE_TIFF						4				// Tiff
#define	SKIM_ENCODE_MIN							0				// Minimum value
#define	SKIM_ENCODE_MAX							4				// Maximum value


// .iParam (Jpeg)
#define	SKIM_ENCODE_JPEG_PRM_MIN				0				// Minimum value
#define	SKIM_ENCODE_JPEG_PRM_MAX				100				// Maximum value

// .iParam (Tiff)
#define	SKIM_ENCODE_TIFF_PRM_LZW				2				// EncoderValueCompressionLZW
#define	SKIM_ENCODE_TIFF_PRM_NONE				6				// EncoderValueCompressionNone


//-----+-------+-------+-------+-------+-------+-------+-------+
// SkDv_ReqGetSensor - pdwSensor
#define SKDV_SENSOR_BIT_OUTPS					0x00000020		// OUTPS
#define SKDV_SENSOR_BIT_RDPS					0x00000010		// RDPS
#define SKDV_SENSOR_BIT_INPS					0x00000008		// INPS
#define SKDV_SENSOR_BIT_PS0						0x00000004		// PS0
#define SKDV_SENSOR_BIT_UPPS					0x00000002		// UPPS
#define SKDV_SENSOR_BIT_DWPS					0x00000001		// DWPS
#define SKDV_SENSOR_BIT_SKS						0x00001000		// SKS
#define SKDV_SENSOR_BIT_MAIN_CVR				0x00000100		// MAIN-CVR
#define SKDV_SENSOR_BIT_SPS						0x00040000		// SPS
#define SKDV_SENSOR_BIT_MPS						0x00020000		// MPS
#define SKDV_SENSOR_BIT_P2PS					0x00010000		// P2PS
#define SKDV_SENSOR_BIT_STK_CVR1				0x01000000		// STK-CVR1



//-----+-------+-------+-------+-------+-------+-------+-------+
// SkDv_ReqEjectForm - iDirection
#define SKDV_EJECT_MAIN							1				// Eject sheet to Main Stacker (Immediate)
#define SKDV_EJECT_SELECT						2				// Eject sheet to Select Stacker (Immediate)
#define SKDV_EJECT_MAIN_NEXT					3				// Eject sheet to Main Stacker on the next SF command.
#define SKDV_EJECT_SELECT_NEXT					4				// Eject sheet to Select Stacker on the next SF command.


//-----+-------+-------+-------+-------+-------+-------+-------+
// fnCalibrationCallBack - iSeqNum
#define SKDV_CALIB_SEQ_START					0				// 
#define SKDV_CALIB_SEQ_GET_INFO					1				// 
#define SKDV_CALIB_SEQ_FIRST_FEED				2				// 
#define SKDV_CALIB_SEQ_CHK_BACKGROUND			3				// 
#define SKDV_CALIB_SEQ_START_FEED				4				// 
#define SKDV_CALIB_SEQ_ADJ_LED_ONTIME			5				// 
#define SKDV_CALIB_SEQ_SET_LED_ONTIME			6				// 
#define SKDV_CALIB_SEQ_CIS_BASE					7				// 
#define SKDV_CALIB_SEQ_CHK_CIS_BASE				8				// 
#define SKDV_CALIB_SEQ_SAVE						9				// 
#define SKDV_CALIB_SEQ_END_FEED					10				// 
#define SKDV_CALIB_SEQ_CHK_PLATEN				11				// 
#define SKDV_CALIB_SEQ_END						12				// 


//-----+-------+-------+-------+-------+-------+-------+-------+
// fnCalibrationCallBack - iSeqNum
#define SKDV_CALIB_PROG_LOWER					0				// Minimum value
#define SKDV_CALIB_PROG_UPPER					100				// Maximum value


//*************+***************+***************+***************+***************+
//*************+***************+***************+***************+***************+

//-----+-------+-------+-------+-------+-------+-------+-------+
// Module Info
typedef struct tag_SK_DV_MODULE_INFO
{
	char	szModel		[SKDV_INFO_MODEL_LEN];					// Model name
	char	szVersion	[SKDV_INFO_VER_LEN];					// Version
}SK_DV_MODULE_INFO;


//-----+-------+-------+-------+-------+-------+-------+-------+
// Device Info Base
typedef struct	tag_SK_DEVICE_INFO
{
	char	szGuid		[SKDV_GUID_LEN+1];						// Unique ID []
	char	szProduct	[SKDV_PRODUCT_STR_MAX+1];				// Product name
	char	szSerialNo	[SKDV_SERIAL_LEN+1];					// Serial number [IE]
	char	szFirmVer	[SKDV_FIRM_VER_STR_MAX+1];				// Firmware version
	char	szFirmSum	[SKDV_FIRM_SUM_STR_MAX+1];				// Firmware check sum
	char	szHardVer	[SKDV_HARD_VER_STR_MAX+1];				// Hardware version

	DWORD	dwOption;											// Option infomation
}SK_DEVICE_INFO;


//-----+-------+-------+-------+-------+-------+-------+-------+
// Device Info
typedef struct	tag_SK_DV_SR3500_INFO
{
	SK_DEVICE_INFO		Main;									// Main unit
	SK_DEVICE_INFO		Reader[SKDV_FACE_NUM];					// Mark reading unit
	SK_DEVICE_INFO		Bcr;									// Barcode reader unit (option)
	SK_DEVICE_INFO		Printer;								// Printer unit (option)
	SK_DEVICE_INFO		Stacker;								// Stacker unit (option)
	SK_DEVICE_INFO		Image1;									// Image reading CPU unit (option)
	SK_DEVICE_INFO		Image2;									// Image reading FPGA unit (option)
}SK_DV_SR3500_INFO;


//-----+-------+-------+-------+-------+-------+-------+-------+
// Device mode
typedef struct tag_SK_DV_SR3500_MODE
{
	int			iFeedMode;										// (reserved)
	int			iFeedTime;										// (reserved)
	DWORD		dwDisableWarning;								// DisableWarning
	struct tagMarkSkew{											// Mark skew
		int			iRow;											// Row
		int			iLevel;											// Mark level
	}MarkSkew;
	int			iPanelOperation;								// Panel Operation
	struct tagBuzzer{											// Buzzer
		int			iVol;											// Volume
		int			iTone;											// Tone
	}Buzzer;
	struct tagPSaving{											// Power Saving
		int			iSleep;											// Sleep time
		int			iStandby;										// Standby time
	}PSaving;
}SK_DV_SR3500_MODE;


//-----+-------+-------+-------+-------+-------+-------+-------+
// Device Configuration for MarkSheet
typedef struct tag_SK_DV_SR3500MARK_CONF
{
	int			iBackSideReading;								// Use of Back Sensor Unit
	int			iColumns;										// Number of columns
	int			iReadingMethod;									// Reading method
	int			iCtrlMultiple;									// Control multiple value
	int			iThicknessType;									// Sheet paper weight (thickness)
}SK_DV_SR3500MARK_CONF;


//-----+-------+-------+-------+-------+-------+-------+-------+
// Device Configuration for Image
typedef struct tag_SK_DV_SR3500IMG_CONF
{
	int			iScanningSide;									// Scaning side
	int			iScanCtrlType;									// (reserved)
	int			iFormLengthMin;									// (reserved)
	int			iFormLengthMax;									// (reserved)
	int			iLightColor[SKDV_FACE_NUM];						// LightColor
	int			iResoType;										// Resolution
	int			iResoTypeY;										// (reserved)
}SK_DV_SR3500IMG_CONF;


//-----+-------+-------+-------+-------+-------+-------+-------+
// Status code character
typedef struct tag_SK_DV_SR3500_STATUS_CHAR
{
	char	ST1[SKDV_ST_LEN];
	char	ST2[SKDV_ST_LEN];
	char	DIF1;
	char	DIF2;
}SK_DV_SR3500_STATUS_CHAR, *PSK_DV_SR3500_STATUS_CHAR;


//-----+-------+-------+-------+-------+-------+-------+-------+
// Mark data infomation
typedef struct tag_SK_DV_MARK_INFO
{
	int		iType;
	int		iRows;
	int		iColumns;
}SK_DV_MARK_INFO, *PSK_DV_MARK_INFO;


//-----+-------+-------+-------+-------+-------+-------+-------+
// Image data Configuration
typedef struct tag_SK_DV_IMAGE_DATA_CONF
{
	int			iFace;											// Face
	RECT		rectCutout;										// Cutout area
	int			iColorType;										// Color type
	int			iRotate;										// Rotate
	int			iResolution;									// Resolution
	DWORD		dwOption;										// (reserved)
}SK_DV_IMAGE_DATA_CONF;


//-----+-------+-------+-------+-------+-------+-------+-------+
// Image file Configuration
typedef struct tag_SK_DV_IMAGE_FILE_CONF
{
	int			iEncoder;										// Encoder
	int			iParam;											// Encoder parameter
}SK_DV_IMAGE_FILE_CONF;


//*************+***************+***************+***************+***************+
//*************+***************+***************+***************+***************+

// Save the image data file (another thread) callback function definition
#ifndef FN_SK_DV_SAVEIMAGE_CALLBACK_DEFINE
#define FN_SK_DV_SAVEIMAGE_CALLBACK_DEFINE
typedef BOOL (CALLBACK *FN_SK_DV_SAVEIMAGE_CALLBACK)(SK_DV_IMAGE_DATA_CONF* pImageDataConf, SK_DV_IMAGE_FILE_CONF* pImageFileConf, char* pszFilename, SkDvStatus Status, LPVOID lpParameter);
#endif



#endif
