Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices

Module SkDvSrSeriesPrm
    '//*************+***************+***************+***************+***************+
    '//
    '// SEKONIC
    '// Device control Parameter header
    '//
    '// FileName        : SkDvSeriesPrm.h
    '// CPU             : x86
    '// Compiler        : Microsoft Visual C++ 6.0 or later
    '//
    '//*************+***************+***************+***************+***************+
    '// 2012.03.15      for New Sample Program
    '// 2012.01.11      Into English
    '// 2011.10.27      for SR-3500 HYBRID
    '//*************+***************+***************+***************+***************+


    Public Const SKDV_TRUE As Integer = 1
    Public Const SKDV_FALSE As Integer = 0


    Public Structure RECT
        Dim left As Integer
        Dim top As Integer
        Dim right As Integer
        Dim bottom As Integer
    End Structure



    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// dot,meter
    Public Const DPI600_PPM As Integer = 23622      '// Pixels per meter (600dpi)   = 23622.047 = 600/0.0254
    Public Const DPI300_PPM As Integer = 11811      '// Pixels per meter (300dpi)   = 11811.024 = 300/0.0254
    Public Const DPI200_PPM As Integer = 7874       '// Pixels per meter (200dpi)   =  7874.016 = 200/0.0254
    Public Const DPI150_PPM As Integer = 5906       '// Pixels per meter (150dpi)   =  5905.512 = 150/0.0254
    Public Const DPI100_PPM As Integer = 3937       '// Pixels per meter (100dpi)   =  3937.007 = 100/0.0254


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Enable/Disable
    Public Const SKDV_DISABLE As Integer = 0                        '// Disable
    Public Const SKDV_ENABLE As Integer = 1                         '// Enable


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Face
    Public Const SKDV_FRONT As Integer = 0                          '// Front
    Public Const SKDV_BACK As Integer = 1                           '// Back
    Public Const SKDV_FACE_NUM As Integer = 2                       '// Number of items



    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_MODULE_INFO
    Public Const SKDV_INFO_MODEL_LEN As Integer = 16                '// model name string length
    Public Const SKDV_INFO_VER_LEN As Integer = 16                  '// version string length


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DEVICE_INFO
    '// length
    Public Const SKDV_GUID_LEN As Integer = 36                      '// Length of GUID
    Public Const SKDV_PRODUCT_STR_MAX As Integer = 15               '// Max length of product name
    Public Const SKDV_SERIAL_LEN As Integer = 9                     '// The number of bytes in the serial number  (fixed length)
    Public Const SKDV_FIRM_VER_STR_MAX As Integer = 4               '// The maximum length version of the farm
    Public Const SKDV_FIRM_SUM_STR_MAX As Integer = 4               '// The maximum number of farm checksum
    Public Const SKDV_HARD_VER_STR_MAX As Integer = 3               '// The maximum number of hardware version

    '// szProduct
    Public Const SKDV_PRODUCT_SR2300 As String = "SR-2300"              '// SR-2300
    Public Const SKDV_PRODUCT_SR5500 As String = "SR-5500"              '// SR-5500
    Public Const SKDV_PRODUCT_SR3500 As String = "SR-3500"              '// SR-3500
    Public Const SKDV_PRODUCT_SR6000 As String = "SR-6000"              '// SR-6000
    Public Const SKDV_PRODUCT_SR6500 As String = "SR-6500"              '// SR-6500
    Public Const SKDV_PRODUCT_SR1800 As String = "SR-1800"              '// SR-1800
    Public Const SKDV_PRODUCT_SR3500HYBRID As String = "SR-3500 HYBRID" '// SR-3500 HYBRID
    Public Const SKDV_PRODUCT_SR6500HYBRID As String = "SR-6500 HYBRID" '// SR-6500HYBRID
    Public Const SKDV_PRODUCT_SR11000 As String = "SR-11000"            '// SR-11000
    Public Const SKDV_PRODUCT_SR8000HYBRID As String = "SR-8000 HYBRID" '// SR-8000HYBRID


    '// Main.dwOption
    Public Const SKDV_OPT_UNIT_MASK As Integer = &HFFFF0000         '// Optional unit bit mask
    Public Const SKDV_OPT_UNIT_READER_F As Integer = &H80000000     '// Exist MarkReading unit (front)
    Public Const SKDV_OPT_UNIT_READER_B As Integer = &H40000000     '// Exist MarkReading unit (back)
    Public Const SKDV_OPT_UNIT_BCR As Integer = &H20000000          '// Exist BarcodeReader unit
    Public Const SKDV_OPT_UNIT_PRINTER As Integer = &H10000000      '// Exist Printer unit
    Public Const SKDV_OPT_UNIT_STACKER As Integer = &H8000000       '// Exist Stacker unit
    Public Const SKDV_OPT_UNIT_IMAGE_1 As Integer = &H4000000       '// Exist ImageReading unit (CPU)
    Public Const SKDV_OPT_UNIT_IMAGE_2 As Integer = &H2000000       '// Exist ImageReading unit (FPGA)

    '// (reserved)
    '// Public Const    SKDV_OPT_INTERFACE_MASK = &H0000000f        '// Interface type bit mask
    '// Public Const    SKDV_OPT_INTERFACE_USB_FULL = &H00000001    '// USB full speed interface  (USB1.1)
    '// Public Const    SKDV_OPT_INTERFACE_USB_HIGH = &H00000002    '// USB high-speed interface  (USB2.0)

    '// Reader[].dwOption
    Public Const SKDV_OPT_SENSOR_TYPE_MASK As Integer = &HFF00      '// Sensor type bit mask
    Public Const SKDV_OPT_SENSOR_TYPE_BIT As Integer = 8            '// Bit positions of sensor type
    Public Const SKDV_OPT_SENSOR_TYPE_ERR As Integer = &HFF00       '// Error Sensor type
    Public Const SKDV_OPT_SENSOR_TYPE_RED_VIS As Integer = &H0      '// Visible light
    Public Const SKDV_OPT_SENSOR_TYPE_INFRARED As Integer = &H100   '// Near-infrared light

    Public Const SKDV_OPT_SENSOR_PITCH_MASK As Integer = &HFF       '// Sensor pitch bit mask
    Public Const SKDV_OPT_SENSOR_PITCH_BIT As Integer = 0           '// Bit position of the sensor pitch
    Public Const SKDV_OPT_SENSOR_PITCH_ERR As Integer = &HFF        '// Sensor pitch error
    Public Const SKDV_OPT_SENSOR_PITCH_1P6INCH As Integer = &H1     '// 1/6inch
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH As Integer = &H2      '// 0.2inch
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH_S As Integer = &H3    '// 0.2inch-S
    Public Const SKDV_OPT_SENSOR_PITCH_025INCH As Integer = &H4     '// 0.25inch
    Public Const SKDV_OPT_SENSOR_PITCH_03INCH As Integer = &H5      '// 0.3inch
    Public Const SKDV_OPT_SENSOR_PITCH_03INCH_F As Integer = &H6    '// 0.3inch-F
    Public Const SKDV_OPT_SENSOR_PITCH_6MM As Integer = &H7         '// 6mm
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH_K As Integer = &H8    '// 0.2inch-K
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH_SP As Integer = &H9   '// 0.2inch-Special
    Public Const SKDV_OPT_SENSOR_PITCH_02INCH_C As Integer = &HA    '// 0.2inch-C

    '// Bcr.dwOption
    Public Const SKDV_OPT_BARCODE_MASK As Integer = &HFF            '// Bar code reader bit mask
    Public Const SKDV_OPT_BARCODE_BIT As Integer = 0                '// Bit positions of Bar code reader
    Public Const SKDV_OPT_BARCODE_ERR As Integer = &HFF             '// Not connected bar code reader
    Public Const SKDV_OPT_BARCODE_V As Integer = &H1                '// Vertical
    Public Const SKDV_OPT_BARCODE_H As Integer = &H2                '// Horizontal

    '// Printer.dwOption & Stacker.dwOption
    Public Const SKDV_OPT_PRINTER_CARTRIDGE As Integer = &H80000000 '// With Cartridge

    '// Image1.dwOption
    Public Const SKDV_OPT_IMAGE_FACE_MASK As Integer = &HF0000000   '// Face bit mask
    Public Const SKDV_OPT_IMAGE_FACE_FRONT As Integer = &H80000000  '// Front
    Public Const SKDV_OPT_IMAGE_FACE_BACK As Integer = &H40000000   '// Back
    Public Const SKDV_OPT_IMAGE_FACE_BOTH As Integer = &HC0000000   '// Both


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Other
    Public Const SKDV_ID_LEN As Integer = 20                        '// The number of bytes of identification codes


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_SR3500_MODE

    '// (reserved).iFeedMode
    Public Const SKDV_FEED_MODE_AUTO As Integer = 0                 '// (reserved)
    Public Const SKDV_FEED_MODE_MANUAL As Integer = 1               '// (reserved)

    '// (reserved).iFeedTime
    Public Const SKDV_FEED_TIME_MIN As Integer = 0                  '// (reserved)
    Public Const SKDV_FEED_TIME_MAX As Integer = 99                 '// (reserved)

    '// .dwDisableWarning
    Public Const SKDV_WARN_AUTO_REJECT As Integer = &H10000         '// Enable automatic waste paper processing
    Public Const SKDV_WARN_HOPPER_EMPTY As Integer = &H20000        '// Empty seat detection
    Public Const SKDV_WARN_TM_ERROR As Integer = &H40000            '// Error detection timing mark
    Public Const SKDV_WARN_DF_ERROR As Integer = &H80000            '// Double-feed detection
    Public Const SKDV_WARN_LEFT_SKEW As Integer = &H100000          '// Left edge skew detection

    '// .MarkSkew.iRow
    Public Const SKDV_MARKSKEW_ROW_DISABLE As Integer = 0           '// Disable
    Public Const SKDV_MARKSKEW_ROW_MIN As Integer = 1               '//
    Public Const SKDV_MARKSKEW_ROW_MAX As Integer = 155             '// Maximum value

    '// .MarkSkew.iLevel
    Public Const SKDV_MARKSKEW_LEVEL_MIN As Integer = 1             '//
    Public Const SKDV_MARKSKEW_LEVEL_MAX As Integer = 16            '// Maximum value

    '// .iPanelOperation
    '// SKDV_DISABLE/SKDV_ENABLE

    '// .Buzzer.iVol
    Public Const SKDV_BUZZER_DISABLE As Integer = 0                 '// Buzzer Off
    Public Const SKDV_BUZZER_MIN As Integer = 1                     '// Buzzer Volume Min.
    Public Const SKDV_BUZZER_MAX As Integer = 5                     '// Buzzer Volume Max.

    '// .Buzzer.iTone
    Public Const SKDV_BUZZER_TONE_A As Integer = 1                  '//
    Public Const SKDV_BUZZER_TONE_B As Integer = 2                  '//
    Public Const SKDV_BUZZER_TONE_C As Integer = 3                  '//

    '// .PSaving.iSleep
    Public Const SKDV_SLEEPTIME_DISABLE As Integer = 0              '//
    Public Const SKDV_SLEEPTIME_MIN As Integer = 1                  '// Minimum value
    Public Const SKDV_SLEEPTIME_MAX As Integer = 60                 '// Maximum value

    '// .PSaving.iStandby
    Public Const SKDV_STANDBYTIME_DISABLE As Integer = 0            '//
    Public Const SKDV_STANDBYTIME_MIN As Integer = 1                '// Minimum value
    Public Const SKDV_STANDBYTIME_MAX As Integer = 60               '// Maximum value


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_SR3500MARK_CONF

    '// .iBackSideReading
    '// SKDV_DISABLE/SKDV_ENABLE

    '// .iColumns
    Public Const SKDV_COL_MAX As Integer = 48
    Public Const SKDV_ROW_MAX As Integer = 155

    '// .iReadingMethod
    Public Const SKDV_READ_FRONT_EDGE As Integer = 1                '// Top-end timing control type
    Public Const SKDV_READ_REAR_EDGE As Integer = 2                 '// Bottom-end timing control type
    Public Const SKDV_READ_DIRECT As Integer = 3                    '// Direct under type
    Public Const SKDV_READ_FACOM As Integer = 4                     '// FACOM type
    Public Const SKDV_READ_BETWEEN_MARK_NS As Integer = 5           '// Mark to mark type (without top-end)
    Public Const SKDV_READ_BETWEEN_MARK As Integer = 6              '// Mark to mark type (with top-end)
    Public Const SKDV_READMETHOD_MIN As Integer = 1                 '//
    Public Const SKDV_READMETHOD_MAX As Integer = 6                 '// Maximum value
    Public Const SKDV_READMETHOD_CNT As Integer = 6                 '// Number of items

    '// .iCtrlMultiple
    Public Const SKDV_READ_EDGE_CTRL_MIN1 As Integer = 1            '// Timing control value of minimum (Top-end)
    Public Const SKDV_READ_EDGE_CTRL_MIN2 As Integer = 2            '// Timing control value of minimum (Bottom-end)
    Public Const SKDV_READ_EDGE_CTRL_MAX As Integer = 9             '// Timing control value of maximum

    '// .iThicknessType
    Public Const SKDV_THICKNESS_AUTO_DETECT As Integer = 0          '// Automatic detection
    Public Const SKDV_THICKNESS_55_KG As Integer = 1                '// 64g/m2   (55kg)
    Public Const SKDV_THICKNESS_72_KG As Integer = 2                '// 84g/m2   (72kg)
    Public Const SKDV_THICKNESS_90_KG As Integer = 3                '// 105g/m2  (90kg)
    Public Const SKDV_THICKNESS_110_KG As Integer = 4               '// 128g/m2  (110kg)
    Public Const SKDV_THICKNESS_135_KG As Integer = 5               '// 157g/m2  (135kg)
    Public Const SKDV_THICKNESS_MIN As Integer = 0                  '// Minimum value
    Public Const SKDV_THICKNESS_MAX As Integer = 5                  '//
    Public Const SKDV_THICKNESS_CNT As Integer = 6                  '// Number of items


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_SR3500IMG_CONF

    '// .iScaningSide
    Public Const SKDV_SIDE_NONE As Integer = 0                      '// Images do not scan
    Public Const SKDV_SIDE_BOTH As Integer = 1                      '// Both
    Public Const SKDV_SIDE_FRONT As Integer = 2                     '// Front
    Public Const SKDV_SIDE_BACK As Integer = 3                      '// Back
    Public Const SKDV_SIDE_MAX As Integer = 3                       '// Maximum value


    '// (reserved)
    '// .iScanCtrlType
    '// Public Const SKDV_SCAN_CTRL_ONE =               0           '// One Scans
    '// Public Const SKDV_SCAN_CTRL_BATCH =             1           '// Batch scanning  (continuous feed)
    '// Public Const SKDV_SCAN_CTRL_MAX =               1           '// Maximum value

    '// (reserved)
    '// .iFormLength
    Public Const SKDV_FORMLENGTH_DISABLE As Integer = 0             '// Disable
    Public Const SKDV_FORMLENGTH_MIN As Integer = 1100              '// 110.0[mm]
    Public Const SKDV_FORMLENGTH_MAX As Integer = 3556              '// 355.6[mm]


    '// .iLightColor[]
    Public Const SKDV_LIGHT_COLOR As Integer = 0                    '// Color
    Public Const SKDV_LIGHT_GRAYSCALE As Integer = 1                '// Glayscale
    Public Const SKDV_LIGHT_RED As Integer = 2                      '// Red
    Public Const SKDV_LIGHT_GREEN As Integer = 3                    '// Green
    Public Const SKDV_LIGHT_BLUE As Integer = 4                     '// Blue
    Public Const SKDV_LIGHT_MAX As Integer = 4                      '// Maximum value


    '// .iResoType
    Public Const SKDV_RESO_TYPE_600DPI As Integer = 0               '// 600dpi
    Public Const SKDV_RESO_TYPE_300DPI As Integer = 1               '// 300dpi
    Public Const SKDV_RESO_TYPE_200DPI As Integer = 2               '// 200dpi
    Public Const SKDV_RESO_TYPE_150DPI As Integer = 3               '// 150dpi
    Public Const SKDV_RESO_TYPE_100DPI As Integer = 4               '// 100dpi
    Public Const SKDV_RESO_TYPE_MAX As Integer = 4                  '// Maximum value


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// iResoMode
    Public Const SKDV_RESO_MODE_600DPI As Integer = 0               '// 600dpi driving
    Public Const SKDV_RESO_MODE_300DPI As Integer = 1               '// 300dpi driving
    Public Const SKDV_RESO_MODE_MAX As Integer = 1                  '// Maximum value
    Public Const SKDV_RESO_MODE_NUM As Integer = 2                  '// Number of items


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_SR3500_STATUS_CHAR
    Public Const SKDV_ST_LEN As Integer = 2                         '// ST1/ST2 length


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_IMAGE_DATA_CONF

    '// .iSide
    '// SKDV_FRONT/SKDV_BACK

    '// .iColorType
    Public Const SKIM_IMAGE_WB As Integer = 0                       '// Monochrome
    Public Const SKIM_IMAGE_GRAY As Integer = 1                     '// Grayscale
    Public Const SKIM_IMAGE_COLOR As Integer = 2                    '// Color
    Public Const SKIM_COLOR_TYPE_MIN As Integer = 0                 '// Minimum value
    Public Const SKIM_COLOR_TYPE_MAX As Integer = 2                 '// Maximum value

    '// .iRotate
    Public Const SKIM_IMAGE_ROTATE_0 As Integer = 0                 '// No rotation
    Public Const SKIM_IMAGE_ROTATE_90 As Integer = 1                '// Rotated  90 degrees
    Public Const SKIM_IMAGE_ROTATE_180 As Integer = 2               '// Rotated 180 degrees
    Public Const SKIM_IMAGE_ROTATE_270 As Integer = 3               '// Rotated 270 degrees
    Public Const SKIM_IMAGE_ROTATE_MIN As Integer = 0               '// Minimum value
    Public Const SKIM_IMAGE_ROTATE_MAX As Integer = 3               '// Maximum value

    '// .iResolution
    Public Const SKIM_IMAGE_RESOLUTION_MIN As Integer = 50          '// Minimum value
    Public Const SKIM_IMAGE_RESOLUTION_MAX As Integer = 600         '// Maximum value


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SK_DV_IMAGE_FILE_CONF

    '// .iEncoder
    Public Const SKIM_ENCODE_BMP As Integer = 0                     '// BMP
    Public Const SKIM_ENCODE_GIF As Integer = 1                     '// gif
    Public Const SKIM_ENCODE_JPEG As Integer = 2                    '// Jpeg
    Public Const SKIM_ENCODE_PNG As Integer = 3                     '// png
    Public Const SKIM_ENCODE_TIFF As Integer = 4                    '// Tiff
    Public Const SKIM_ENCODE_MIN As Integer = 0                     '// Minimum value
    Public Const SKIM_ENCODE_MAX As Integer = 4                     '// Maximum value


    '// .iParam  (Jpeg)
    Public Const SKIM_ENCODE_JPEG_PRM_MIN As Integer = 0            '// Minimum value
    Public Const SKIM_ENCODE_JPEG_PRM_MAX As Integer = 100          '// Maximum value

    '// .iParam  (Tiff)
    Public Const SKIM_ENCODE_TIFF_PRM_LZW As Integer = 2            '// EncoderValueCompressionLZW
    Public Const SKIM_ENCODE_TIFF_PRM_NONE As Integer = 6           '// EncoderValueCompressionNone


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SkDv_ReqGetSensor - pdwSensor
    Public Const SKDV_SENSOR_BIT_OUTPS As UInteger = &H20           '// OUTPS
    Public Const SKDV_SENSOR_BIT_RDPS As UInteger = &H10            '// RDPS
    Public Const SKDV_SENSOR_BIT_INPS As UInteger = &H8             '// INPS
    Public Const SKDV_SENSOR_BIT_PS0 As UInteger = &H4              '// PS0
    Public Const SKDV_SENSOR_BIT_UPPS As UInteger = &H2             '// UPPS
    Public Const SKDV_SENSOR_BIT_DWPS As UInteger = &H1             '// DWPS
    Public Const SKDV_SENSOR_BIT_SKS As UInteger = &H1000           '// SKS
    Public Const SKDV_SENSOR_BIT_MAIN_CVR As UInteger = &H100       '// MAIN-CVR
    Public Const SKDV_SENSOR_BIT_SPS As UInteger = &H40000          '// SPS
    Public Const SKDV_SENSOR_BIT_MPS As UInteger = &H20000          '// MPS
    Public Const SKDV_SENSOR_BIT_P2PS As UInteger = &H10000         '// P2PS
    Public Const SKDV_SENSOR_BIT_STK_CVR1 As UInteger = &H1000000   '// STK-CVR1



    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// SkDv_ReqEjectForm - iDirection
    Public Const SKDV_EJECT_MAIN As Integer = 1                     '// Eject sheet to Main Stacker  (Immediate)
    Public Const SKDV_EJECT_SELECT As Integer = 2                   '// Eject sheet to Select Stacker  (Immediate)
    Public Const SKDV_EJECT_MAIN_NEXT As Integer = 3                '// Eject sheet to Main Stacker on the next SF command.
    Public Const SKDV_EJECT_SELECT_NEXT As Integer = 4              '// Eject sheet to Select Stacker on the next SF command.


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// BCR Reading area                             (Barcode reader option)
    '//  Array number of SK_DV_OPT_BCR_CONF.iReadingArea
    Public Const SKDV_BCR_READING_AREA_MAX As Integer = 20          '// Reading area array max
    '// 0:Start Posisiton
    '// 1,3,5,7,9,11,13,15,17,19:Range to read
    '// 2,4,6,8,10,12,14,16,18:Range to unread


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// BCR Reading area                             (Barcode reader option)
    '//  Array number of tag_SK_DV_OPT_BCR_CONF_EX.Area
    Public Const SKDV_BCR_AREA_MAX As Integer = 10                  '// Reading area array max


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// BC type                                      (Barcode reader option)
    '//  SK_DV_OPT_BCR_CONF.dwEnableBcType(Multiple selected)
    '//  SK_DV_OPT_BCR_CONF.TypeOption[].dwBcType(One selected)
    Public Const SKDV_BCR_CODE39 As UInteger = &H1                  '// CODE-39
    Public Const SKDV_BCR_ITF As UInteger = &H2                     '// Interleaved 2 of 5
    Public Const SKDV_BCR_NW7 As UInteger = &H4                     '// NW-7
    Public Const SKDV_BCR_JAN_EAN_UPC As UInteger = &H8             '// JAN,EAN,UPC
    Public Const SKDV_BCR_CODE128 As UInteger = &H10                '// Code-128
    Public Const SKDV_BCR_INDUSTRIAL2OF5 As UInteger = &H20         '// Industrial 2 of 5
    Public Const SKDV_BCR_COOP2OF5 As UInteger = &H40               '// COOP 2 of 5
    Public Const SKDV_BCR_CODE93 As UInteger = &H80                 '// CODE-93

    Public Const SKDV_BCR_JAN_EAN_8 As UInteger = &H100             '// JAN,EAN 8
    Public Const SKDV_BCR_JAN_EAN_13 As UInteger = &H200            '// JAN,EAN 13
    Public Const SKDV_BCR_UPC_A As UInteger = &H400                 '// UPC-A
    Public Const SKDV_BCR_UPC_E As UInteger = &H800                 '// UPC-E
    Public Const SKDV_BCR_QR As UInteger = &H1000000                '// QR Code

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Print buffer size							(Printer option)
    Public Const SKDV_PRINT_BUFFER_SIZE As Integer = 42             '// 

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Print orientation							(Printer option)
    Public Const SKDV_PRINT_ORIENT_0 As Integer = 1                 '// Normal
    Public Const SKDV_PRINT_ORIENT_180 As Integer = 2               '// Rotate 180 degrees string

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Print Mode									(Printer option)
    Public Const SKDV_PRINT_MODE_AFTER_FEED As Integer = 1          '// Prints after having read
    Public Const SKDV_PRINT_MODE_FEED_AND_PRINT As Integer = 2      '// At the same time printing and reading


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// fnCalibrationCallBack - iSeqNum             (SR-3500HYBRID)
    Public Const SKDV_CALIB_SEQ_START As Integer = 0                '//
    Public Const SKDV_CALIB_SEQ_GET_INFO As Integer = 1             '//
    Public Const SKDV_CALIB_SEQ_FIRST_FEED As Integer = 2           '//
    Public Const SKDV_CALIB_SEQ_CHK_BACKGROUND As Integer = 3       '//
    Public Const SKDV_CALIB_SEQ_START_FEED As Integer = 4           '//
    Public Const SKDV_CALIB_SEQ_ADJ_LED_ONTIME As Integer = 5       '//
    Public Const SKDV_CALIB_SEQ_SET_LED_ONTIME As Integer = 6       '//
    Public Const SKDV_CALIB_SEQ_CIS_BASE As Integer = 7             '//
    Public Const SKDV_CALIB_SEQ_CHK_CIS_BASE As Integer = 8         '//
    Public Const SKDV_CALIB_SEQ_SAVE As Integer = 9                 '//
    Public Const SKDV_CALIB_SEQ_END_FEED As Integer = 10            '//
    Public Const SKDV_CALIB_SEQ_CHK_PLATEN As Integer = 11          '//
    Public Const SKDV_CALIB_SEQ_END As Integer = 12                 '//


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// fnCalibrationCallBack - iSeqNum             (SR-3500HYBRID)
    Public Const SKDV_CALIB_PROG_LOWER As Integer = 0               '// Minimum value
    Public Const SKDV_CALIB_PROG_UPPER As Integer = 100             '// Maximum value


    '//*************+***************+***************+***************+***************+
    '//*************+***************+***************+***************+***************+

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Module Info
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_MODULE_INFO
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_INFO_MODEL_LEN)> _
        Public ReszModel() As Byte                                  '// model name
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_INFO_VER_LEN)> _
        Public szVersion() As Byte                                  '// version
    End Structure


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device Info Base                            (SR-Series)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DEVICE_INFO
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_GUID_LEN + 1)> _
        Public szGuid() As Byte                                     '// Unique ID []
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_PRODUCT_STR_MAX + 1)> _
        Public szProduct() As Byte                                  '// Product name
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_SERIAL_LEN + 1)> _
        Public szSerialNo() As Byte                                 '// Serial number [IE]
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_FIRM_VER_STR_MAX + 1)> _
        Public szFirmVer() As Byte                                  '// Firmware version
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_FIRM_SUM_STR_MAX + 1)> _
        Public szFirmSum() As Byte                                  '// Firmware check sum
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_HARD_VER_STR_MAX + 1)> _
        Public szHardVer() As Byte                                  '// Hardware version

        <MarshalAs(UnmanagedType.I4)> _
        Public dwOption As UInteger                                 '// Option infomation
    End Structure


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device Info                                 (SR-Series)
    '<StructLayout(LayoutKind.Sequential)> _
    'Public Structure SK_DV_SR3500_INFO
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_DEVICE_INFO
        'Public Structure SK_DV_SR3500_INFO
        <MarshalAs(UnmanagedType.Struct)> _
        Public Main As SK_DEVICE_INFO                               '// Main unit
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_FACE_NUM)> _
        Public Reader() As SK_DEVICE_INFO                           '// Mark reading unit
        <MarshalAs(UnmanagedType.Struct)> _
        Public Bcr As SK_DEVICE_INFO                                '// Barcode reader unit (option)
        <MarshalAs(UnmanagedType.Struct)> _
        Public Printer As SK_DEVICE_INFO                            '// Printer unit (option)
        <MarshalAs(UnmanagedType.Struct)> _
        Public Stacker As SK_DEVICE_INFO                            '// Stacker unit (option)
        <MarshalAs(UnmanagedType.Struct)> _
        Public Image1 As SK_DEVICE_INFO                             '// Image reading CPU unit (option)
        <MarshalAs(UnmanagedType.Struct)> _
        Public Image2 As SK_DEVICE_INFO                             '// Image reading FPGA unit (option)
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device mode                                 (SR-Series)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_SR3500_MODE
        Public iFeedMode As Integer                                 '// (reserved)
        Public iFeedTime As Integer                                 '// (reserved)
        Public dwDisableWarning As UInteger                         '// DisableWarning
        Public MarkSkew As MarkSkew                                 '// Mark skew
        Public iPanelOperation As Integer                           '// Panel Operation
        Public Buzzer As Buzzer                                     '// Buzzer
        Public PSaving As PSaving                                   '// Power Saving
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure MarkSkew                                       '// Mark skew
        Public iRow As Integer                                          '// Row
        Public iLevel As Integer                                        '// Mark level
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure Buzzer                                         '// Buzzer
        Public iVol As Integer                                          '// Volume
        Public iTone As Integer                                         '// Tone
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure PSaving                                        '// Power Saving
        Public iSleep As Integer                                        '// Sleep time
        Public iStandby As Integer                                      '// Standby time
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device Configuration for MarkSheet          (SR-Series)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_MARK_CONF
        Public iBackSideReading As Integer                          '// Use of Back Sensor Unit
        Public iColumns As Integer                                  '// Number of columns
        Public iReadingMethod As Integer                            '// Reading method
        Public iCtrlMultiple As Integer                             '// Control multiple value
        Public iThicknessType As Integer                            '// Sheet paper weight (thickness)
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device Configuration for Image              (SR-3500HYBRID)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_SR3500IMG_CONF
        Public iScanningSide As Integer                             '// Scaning side
        Public iScanCtrlType As Integer                             '// (reserved)
        Public iFormLengthMin As Integer                            '// (reserved)
        Public iFormLengthMax As Integer                            '// (reserved)
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_FACE_NUM)> _
        Public iLightColor() As Integer                             '// LightColor
        Public iResoType As Integer                                 '// Resolution
        Public iResoTypeY As Integer                                '// (reserved)
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Device Configuration for Image Ex            (SR-8000HYBRID)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_IMAGE_CONF_EX
        Dim iSize As Integer                                '
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_FACE_NUM)> _
        Dim Face() As SK_DV_IMAGE_CONF_EX_FACE                      '// Face
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_IMAGE_CONF_EX_FACE
        Dim iEnable As Integer                                          '// Scan Image On/Off
        Dim iColorType As Integer                                       '// Color type
        Dim iEncoder As Integer                                         '// Encoder
        Dim iParam As Integer                                           '// Encoder parameter
        Dim iRotate As Integer                                          '// Rotate
        Dim iResoMode As Integer                                        '// Resolution Mode
        Dim iResolution As Integer                                      '// Resolution
    End Structure


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Status code character                       (SR-Series)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_DEVICE_STATUS_CHAR
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_ST_LEN)> _
        Public ST1() As Byte                                        '// Status of front side
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_ST_LEN)> _
        Public ST2() As Byte                                        '// Status of back side
        Dim DIF1 As Byte
        Dim DIF2 As Byte
    End Structure


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Mark data infomation                        (SR-Series)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_MARK_INFO
        Dim iType As Integer                                        '// Data type(16 levels)
        Dim iRows As Integer                                        '// Number of rows
        Dim iColumns As Integer                                     '// Number of columns
    End Structure


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Printer Configuration                        (SR-Series option)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_OPT_PRN_CONF
        Dim iEnable As Integer                                      '// Enable printer
        Dim iStartPos As Integer                                    '// Print starting position from the leading edge of the sheet[mm]
        Dim iOrientation As Integer                                 '// Print orientation
        Dim iFontSize As Integer                                    '// Font size
        Dim iFontSpace As Integer                                   '// Font space
        Dim iPrintMode As Integer                                   '// Print mode
    End Structure


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Barcode Reader Configuration                 (SR-Series option)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_OPT_BCR_CONF
        Dim iEnable As Integer                                      '// Enable BCR
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_BCR_READING_AREA_MAX)> _
        Dim iReadingArea() As Integer                               '// Reading area [mm]
        Dim dwEnableBcType As Integer                               '// Enable Barcode type
        Dim CheckDigit As SK_DV_OPT_BCR_CONF_CHECKDIGIT             '// Check Digit
        Dim Option_Renamed As SK_DV_OPT_BCR_CONF_OPTION             '// Option
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_OPT_BCR_CONF_CHECKDIGIT
        Dim iCode39 As Integer                                      '// CODE-39
        Dim iItf As Integer                                         '// ITF
        Dim iNw7 As Integer                                         '// NW-7
        Dim iReserved1 As Integer                                   '// (reserved)It must be set to 0
        Dim iReserved2 As Integer                                   '// (reserved)It must be set to 0
        Dim iReserved3 As Integer                                   '// (reserved)It must be set to 0
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_OPT_BCR_CONF_OPTION
        Dim iUpcA As Integer                                        '// UPC-A Number of output digits
        Dim iUpcE As Integer                                        '// UPC-E System code
        Dim iReserved1 As Integer                                   '// (reserved)It must be set to 0
        Dim iReserved2 As Integer                                   '// (reserved)It must be set to 0
        Dim iReserved3 As Integer                                   '// (reserved)It must be set to 0
        Dim iReserved4 As Integer                                   '// (reserved)It must be set to 0
    End Structure


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Barcode Reader Area Configuration            (SR-8000HYBRID option)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_OPT_BCR_AREA
        Dim rectFrect As RECT                                       '// Area[0.1mm]
        Dim dwEnableBcType As Integer                               '// Enable Barcode type
        Dim iCheckDigit As Integer                                  '// CheckDigit
        Dim iOption As Integer                                      '// Option
    End Structure


    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Barcode Reader Configuration                 (SR-8000HYBRID option)
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_OPT_BCR_CONF_EX
        Dim iScanningSide As Integer                                '// Scaning side
        Dim iColorType As Integer                                   '// Color type
        Dim iAreaNumber As Integer                                  '// Number of areas to scan
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=SKDV_BCR_AREA_MAX)> _
        Dim Area() As SK_DV_OPT_BCR_AREA                            '// Area and configuration
    End Structure





    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Image data Configuration
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_IMAGE_DATA_CONF
        Dim iFace As Integer                                        '// Face
        Dim rectCutout As RECT                                      '// Cutout area
        Dim iColorType As Integer                                   '// Color type
        Dim iRotate As Integer                                      '// Rotate
        Dim iResolution As Integer                                  '// Resolution
        Dim iOption As Integer                                      '// (reserved)
    End Structure

    '//-----+-------+-------+-------+-------+-------+-------+-------+
    '// Image file Configuration
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SK_DV_IMAGE_FILE_CONF
        Dim iEncoder As Integer                                     '// Encoder
        Dim iParam As Integer                                       '// Encoder parameter
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SIZE
        Dim cx As Integer
        Dim cy As Integer
    End Structure
End Module